/*!-----------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Version: 0.47.0-dev-20240304(21007360cad28648bdf46282a2592cb47c3a7a6f)
 * Released under the MIT license
 * https://github.com/microsoft/vscode/blob/main/LICENSE.txt
 *-----------------------------------------------------------*/(function(){var Z=["require","exports","vs/editor/common/core/range","vs/editor/common/core/offsetRange","vs/editor/common/core/position","vs/base/common/errors","vs/base/common/strings","vs/base/common/arrays","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/diffAlgorithm","vs/base/common/event","vs/editor/common/core/lineRange","vs/base/common/arraysFind","vs/base/common/assert","vs/base/common/lifecycle","vs/base/common/objects","vs/editor/common/diff/defaultLinesDiffComputer/utils","vs/editor/common/diff/rangeMapping","vs/base/common/platform","vs/base/common/uri","vs/nls","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/codiconsUtil","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/myersDiffAlgorithm","vs/editor/common/diff/defaultLinesDiffComputer/linesSliceCharSequence","vs/editor/common/diff/linesDiffComputer","vs/base/common/cache","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/map","vs/base/common/cancellation","vs/base/common/hash","vs/base/common/codiconsLibrary","vs/base/common/codicons","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/defaultLinesDiffComputer/heuristicSequenceOptimizations","vs/editor/common/diff/defaultLinesDiffComputer/lineSequence","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/defaultLinesDiffComputer/computeMovedLines","vs/editor/common/diff/defaultLinesDiffComputer/defaultLinesDiffComputer","vs/editor/common/diff/legacyLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/platform","vs/nls!vs/base/common/worker/simpleWorker","vs/base/common/process","vs/base/common/path","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],K=function(q){for(var t=[],r=0,M=q.length;r<M;r++)t[r]=Z[q[r]];return t};const Ae=this,Re=typeof global=="object"?global:{};var he;(function(q){q.global=Ae;class t{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=t._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof q.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}q.Environment=t})(he||(he={}));var he;(function(q){class t{constructor(d,v,L){this.type=d,this.detail=v,this.timestamp=L}}q.LoaderEvent=t;class r{constructor(d){this._events=[new t(1,"",d)]}record(d,v){this._events.push(new t(d,v,q.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}q.LoaderEventRecorder=r;class M{record(d,v){}getEvents(){return[]}}M.INSTANCE=new M,q.NullLoaderEventRecorder=M})(he||(he={}));var he;(function(q){class t{static fileUriToFilePath(M,R){if(R=decodeURI(R).replace(/%23/g,"#"),M){if(/^file:\/\/\//.test(R))return R.substr(8);if(/^file:\/\//.test(R))return R.substr(5)}else if(/^file:\/\//.test(R))return R.substr(7);return R}static startsWith(M,R){return M.length>=R.length&&M.substr(0,R.length)===R}static endsWith(M,R){return M.length>=R.length&&M.substr(M.length-R.length)===R}static containsQueryString(M){return/^[^\#]*\?/gi.test(M)}static isAbsolutePath(M){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(M)}static forEachProperty(M,R){if(M){let d;for(d in M)M.hasOwnProperty(d)&&R(d,M[d])}}static isEmpty(M){let R=!0;return t.forEachProperty(M,()=>{R=!1}),R}static recursiveClone(M){if(!M||typeof M!="object"||M instanceof RegExp||!Array.isArray(M)&&Object.getPrototypeOf(M)!==Object.prototype)return M;let R=Array.isArray(M)?[]:{};return t.forEachProperty(M,(d,v)=>{v&&typeof v=="object"?R[d]=t.recursiveClone(v):R[d]=v}),R}static generateAnonymousModule(){return"===anonymous"+t.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(M){return t.startsWith(M,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=q.global.performance&&typeof q.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?q.global.performance.now():Date.now()}}t.NEXT_ANONYMOUS_ID=1,t.PERFORMANCE_NOW_PROBED=!1,t.HAS_PERFORMANCE_NOW=!1,q.Utilities=t})(he||(he={}));var he;(function(q){function t(R){if(R instanceof Error)return R;const d=new Error(R.message||String(R)||"Unknown Error");return R.stack&&(d.stack=R.stack),d}q.ensureError=t;class r{static validateConfigurationOptions(d){function v(L){if(L.phase==="loading"){console.error('Loading "'+L.moduleId+'" failed'),console.error(L),console.error("Here are the modules that depend on it:"),console.error(L.neededBy);return}if(L.phase==="factory"){console.error('The factory function of "'+L.moduleId+'" has thrown an exception'),console.error(L),console.error("Here are the modules that depend on it:"),console.error(L.neededBy);return}}if(d=d||{},typeof d.baseUrl!="string"&&(d.baseUrl=""),typeof d.isBuild!="boolean"&&(d.isBuild=!1),typeof d.paths!="object"&&(d.paths={}),typeof d.config!="object"&&(d.config={}),typeof d.catchError>"u"&&(d.catchError=!1),typeof d.recordStats>"u"&&(d.recordStats=!1),typeof d.urlArgs!="string"&&(d.urlArgs=""),typeof d.onError!="function"&&(d.onError=v),Array.isArray(d.ignoreDuplicateModules)||(d.ignoreDuplicateModules=[]),d.baseUrl.length>0&&(q.Utilities.endsWith(d.baseUrl,"/")||(d.baseUrl+="/")),typeof d.cspNonce!="string"&&(d.cspNonce=""),typeof d.preferScriptTags>"u"&&(d.preferScriptTags=!1),d.nodeCachedData&&typeof d.nodeCachedData=="object"&&(typeof d.nodeCachedData.seed!="string"&&(d.nodeCachedData.seed="seed"),(typeof d.nodeCachedData.writeDelay!="number"||d.nodeCachedData.writeDelay<0)&&(d.nodeCachedData.writeDelay=1e3*7),!d.nodeCachedData.path||typeof d.nodeCachedData.path!="string")){const L=t(new Error("INVALID cached data configuration, 'path' MUST be set"));L.phase="configuration",d.onError(L),d.nodeCachedData=void 0}return d}static mergeConfigurationOptions(d=null,v=null){let L=q.Utilities.recursiveClone(v||{});return q.Utilities.forEachProperty(d,(h,l)=>{h==="ignoreDuplicateModules"&&typeof L.ignoreDuplicateModules<"u"?L.ignoreDuplicateModules=L.ignoreDuplicateModules.concat(l):h==="paths"&&typeof L.paths<"u"?q.Utilities.forEachProperty(l,(w,e)=>L.paths[w]=e):h==="config"&&typeof L.config<"u"?q.Utilities.forEachProperty(l,(w,e)=>L.config[w]=e):L[h]=q.Utilities.recursiveClone(l)}),r.validateConfigurationOptions(L)}}q.ConfigurationOptionsUtil=r;class M{constructor(d,v){if(this._env=d,this.options=r.mergeConfigurationOptions(v),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let L=this.options.nodeRequire.main.filename,h=Math.max(L.lastIndexOf("/"),L.lastIndexOf("\\"));this.options.baseUrl=L.substring(0,h+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let d=0;d<this.options.ignoreDuplicateModules.length;d++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[d]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],q.Utilities.forEachProperty(this.options.paths,(d,v)=>{Array.isArray(v)?this.sortedPathsRules.push({from:d,to:v}):this.sortedPathsRules.push({from:d,to:[v]})}),this.sortedPathsRules.sort((d,v)=>v.from.length-d.from.length)}cloneAndMerge(d){return new M(this._env,r.mergeConfigurationOptions(d,this.options))}getOptionsLiteral(){return this.options}_applyPaths(d){let v;for(let L=0,h=this.sortedPathsRules.length;L<h;L++)if(v=this.sortedPathsRules[L],q.Utilities.startsWith(d,v.from)){let l=[];for(let w=0,e=v.to.length;w<e;w++)l.push(v.to[w]+d.substr(v.from.length));return l}return[d]}_addUrlArgsToUrl(d){return q.Utilities.containsQueryString(d)?d+"&"+this.options.urlArgs:d+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(d){return this.options.urlArgs?this._addUrlArgsToUrl(d):d}_addUrlArgsIfNecessaryToUrls(d){if(this.options.urlArgs)for(let v=0,L=d.length;v<L;v++)d[v]=this._addUrlArgsToUrl(d[v]);return d}moduleIdToPaths(d){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(d))return this.isBuild()?["empty:"]:["node|"+d];let v=d,L;if(!q.Utilities.endsWith(v,".js")&&!q.Utilities.isAbsolutePath(v)){L=this._applyPaths(v);for(let h=0,l=L.length;h<l;h++)this.isBuild()&&L[h]==="empty:"||(q.Utilities.isAbsolutePath(L[h])||(L[h]=this.options.baseUrl+L[h]),!q.Utilities.endsWith(L[h],".js")&&!q.Utilities.containsQueryString(L[h])&&(L[h]=L[h]+".js"))}else!q.Utilities.endsWith(v,".js")&&!q.Utilities.containsQueryString(v)&&(v=v+".js"),L=[v];return this._addUrlArgsIfNecessaryToUrls(L)}requireToUrl(d){let v=d;return q.Utilities.isAbsolutePath(v)||(v=this._applyPaths(v)[0],q.Utilities.isAbsolutePath(v)||(v=this.options.baseUrl+v)),this._addUrlArgsIfNecessaryToUrl(v)}isBuild(){return this.options.isBuild}shouldInvokeFactory(d){return!!(!this.options.isBuild||q.Utilities.isAnonymousModule(d)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[d])}isDuplicateMessageIgnoredFor(d){return this.ignoreDuplicateModulesMap.hasOwnProperty(d)}getConfigForModule(d){if(this.options.config)return this.options.config[d]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(d){this.options.onError(d)}}q.Configuration=M})(he||(he={}));var he;(function(q){class t{constructor(l){this._env=l,this._scriptLoader=null,this._callbackMap={}}load(l,w,e,s){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new R;else if(this._env.isElectronRenderer){const{preferScriptTags:u}=l.getConfig().getOptionsLiteral();u?this._scriptLoader=new r:this._scriptLoader=new d(this._env)}else this._env.isNode?this._scriptLoader=new d(this._env):this._scriptLoader=new r;let o={callback:e,errorback:s};if(this._callbackMap.hasOwnProperty(w)){this._callbackMap[w].push(o);return}this._callbackMap[w]=[o],this._scriptLoader.load(l,w,()=>this.triggerCallback(w),u=>this.triggerErrorback(w,u))}triggerCallback(l){let w=this._callbackMap[l];delete this._callbackMap[l];for(let e=0;e<w.length;e++)w[e].callback()}triggerErrorback(l,w){let e=this._callbackMap[l];delete this._callbackMap[l];for(let s=0;s<e.length;s++)e[s].errorback(w)}}class r{attachListeners(l,w,e){let s=()=>{l.removeEventListener("load",o),l.removeEventListener("error",u)},o=m=>{s(),w()},u=m=>{s(),e(m)};l.addEventListener("load",o),l.addEventListener("error",u)}load(l,w,e,s){if(/^node\|/.test(w)){let o=l.getConfig().getOptionsLiteral(),u=v(l.getRecorder(),o.nodeRequire||q.global.nodeRequire),m=w.split("|"),c=null;try{c=u(m[1])}catch(y){s(y);return}l.enqueueDefineAnonymousModule([],()=>c),e()}else{let o=document.createElement("script");o.setAttribute("async","async"),o.setAttribute("type","text/javascript"),this.attachListeners(o,e,s);const{trustedTypesPolicy:u}=l.getConfig().getOptionsLiteral();u&&(w=u.createScriptURL(w)),o.setAttribute("src",w);const{cspNonce:m}=l.getConfig().getOptionsLiteral();m&&o.setAttribute("nonce",m),document.getElementsByTagName("head")[0].appendChild(o)}}}function M(h){const{trustedTypesPolicy:l}=h.getConfig().getOptionsLiteral();try{return(l?self.eval(l.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class R{constructor(){this._cachedCanUseEval=null}_canUseEval(l){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=M(l)),this._cachedCanUseEval}load(l,w,e,s){if(/^node\|/.test(w)){const o=l.getConfig().getOptionsLiteral(),u=v(l.getRecorder(),o.nodeRequire||q.global.nodeRequire),m=w.split("|");let c=null;try{c=u(m[1])}catch(y){s(y);return}l.enqueueDefineAnonymousModule([],function(){return c}),e()}else{const{trustedTypesPolicy:o}=l.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(w)&&w.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(l)){fetch(w).then(m=>{if(m.status!==200)throw new Error(m.statusText);return m.text()}).then(m=>{m=`${m}
//# sourceURL=${w}`,(o?self.eval(o.createScript("",m)):new Function(m)).call(self),e()}).then(void 0,s);return}try{o&&(w=o.createScriptURL(w)),importScripts(w),e()}catch(m){s(m)}}}}class d{constructor(l){this._env=l,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(l){this._didInitialize||(this._didInitialize=!0,this._fs=l("fs"),this._vm=l("vm"),this._path=l("path"),this._crypto=l("crypto"))}_initNodeRequire(l,w){const{nodeCachedData:e}=w.getConfig().getOptionsLiteral();if(!e||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const s=this,o=l("module");function u(m){const c=m.constructor;let y=function(E){try{return m.require(E)}finally{}};return y.resolve=function(E,S){return c._resolveFilename(E,m,!1,S)},y.resolve.paths=function(E){return c._resolveLookupPaths(E,m)},y.main=process.mainModule,y.extensions=c._extensions,y.cache=c._cache,y}o.prototype._compile=function(m,c){const y=o.wrap(m.replace(/^#!.*/,"")),C=w.getRecorder(),E=s._getCachedDataPath(e,c),S={filename:c};let _;try{const N=s._fs.readFileSync(E);_=N.slice(0,16),S.cachedData=N.slice(16),C.record(60,E)}catch{C.record(61,E)}const i=new s._vm.Script(y,S),a=i.runInThisContext(S),g=s._path.dirname(c),b=u(this),f=[this.exports,b,this,c,g,process,Re,Buffer],p=a.apply(this.exports,f);return s._handleCachedData(i,y,E,!S.cachedData,w),s._verifyCachedData(i,y,E,_,w),p}}load(l,w,e,s){const o=l.getConfig().getOptionsLiteral(),u=v(l.getRecorder(),o.nodeRequire||q.global.nodeRequire),m=o.nodeInstrumenter||function(y){return y};this._init(u),this._initNodeRequire(u,l);let c=l.getRecorder();if(/^node\|/.test(w)){let y=w.split("|"),C=null;try{C=u(y[1])}catch(E){s(E);return}l.enqueueDefineAnonymousModule([],()=>C),e()}else{w=q.Utilities.fileUriToFilePath(this._env.isWindows,w);const y=this._path.normalize(w),C=this._getElectronRendererScriptPathOrUri(y),E=!!o.nodeCachedData,S=E?this._getCachedDataPath(o.nodeCachedData,w):void 0;this._readSourceAndCachedData(y,S,c,(_,i,a,g)=>{if(_){s(_);return}let b;i.charCodeAt(0)===d._BOM?b=d._PREFIX+i.substring(1)+d._SUFFIX:b=d._PREFIX+i+d._SUFFIX,b=m(b,y);const f={filename:C,cachedData:a},p=this._createAndEvalScript(l,b,f,e,s);this._handleCachedData(p,b,S,E&&!a,l),this._verifyCachedData(p,b,S,g,l)})}}_createAndEvalScript(l,w,e,s,o){const u=l.getRecorder();u.record(31,e.filename);const m=new this._vm.Script(w,e),c=m.runInThisContext(e),y=l.getGlobalAMDDefineFunc();let C=!1;const E=function(){return C=!0,y.apply(null,arguments)};return E.amd=y.amd,c.call(q.global,l.getGlobalAMDRequireFunc(),E,e.filename,this._path.dirname(e.filename)),u.record(32,e.filename),C?s():o(new Error(`Didn't receive define call in ${e.filename}!`)),m}_getElectronRendererScriptPathOrUri(l){if(!this._env.isElectronRenderer)return l;let w=l.match(/^([a-z])\:(.*)/i);return w?`file:///${(w[1].toUpperCase()+":"+w[2]).replace(/\\/g,"/")}`:`file://${l}`}_getCachedDataPath(l,w){const e=this._crypto.createHash("md5").update(w,"utf8").update(l.seed,"utf8").update(process.arch,"").digest("hex"),s=this._path.basename(w).replace(/\.js$/,"");return this._path.join(l.path,`${s}-${e}.code`)}_handleCachedData(l,w,e,s,o){l.cachedDataRejected?this._fs.unlink(e,u=>{o.getRecorder().record(62,e),this._createAndWriteCachedData(l,w,e,o),u&&o.getConfig().onError(u)}):s&&this._createAndWriteCachedData(l,w,e,o)}_createAndWriteCachedData(l,w,e,s){let o=Math.ceil(s.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),u=-1,m=0,c;const y=()=>{setTimeout(()=>{c||(c=this._crypto.createHash("md5").update(w,"utf8").digest());const C=l.createCachedData();if(!(C.length===0||C.length===u||m>=5)){if(C.length<u){y();return}u=C.length,this._fs.writeFile(e,Buffer.concat([c,C]),E=>{E&&s.getConfig().onError(E),s.getRecorder().record(63,e),y()})}},o*Math.pow(4,m++))};y()}_readSourceAndCachedData(l,w,e,s){if(!w)this._fs.readFile(l,{encoding:"utf8"},s);else{let o,u,m,c=2;const y=C=>{C?s(C):--c===0&&s(void 0,o,u,m)};this._fs.readFile(l,{encoding:"utf8"},(C,E)=>{o=E,y(C)}),this._fs.readFile(w,(C,E)=>{!C&&E&&E.length>0?(m=E.slice(0,16),u=E.slice(16),e.record(60,w)):e.record(61,w),y()})}}_verifyCachedData(l,w,e,s,o){s&&(l.cachedDataRejected||setTimeout(()=>{const u=this._crypto.createHash("md5").update(w,"utf8").digest();s.equals(u)||(o.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${e}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(e,m=>{m&&o.getConfig().onError(m)}))},Math.ceil(5e3*(1+Math.random()))))}}d._BOM=65279,d._PREFIX="(function (require, define, __filename, __dirname) { ",d._SUFFIX=`
});`;function v(h,l){if(l.__$__isRecorded)return l;const w=function(s){h.record(33,s);try{return l(s)}finally{h.record(34,s)}};return w.__$__isRecorded=!0,w}q.ensureRecordedNodeRequire=v;function L(h){return new t(h)}q.createScriptLoader=L})(he||(he={}));var he;(function(q){class t{constructor(h){let l=h.lastIndexOf("/");l!==-1?this.fromModulePath=h.substr(0,l+1):this.fromModulePath=""}static _normalizeModuleId(h){let l=h,w;for(w=/\/\.\//;w.test(l);)l=l.replace(w,"/");for(l=l.replace(/^\.\//g,""),w=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;w.test(l);)l=l.replace(w,"/");return l=l.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),l}resolveModule(h){let l=h;return q.Utilities.isAbsolutePath(l)||(q.Utilities.startsWith(l,"./")||q.Utilities.startsWith(l,"../"))&&(l=t._normalizeModuleId(this.fromModulePath+l)),l}}t.ROOT=new t(""),q.ModuleIdResolver=t;class r{constructor(h,l,w,e,s,o){this.id=h,this.strId=l,this.dependencies=w,this._callback=e,this._errorback=s,this.moduleIdResolver=o,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(h,l){try{return{returnedValue:h.apply(q.global,l),producedError:null}}catch(w){return{returnedValue:null,producedError:w}}}static _invokeFactory(h,l,w,e){return h.shouldInvokeFactory(l)?h.shouldCatchError()?this._safeInvokeFunction(w,e):{returnedValue:w.apply(q.global,e),producedError:null}:{returnedValue:null,producedError:null}}complete(h,l,w,e){this._isComplete=!0;let s=null;if(this._callback)if(typeof this._callback=="function"){h.record(21,this.strId);let o=r._invokeFactory(l,this.strId,this._callback,w);s=o.producedError,h.record(22,this.strId),!s&&typeof o.returnedValue<"u"&&(!this.exportsPassedIn||q.Utilities.isEmpty(this.exports))&&(this.exports=o.returnedValue)}else this.exports=this._callback;if(s){let o=q.ensureError(s);o.phase="factory",o.moduleId=this.strId,o.neededBy=e(this.id),this.error=o,l.onError(o)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(h){return this._isComplete=!0,this.error=h,this._errorback?(this._errorback(h),!0):!1}isComplete(){return this._isComplete}}q.Module=r;class M{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(h){let l=this._strModuleIdToIntModuleId.get(h);return typeof l>"u"&&(l=this._nextId++,this._strModuleIdToIntModuleId.set(h,l),this._intModuleIdToStrModuleId[l]=h),l}getStrModuleId(h){return this._intModuleIdToStrModuleId[h]}}class R{constructor(h){this.id=h}}R.EXPORTS=new R(0),R.MODULE=new R(1),R.REQUIRE=new R(2),q.RegularDependency=R;class d{constructor(h,l,w){this.id=h,this.pluginId=l,this.pluginParam=w}}q.PluginDependency=d;class v{constructor(h,l,w,e,s=0){this._env=h,this._scriptLoader=l,this._loaderAvailableTimestamp=s,this._defineFunc=w,this._requireFunc=e,this._moduleIdProvider=new M,this._config=new q.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[],this._requireFunc.moduleManager=this}reset(){return new v(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(h,l){let w=o=>o.replace(/\\/g,"/"),e=w(h),s=l.split(/\n/);for(let o=0;o<s.length;o++){let u=s[o].match(/(.*):(\d+):(\d+)\)?$/);if(u){let m=u[1],c=u[2],y=u[3],C=Math.max(m.lastIndexOf(" ")+1,m.lastIndexOf("(")+1);if(m=m.substr(C),m=w(m),m===e){let E={line:parseInt(c,10),col:parseInt(y,10)};return E.line===1&&(E.col-=53),E}}}throw new Error("Could not correlate define call site for needle "+h)}getBuildInfo(){if(!this._config.isBuild())return null;let h=[],l=0;for(let w=0,e=this._modules2.length;w<e;w++){let s=this._modules2[w];if(!s)continue;let o=this._buildInfoPath[s.id]||null,u=this._buildInfoDefineStack[s.id]||null,m=this._buildInfoDependencies[s.id];h[l++]={id:s.strId,path:o,defineLocation:o&&u?v._findRelevantLocationInStack(o,u):null,dependencies:m,shim:null,exports:s.exports}}return h}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new q.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=q.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(h,l){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let w=null;this._config.isBuild()&&(w=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:w,dependencies:h,callback:l}}defineModule(h,l,w,e,s,o=new t(h)){let u=this._moduleIdProvider.getModuleId(h);if(this._modules2[u]){this._config.isDuplicateMessageIgnoredFor(h)||console.warn("Duplicate definition of module '"+h+"'");return}let m=new r(u,h,this._normalizeDependencies(l,o),w,e,o);this._modules2[u]=m,this._config.isBuild()&&(this._buildInfoDefineStack[u]=s,this._buildInfoDependencies[u]=(m.dependencies||[]).map(c=>this._moduleIdProvider.getStrModuleId(c.id))),this._resolve(m)}_normalizeDependency(h,l){if(h==="exports")return R.EXPORTS;if(h==="module")return R.MODULE;if(h==="require")return R.REQUIRE;let w=h.indexOf("!");if(w>=0){let e=l.resolveModule(h.substr(0,w)),s=l.resolveModule(h.substr(w+1)),o=this._moduleIdProvider.getModuleId(e+"!"+s),u=this._moduleIdProvider.getModuleId(e);return new d(o,u,s)}return new R(this._moduleIdProvider.getModuleId(l.resolveModule(h)))}_normalizeDependencies(h,l){let w=[],e=0;for(let s=0,o=h.length;s<o;s++)w[e++]=this._normalizeDependency(h[s],l);return w}_relativeRequire(h,l,w,e){if(typeof l=="string")return this.synchronousRequire(l,h);this.defineModule(q.Utilities.generateAnonymousModule(),l,w,e,null,h)}synchronousRequire(h,l=new t(h)){let w=this._normalizeDependency(h,l),e=this._modules2[w.id];if(!e)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+h+"'. This is the first mention of this module!");if(!e.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+h+"'. This module has not been resolved completely yet.");if(e.error)throw e.error;return e.exports}configure(h,l){let w=this._config.shouldRecordStats();l?this._config=new q.Configuration(this._env,h):this._config=this._config.cloneAndMerge(h),this._config.shouldRecordStats()&&!w&&(this._recorder=null)}getConfig(){return this._config}_onLoad(h){if(this._currentAnonymousDefineCall!==null){let l=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(h),l.dependencies,l.callback,null,l.stack)}}_createLoadError(h,l){let w=this._moduleIdProvider.getStrModuleId(h),e=(this._inverseDependencies2[h]||[]).map(o=>this._moduleIdProvider.getStrModuleId(o));const s=q.ensureError(l);return s.phase="loading",s.moduleId=w,s.neededBy=e,s}_onLoadError(h,l){const w=this._createLoadError(h,l);this._modules2[h]||(this._modules2[h]=new r(h,this._moduleIdProvider.getStrModuleId(h),[],()=>{},null,null));let e=[];for(let u=0,m=this._moduleIdProvider.getMaxModuleId();u<m;u++)e[u]=!1;let s=!1,o=[];for(o.push(h),e[h]=!0;o.length>0;){let u=o.shift(),m=this._modules2[u];m&&(s=m.onDependencyError(w)||s);let c=this._inverseDependencies2[u];if(c)for(let y=0,C=c.length;y<C;y++){let E=c[y];e[E]||(o.push(E),e[E]=!0)}}s||this._config.onError(w)}_hasDependencyPath(h,l){let w=this._modules2[h];if(!w)return!1;let e=[];for(let o=0,u=this._moduleIdProvider.getMaxModuleId();o<u;o++)e[o]=!1;let s=[];for(s.push(w),e[h]=!0;s.length>0;){let u=s.shift().dependencies;if(u)for(let m=0,c=u.length;m<c;m++){let y=u[m];if(y.id===l)return!0;let C=this._modules2[y.id];C&&!e[y.id]&&(e[y.id]=!0,s.push(C))}}return!1}_findCyclePath(h,l,w){if(h===l||w===50)return[h];let e=this._modules2[h];if(!e)return null;let s=e.dependencies;if(s)for(let o=0,u=s.length;o<u;o++){let m=this._findCyclePath(s[o].id,l,w+1);if(m!==null)return m.push(h),m}return null}_createRequire(h){let l=(w,e,s)=>this._relativeRequire(h,w,e,s);return l.toUrl=w=>this._config.requireToUrl(h.resolveModule(w)),l.getStats=()=>this.getLoaderEvents(),l.hasDependencyCycle=()=>this._hasDependencyCycle,l.config=(w,e=!1)=>{this.configure(w,e)},l.__$__nodeRequire=q.global.nodeRequire,l}_loadModule(h){if(this._modules2[h]||this._knownModules2[h])return;this._knownModules2[h]=!0;let l=this._moduleIdProvider.getStrModuleId(h),w=this._config.moduleIdToPaths(l),e=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(l.indexOf("/")===-1||e.test(l))&&w.push("node|"+l);let s=-1,o=u=>{if(s++,s>=w.length)this._onLoadError(h,u);else{let m=w[s],c=this.getRecorder();if(this._config.isBuild()&&m==="empty:"){this._buildInfoPath[h]=m,this.defineModule(this._moduleIdProvider.getStrModuleId(h),[],null,null,null),this._onLoad(h);return}c.record(10,m),this._scriptLoader.load(this,m,()=>{this._config.isBuild()&&(this._buildInfoPath[h]=m),c.record(11,m),this._onLoad(h)},y=>{c.record(12,m),o(y)})}};o(null)}_loadPluginDependency(h,l){if(this._modules2[l.id]||this._knownModules2[l.id])return;this._knownModules2[l.id]=!0;let w=e=>{this.defineModule(this._moduleIdProvider.getStrModuleId(l.id),[],e,null,null)};w.error=e=>{this._config.onError(this._createLoadError(l.id,e))},h.load(l.pluginParam,this._createRequire(t.ROOT),w,this._config.getOptionsLiteral())}_resolve(h){let l=h.dependencies;if(l)for(let w=0,e=l.length;w<e;w++){let s=l[w];if(s===R.EXPORTS){h.exportsPassedIn=!0,h.unresolvedDependenciesCount--;continue}if(s===R.MODULE){h.unresolvedDependenciesCount--;continue}if(s===R.REQUIRE){h.unresolvedDependenciesCount--;continue}let o=this._modules2[s.id];if(o&&o.isComplete()){if(o.error){h.onDependencyError(o.error);return}h.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(s.id,h.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(s.id)+"' and '"+this._moduleIdProvider.getStrModuleId(h.id)+"'. The cyclic path follows:");let u=this._findCyclePath(s.id,h.id,0)||[];u.reverse(),u.push(s.id),console.warn(u.map(m=>this._moduleIdProvider.getStrModuleId(m)).join(` => 
`)),h.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[s.id]=this._inverseDependencies2[s.id]||[],this._inverseDependencies2[s.id].push(h.id),s instanceof d){let u=this._modules2[s.pluginId];if(u&&u.isComplete()){this._loadPluginDependency(u.exports,s);continue}let m=this._inversePluginDependencies2.get(s.pluginId);m||(m=[],this._inversePluginDependencies2.set(s.pluginId,m)),m.push(s),this._loadModule(s.pluginId);continue}this._loadModule(s.id)}h.unresolvedDependenciesCount===0&&this._onModuleComplete(h)}_onModuleComplete(h){let l=this.getRecorder();if(h.isComplete())return;let w=h.dependencies,e=[];if(w)for(let m=0,c=w.length;m<c;m++){let y=w[m];if(y===R.EXPORTS){e[m]=h.exports;continue}if(y===R.MODULE){e[m]={id:h.strId,config:()=>this._config.getConfigForModule(h.strId)};continue}if(y===R.REQUIRE){e[m]=this._createRequire(h.moduleIdResolver);continue}let C=this._modules2[y.id];if(C){e[m]=C.exports;continue}e[m]=null}const s=m=>(this._inverseDependencies2[m]||[]).map(c=>this._moduleIdProvider.getStrModuleId(c));h.complete(l,this._config,e,s);let o=this._inverseDependencies2[h.id];if(this._inverseDependencies2[h.id]=null,o)for(let m=0,c=o.length;m<c;m++){let y=o[m],C=this._modules2[y];C.unresolvedDependenciesCount--,C.unresolvedDependenciesCount===0&&this._onModuleComplete(C)}let u=this._inversePluginDependencies2.get(h.id);if(u){this._inversePluginDependencies2.delete(h.id);for(let m=0,c=u.length;m<c;m++)this._loadPluginDependency(h.exports,u[m])}}}q.ModuleManager=v})(he||(he={}));var X,he;(function(q){const t=new q.Environment;let r=null;const M=function(L,h,l){typeof L!="string"&&(l=h,h=L,L=null),(typeof h!="object"||!Array.isArray(h))&&(l=h,h=null),h||(h=["require","exports","module"]),L?r.defineModule(L,h,l,null,null):r.enqueueDefineAnonymousModule(h,l)};M.amd={jQuery:!0};const R=function(L,h=!1){r.configure(L,h)},d=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){R(arguments[0]);return}if(typeof arguments[0]=="string")return r.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){r.defineModule(q.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};d.config=R,d.getConfig=function(){return r.getConfig().getOptionsLiteral()},d.reset=function(){r=r.reset()},d.getBuildInfo=function(){return r.getBuildInfo()},d.getStats=function(){return r.getLoaderEvents()},d.define=M;function v(){if(typeof q.global.require<"u"||typeof require<"u"){const L=q.global.require||require;if(typeof L=="function"&&typeof L.resolve=="function"){const h=q.ensureRecordedNodeRequire(r.getRecorder(),L);q.global.nodeRequire=h,d.nodeRequire=h,d.__$__nodeRequire=h}}t.isNode&&!t.isElectronRenderer&&!t.isElectronNodeIntegrationWebWorker?module.exports=d:(t.isElectronRenderer||(q.global.define=M),q.global.require=d)}q.init=v,(typeof q.global.define!="function"||!q.global.define.amd)&&(r=new q.ModuleManager(t,q.createScriptLoader(t),M,d,q.Utilities.getHighPerformanceTimestamp()),typeof q.global.require<"u"&&typeof q.global.require!="function"&&d.config(q.global.require),X=function(){return M.apply(null,arguments)},X.amd=M.amd,typeof doNotInitLoader>"u"&&v())})(he||(he={})),X(Z[19],K([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=t.create=t.setPseudoTranslation=t.getConfiguredDefaultLocale=t.localize2=t.localize=void 0;let r=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const M="i-default";function R(c,y){let C;return y.length===0?C=c:C=c.replace(/\{(\d+)\}/g,(E,S)=>{const _=S[0],i=y[_];let a=E;return typeof i=="string"?a=i:(typeof i=="number"||typeof i=="boolean"||i===void 0||i===null)&&(a=String(i)),a}),r&&(C="\uFF3B"+C.replace(/[aouei]/g,"$&$&")+"\uFF3D"),C}function d(c,y){let C=c[y];return C||(C=c["*"],C)?C:null}function v(c){return c.charAt(c.length-1)==="/"?c:c+"/"}async function L(c,y,C){const E=v(c)+v(y)+"vscode/"+v(C),S=await fetch(E);if(S.ok)return await S.json();throw new Error(`${S.status} - ${S.statusText}`)}function h(c){return function(y,C){const E=Array.prototype.slice.call(arguments,2);return R(c[y],E)}}function l(c){return(y,C,...E)=>({value:R(c[y],E),original:R(C,E)})}function w(c,y,...C){return R(y,C)}t.localize=w;function e(c,y,...C){const E=R(y,C);return{value:E,original:E}}t.localize2=e;function s(c){}t.getConfiguredDefaultLocale=s;function o(c){r=c}t.setPseudoTranslation=o;function u(c,y){var C;return{localize:h(y[c]),localize2:l(y[c]),getConfiguredDefaultLocale:(C=y.getConfiguredDefaultLocale)!==null&&C!==void 0?C:E=>{}}}t.create=u;function m(c,y,C,E){var S;const _=(S=E["vs/nls"])!==null&&S!==void 0?S:{};if(!c||c.length===0)return C({localize:w,localize2:e,getConfiguredDefaultLocale:()=>{var f;return(f=_.availableLanguages)===null||f===void 0?void 0:f["*"]}});const i=_.availableLanguages?d(_.availableLanguages,c):null,a=i===null||i===M;let g=".nls";a||(g=g+"."+i);const b=f=>{Array.isArray(f)?(f.localize=h(f),f.localize2=l(f)):(f.localize=h(f[c]),f.localize2=l(f[c])),f.getConfiguredDefaultLocale=()=>{var p;return(p=_.availableLanguages)===null||p===void 0?void 0:p["*"]},C(f)};typeof _.loadBundle=="function"?_.loadBundle(c,i,(f,p)=>{f?y([c+".nls"],b):b(p)}):_.translationServiceUrl&&!a?(async()=>{var f;try{const p=await L(_.translationServiceUrl,i,c);return b(p)}catch(p){if(!i.includes("-"))return console.error(p),y([c+".nls"],b);try{const N=i.split("-")[0],A=await L(_.translationServiceUrl,N,c);return(f=_.availableLanguages)!==null&&f!==void 0||(_.availableLanguages={}),_.availableLanguages["*"]=N,b(A)}catch(N){return console.error(N),y([c+".nls"],b)}}})():y([c+g],b,f=>{if(g===".nls"){console.error("Failed trying to load default language strings",f);return}console.error(`Failed to load message bundle for language ${i}. Falling back to the default language:`,f),y([c+".nls"],b)})}t.load=m}),function(){const q=globalThis.MonacoEnvironment,t=q&&q.baseUrl?q.baseUrl:"../../../";function r(w,e){var s;if(q?.createTrustedTypesPolicy)try{return q.createTrustedTypesPolicy(w,e)}catch(o){console.warn(o);return}try{return(s=self.trustedTypes)===null||s===void 0?void 0:s.createPolicy(w,e)}catch(o){console.warn(o);return}}const M=r("amdLoader",{createScriptURL:w=>w,createScript:(w,...e)=>{const s=e.slice(0,-1).join(","),o=e.pop().toString();return`(function anonymous(${s}) { ${o}
})`}});function R(){try{return(M?globalThis.eval(M.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function d(){return new Promise((w,e)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return w();const s=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(s)&&s.substring(0,globalThis.origin.length)!==globalThis.origin)&&R()){fetch(s).then(u=>{if(u.status!==200)throw new Error(u.statusText);return u.text()}).then(u=>{u=`${u}
//# sourceURL=${s}`,(M?globalThis.eval(M.createScript("",u)):new Function(u)).call(globalThis),w()}).then(void 0,e);return}M?importScripts(M.createScriptURL(s)):importScripts(s),w()})}function v(){require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:M,amdModulesPattern:/^vs\//})}function L(w){d().then(()=>{v(),require([w],function(e){setTimeout(function(){const s=e.create((o,u)=>{globalThis.postMessage(o,u)},null);for(globalThis.onmessage=o=>s.onmessage(o.data,o.ports);l.length>0;){const o=l.shift();s.onmessage(o.data,o.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&v();let h=!0;const l=[];globalThis.onmessage=w=>{if(!h){l.push(w);return}h=!1,L(w.data)}}(),X(Z[7],K([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CallbackIterable=t.ArrayQueue=t.reverseOrder=t.booleanComparator=t.numberComparator=t.tieBreakComparators=t.compareBy=t.CompareResult=t.splice=t.insertInto=t.asArray=t.pushMany=t.pushToEnd=t.pushToStart=t.arrayInsert=t.range=t.firstOrDefault=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.coalesceInPlace=t.coalesce=t.forEachWithNeighbors=t.forEachAdjacent=t.groupAdjacentBy=t.groupBy=t.quickSelect=t.binarySearch2=t.binarySearch=t.removeFastWithoutKeepingOrder=t.equals=t.tail2=t.tail=void 0;function r(x,O=0){return x[x.length-(1+O)]}t.tail=r;function M(x){if(x.length===0)throw new Error("Invalid tail call");return[x.slice(0,x.length-1),x[x.length-1]]}t.tail2=M;function R(x,O,F=(V,j)=>V===j){if(x===O)return!0;if(!x||!O||x.length!==O.length)return!1;for(let V=0,j=x.length;V<j;V++)if(!F(x[V],O[V]))return!1;return!0}t.equals=R;function d(x,O){const F=x.length-1;O<F&&(x[O]=x[F]),x.pop()}t.removeFastWithoutKeepingOrder=d;function v(x,O,F){return L(x.length,V=>F(x[V],O))}t.binarySearch=v;function L(x,O){let F=0,V=x-1;for(;F<=V;){const j=(F+V)/2|0,Q=O(j);if(Q<0)F=j+1;else if(Q>0)V=j-1;else return j}return-(F+1)}t.binarySearch2=L;function h(x,O,F){if(x=x|0,x>=O.length)throw new TypeError("invalid index");const V=O[Math.floor(O.length*Math.random())],j=[],Q=[],ne=[];for(const se of O){const n=F(se,V);n<0?j.push(se):n>0?Q.push(se):ne.push(se)}return x<j.length?h(x,j,F):x<j.length+ne.length?ne[0]:h(x-(j.length+ne.length),Q,F)}t.quickSelect=h;function l(x,O){const F=[];let V;for(const j of x.slice(0).sort(O))!V||O(V[0],j)!==0?(V=[j],F.push(V)):V.push(j);return F}t.groupBy=l;function*w(x,O){let F,V;for(const j of x)V!==void 0&&O(V,j)?F.push(j):(F&&(yield F),F=[j]),V=j;F&&(yield F)}t.groupAdjacentBy=w;function e(x,O){for(let F=0;F<=x.length;F++)O(F===0?void 0:x[F-1],F===x.length?void 0:x[F])}t.forEachAdjacent=e;function s(x,O){for(let F=0;F<x.length;F++)O(F===0?void 0:x[F-1],x[F],F+1===x.length?void 0:x[F+1])}t.forEachWithNeighbors=s;function o(x){return x.filter(O=>!!O)}t.coalesce=o;function u(x){let O=0;for(let F=0;F<x.length;F++)x[F]&&(x[O]=x[F],O+=1);x.length=O}t.coalesceInPlace=u;function m(x){return!Array.isArray(x)||x.length===0}t.isFalsyOrEmpty=m;function c(x){return Array.isArray(x)&&x.length>0}t.isNonEmptyArray=c;function y(x,O=F=>F){const F=new Set;return x.filter(V=>{const j=O(V);return F.has(j)?!1:(F.add(j),!0)})}t.distinct=y;function C(x,O){return x.length>0?x[0]:O}t.firstOrDefault=C;function E(x,O){let F=typeof O=="number"?x:0;typeof O=="number"?F=x:(F=0,O=x);const V=[];if(F<=O)for(let j=F;j<O;j++)V.push(j);else for(let j=F;j>O;j--)V.push(j);return V}t.range=E;function S(x,O,F){const V=x.slice(0,O),j=x.slice(O);return V.concat(F,j)}t.arrayInsert=S;function _(x,O){const F=x.indexOf(O);F>-1&&(x.splice(F,1),x.unshift(O))}t.pushToStart=_;function i(x,O){const F=x.indexOf(O);F>-1&&(x.splice(F,1),x.push(O))}t.pushToEnd=i;function a(x,O){for(const F of O)x.push(F)}t.pushMany=a;function g(x){return Array.isArray(x)?x:[x]}t.asArray=g;function b(x,O,F){const V=p(x,O),j=x.length,Q=F.length;x.length=j+Q;for(let ne=j-1;ne>=V;ne--)x[ne+Q]=x[ne];for(let ne=0;ne<Q;ne++)x[ne+V]=F[ne]}t.insertInto=b;function f(x,O,F,V){const j=p(x,O);let Q=x.splice(j,F);return Q===void 0&&(Q=[]),b(x,j,V),Q}t.splice=f;function p(x,O){return O<0?Math.max(O+x.length,0):Math.min(O,x.length)}var N;(function(x){function O(Q){return Q<0}x.isLessThan=O;function F(Q){return Q<=0}x.isLessThanOrEqual=F;function V(Q){return Q>0}x.isGreaterThan=V;function j(Q){return Q===0}x.isNeitherLessOrGreaterThan=j,x.greaterThan=1,x.lessThan=-1,x.neitherLessOrGreaterThan=0})(N||(t.CompareResult=N={}));function A(x,O){return(F,V)=>O(x(F),x(V))}t.compareBy=A;function D(...x){return(O,F)=>{for(const V of x){const j=V(O,F);if(!N.isNeitherLessOrGreaterThan(j))return j}return N.neitherLessOrGreaterThan}}t.tieBreakComparators=D;const P=(x,O)=>x-O;t.numberComparator=P;const T=(x,O)=>(0,t.numberComparator)(x?1:0,O?1:0);t.booleanComparator=T;function I(x){return(O,F)=>-x(O,F)}t.reverseOrder=I;class W{constructor(O){this.items=O,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(O){let F=this.firstIdx;for(;F<this.items.length&&O(this.items[F]);)F++;const V=F===this.firstIdx?null:this.items.slice(this.firstIdx,F);return this.firstIdx=F,V}takeFromEndWhile(O){let F=this.lastIdx;for(;F>=0&&O(this.items[F]);)F--;const V=F===this.lastIdx?null:this.items.slice(F+1,this.lastIdx+1);return this.lastIdx=F,V}peek(){if(this.length!==0)return this.items[this.firstIdx]}dequeue(){const O=this.items[this.firstIdx];return this.firstIdx++,O}takeCount(O){const F=this.items.slice(this.firstIdx,this.firstIdx+O);return this.firstIdx+=O,F}}t.ArrayQueue=W;class H{constructor(O){this.iterate=O}toArray(){const O=[];return this.iterate(F=>(O.push(F),!0)),O}filter(O){return new H(F=>this.iterate(V=>O(V)?F(V):!0))}map(O){return new H(F=>this.iterate(V=>F(O(V))))}findLast(O){let F;return this.iterate(V=>(O(V)&&(F=V),!0)),F}findLastMaxBy(O){let F,V=!0;return this.iterate(j=>((V||N.isGreaterThan(O(j,F)))&&(V=!1,F=j),!0)),F}}t.CallbackIterable=H,H.empty=new H(x=>{})}),X(Z[11],K([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.mapFindFirst=t.findMaxIdxBy=t.findFirstMinBy=t.findLastMaxBy=t.findFirstMaxBy=t.MonotonousArray=t.findFirstIdxMonotonousOrArrLen=t.findFirstMonotonous=t.findLastIdxMonotonous=t.findLastMonotonous=t.findLastIdx=t.findLast=void 0;function r(u,m,c){const y=M(u,m);if(y!==-1)return u[y]}t.findLast=r;function M(u,m,c=u.length-1){for(let y=c;y>=0;y--){const C=u[y];if(m(C))return y}return-1}t.findLastIdx=M;function R(u,m){const c=d(u,m);return c===-1?void 0:u[c]}t.findLastMonotonous=R;function d(u,m,c=0,y=u.length){let C=c,E=y;for(;C<E;){const S=Math.floor((C+E)/2);m(u[S])?C=S+1:E=S}return C-1}t.findLastIdxMonotonous=d;function v(u,m){const c=L(u,m);return c===u.length?void 0:u[c]}t.findFirstMonotonous=v;function L(u,m,c=0,y=u.length){let C=c,E=y;for(;C<E;){const S=Math.floor((C+E)/2);m(u[S])?E=S:C=S+1}return C}t.findFirstIdxMonotonousOrArrLen=L;class h{constructor(m){this._array=m,this._findLastMonotonousLastIdx=0}findLastMonotonous(m){if(h.assertInvariants){if(this._prevFindLastPredicate){for(const y of this._array)if(this._prevFindLastPredicate(y)&&!m(y))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=m}const c=d(this._array,m,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=c+1,c===-1?void 0:this._array[c]}}t.MonotonousArray=h,h.assertInvariants=!1;function l(u,m){if(u.length===0)return;let c=u[0];for(let y=1;y<u.length;y++){const C=u[y];m(C,c)>0&&(c=C)}return c}t.findFirstMaxBy=l;function w(u,m){if(u.length===0)return;let c=u[0];for(let y=1;y<u.length;y++){const C=u[y];m(C,c)>=0&&(c=C)}return c}t.findLastMaxBy=w;function e(u,m){return l(u,(c,y)=>-m(c,y))}t.findFirstMinBy=e;function s(u,m){if(u.length===0)return-1;let c=0;for(let y=1;y<u.length;y++){const C=u[y];m(C,u[c])>0&&(c=y)}return c}t.findMaxIdxBy=s;function o(u,m){for(const c of u){const y=m(c);if(y!==void 0)return y}}t.mapFindFirst=o}),X(Z[33],K([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedFunction=t.LRUCachedFunction=void 0;class r{constructor(d){this.fn=d,this.lastCache=void 0,this.lastArgKey=void 0}get(d){const v=JSON.stringify(d);return this.lastArgKey!==v&&(this.lastArgKey=v,this.lastCache=this.fn(d)),this.lastCache}}t.LRUCachedFunction=r;class M{get cachedValues(){return this._map}constructor(d){this.fn=d,this._map=new Map}get(d){if(this._map.has(d))return this._map.get(d);const v=this.fn(d);return this._map.set(d,v),v}}t.CachedFunction=M}),X(Z[34],K([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Color=t.HSVA=t.HSLA=t.RGBA=void 0;function r(L,h){const l=Math.pow(10,h);return Math.round(L*l)/l}class M{constructor(h,l,w,e=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,h))|0,this.g=Math.min(255,Math.max(0,l))|0,this.b=Math.min(255,Math.max(0,w))|0,this.a=r(Math.max(Math.min(1,e),0),3)}static equals(h,l){return h.r===l.r&&h.g===l.g&&h.b===l.b&&h.a===l.a}}t.RGBA=M;class R{constructor(h,l,w,e){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=r(Math.max(Math.min(1,l),0),3),this.l=r(Math.max(Math.min(1,w),0),3),this.a=r(Math.max(Math.min(1,e),0),3)}static equals(h,l){return h.h===l.h&&h.s===l.s&&h.l===l.l&&h.a===l.a}static fromRGBA(h){const l=h.r/255,w=h.g/255,e=h.b/255,s=h.a,o=Math.max(l,w,e),u=Math.min(l,w,e);let m=0,c=0;const y=(u+o)/2,C=o-u;if(C>0){switch(c=Math.min(y<=.5?C/(2*y):C/(2-2*y),1),o){case l:m=(w-e)/C+(w<e?6:0);break;case w:m=(e-l)/C+2;break;case e:m=(l-w)/C+4;break}m*=60,m=Math.round(m)}return new R(m,c,y,s)}static _hue2rgb(h,l,w){return w<0&&(w+=1),w>1&&(w-=1),w<1/6?h+(l-h)*6*w:w<1/2?l:w<2/3?h+(l-h)*(2/3-w)*6:h}static toRGBA(h){const l=h.h/360,{s:w,l:e,a:s}=h;let o,u,m;if(w===0)o=u=m=e;else{const c=e<.5?e*(1+w):e+w-e*w,y=2*e-c;o=R._hue2rgb(y,c,l+1/3),u=R._hue2rgb(y,c,l),m=R._hue2rgb(y,c,l-1/3)}return new M(Math.round(o*255),Math.round(u*255),Math.round(m*255),s)}}t.HSLA=R;class d{constructor(h,l,w,e){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=r(Math.max(Math.min(1,l),0),3),this.v=r(Math.max(Math.min(1,w),0),3),this.a=r(Math.max(Math.min(1,e),0),3)}static equals(h,l){return h.h===l.h&&h.s===l.s&&h.v===l.v&&h.a===l.a}static fromRGBA(h){const l=h.r/255,w=h.g/255,e=h.b/255,s=Math.max(l,w,e),o=Math.min(l,w,e),u=s-o,m=s===0?0:u/s;let c;return u===0?c=0:s===l?c=((w-e)/u%6+6)%6:s===w?c=(e-l)/u+2:c=(l-w)/u+4,new d(Math.round(c*60),m,s,h.a)}static toRGBA(h){const{h:l,s:w,v:e,a:s}=h,o=e*w,u=o*(1-Math.abs(l/60%2-1)),m=e-o;let[c,y,C]=[0,0,0];return l<60?(c=o,y=u):l<120?(c=u,y=o):l<180?(y=o,C=u):l<240?(y=u,C=o):l<300?(c=u,C=o):l<=360&&(c=o,C=u),c=Math.round((c+m)*255),y=Math.round((y+m)*255),C=Math.round((C+m)*255),new M(c,y,C,s)}}t.HSVA=d;class v{static fromHex(h){return v.Format.CSS.parseHex(h)||v.red}static equals(h,l){return!h&&!l?!0:!h||!l?!1:h.equals(l)}get hsla(){return this._hsla?this._hsla:R.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:d.fromRGBA(this.rgba)}constructor(h){if(h)if(h instanceof M)this.rgba=h;else if(h instanceof R)this._hsla=h,this.rgba=R.toRGBA(h);else if(h instanceof d)this._hsva=h,this.rgba=d.toRGBA(h);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(h){return!!h&&M.equals(this.rgba,h.rgba)&&R.equals(this.hsla,h.hsla)&&d.equals(this.hsva,h.hsva)}getRelativeLuminance(){const h=v._relativeLuminanceForComponent(this.rgba.r),l=v._relativeLuminanceForComponent(this.rgba.g),w=v._relativeLuminanceForComponent(this.rgba.b),e=.2126*h+.7152*l+.0722*w;return r(e,4)}static _relativeLuminanceForComponent(h){const l=h/255;return l<=.03928?l/12.92:Math.pow((l+.055)/1.055,2.4)}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(h){const l=this.getRelativeLuminance(),w=h.getRelativeLuminance();return l>w}isDarkerThan(h){const l=this.getRelativeLuminance(),w=h.getRelativeLuminance();return l<w}lighten(h){return new v(new R(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*h,this.hsla.a))}darken(h){return new v(new R(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*h,this.hsla.a))}transparent(h){const{r:l,g:w,b:e,a:s}=this.rgba;return new v(new M(l,w,e,s*h))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new v(new M(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}makeOpaque(h){if(this.isOpaque()||h.rgba.a!==1)return this;const{r:l,g:w,b:e,a:s}=this.rgba;return new v(new M(h.rgba.r-s*(h.rgba.r-l),h.rgba.g-s*(h.rgba.g-w),h.rgba.b-s*(h.rgba.b-e),1))}toString(){return this._toString||(this._toString=v.Format.CSS.format(this)),this._toString}static getLighterColor(h,l,w){if(h.isLighterThan(l))return h;w=w||.5;const e=h.getRelativeLuminance(),s=l.getRelativeLuminance();return w=w*(s-e)/s,h.lighten(w)}static getDarkerColor(h,l,w){if(h.isDarkerThan(l))return h;w=w||.5;const e=h.getRelativeLuminance(),s=l.getRelativeLuminance();return w=w*(e-s)/e,h.darken(w)}}t.Color=v,v.white=new v(new M(255,255,255,1)),v.black=new v(new M(0,0,0,1)),v.red=new v(new M(255,0,0,1)),v.blue=new v(new M(0,0,255,1)),v.green=new v(new M(0,255,0,1)),v.cyan=new v(new M(0,255,255,1)),v.lightgrey=new v(new M(211,211,211,1)),v.transparent=new v(new M(0,0,0,0)),function(L){let h;(function(l){let w;(function(e){function s(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:L.Format.CSS.formatRGBA(i)}e.formatRGB=s;function o(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}e.formatRGBA=o;function u(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:L.Format.CSS.formatHSLA(i)}e.formatHSL=u;function m(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}e.formatHSLA=m;function c(i){const a=i.toString(16);return a.length!==2?"0"+a:a}function y(i){return`#${c(i.rgba.r)}${c(i.rgba.g)}${c(i.rgba.b)}`}e.formatHex=y;function C(i,a=!1){return a&&i.rgba.a===1?L.Format.CSS.formatHex(i):`#${c(i.rgba.r)}${c(i.rgba.g)}${c(i.rgba.b)}${c(Math.round(i.rgba.a*255))}`}e.formatHexA=C;function E(i){return i.isOpaque()?L.Format.CSS.formatHex(i):L.Format.CSS.formatRGBA(i)}e.format=E;function S(i){const a=i.length;if(a===0||i.charCodeAt(0)!==35)return null;if(a===7){const g=16*_(i.charCodeAt(1))+_(i.charCodeAt(2)),b=16*_(i.charCodeAt(3))+_(i.charCodeAt(4)),f=16*_(i.charCodeAt(5))+_(i.charCodeAt(6));return new L(new M(g,b,f,1))}if(a===9){const g=16*_(i.charCodeAt(1))+_(i.charCodeAt(2)),b=16*_(i.charCodeAt(3))+_(i.charCodeAt(4)),f=16*_(i.charCodeAt(5))+_(i.charCodeAt(6)),p=16*_(i.charCodeAt(7))+_(i.charCodeAt(8));return new L(new M(g,b,f,p/255))}if(a===4){const g=_(i.charCodeAt(1)),b=_(i.charCodeAt(2)),f=_(i.charCodeAt(3));return new L(new M(16*g+g,16*b+b,16*f+f))}if(a===5){const g=_(i.charCodeAt(1)),b=_(i.charCodeAt(2)),f=_(i.charCodeAt(3)),p=_(i.charCodeAt(4));return new L(new M(16*g+g,16*b+b,16*f+f,(16*p+p)/255))}return null}e.parseHex=S;function _(i){switch(i){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(w=l.CSS||(l.CSS={}))})(h=L.Format||(L.Format={}))}(v||(t.Color=v={}))}),X(Z[35],K([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class r{constructor(R,d,v,L){this.originalStart=R,this.originalLength=d,this.modifiedStart=v,this.modifiedLength=L}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=r}),X(Z[5],K([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BugIndicatingError=t.ErrorNoTelemetry=t.NotSupportedError=t.illegalState=t.illegalArgument=t.canceled=t.CancellationError=t.isCancellationError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.errorHandler=t.ErrorHandler=void 0;class r{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(c){setTimeout(()=>{throw c.stack?o.isErrorNoTelemetry(c)?new o(c.message+`

`+c.stack):new Error(c.message+`

`+c.stack):c},0)}}emit(c){this.listeners.forEach(y=>{y(c)})}onUnexpectedError(c){this.unexpectedErrorHandler(c),this.emit(c)}onUnexpectedExternalError(c){this.unexpectedErrorHandler(c)}}t.ErrorHandler=r,t.errorHandler=new r;function M(m){L(m)||t.errorHandler.onUnexpectedError(m)}t.onUnexpectedError=M;function R(m){L(m)||t.errorHandler.onUnexpectedExternalError(m)}t.onUnexpectedExternalError=R;function d(m){if(m instanceof Error){const{name:c,message:y}=m,C=m.stacktrace||m.stack;return{$isError:!0,name:c,message:y,stack:C,noTelemetry:o.isErrorNoTelemetry(m)}}return m}t.transformErrorForSerialization=d;const v="Canceled";function L(m){return m instanceof h?!0:m instanceof Error&&m.name===v&&m.message===v}t.isCancellationError=L;class h extends Error{constructor(){super(v),this.name=this.message}}t.CancellationError=h;function l(){const m=new Error(v);return m.name=m.message,m}t.canceled=l;function w(m){return m?new Error(`Illegal argument: ${m}`):new Error("Illegal argument")}t.illegalArgument=w;function e(m){return m?new Error(`Illegal state: ${m}`):new Error("Illegal state")}t.illegalState=e;class s extends Error{constructor(c){super("NotSupported"),c&&(this.message=c)}}t.NotSupportedError=s;class o extends Error{constructor(c){super(c),this.name="CodeExpectedError"}static fromError(c){if(c instanceof o)return c;const y=new o;return y.message=c.message,y.stack=c.stack,y}static isErrorNoTelemetry(c){return c.name==="CodeExpectedError"}}t.ErrorNoTelemetry=o;class u extends Error{constructor(c){super(c||"An unexpected bug occurred."),Object.setPrototypeOf(this,u.prototype)}}t.BugIndicatingError=u}),X(Z[12],K([0,1,5]),function(q,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.checkAdjacentItems=t.assertFn=t.softAssert=t.assertNever=t.ok=void 0;function M(h,l){if(!h)throw new Error(l?`Assertion failed (${l})`:"Assertion Failed")}t.ok=M;function R(h,l="Unreachable"){throw new Error(l)}t.assertNever=R;function d(h){h||(0,r.onUnexpectedError)(new r.BugIndicatingError("Soft Assertion Failed"))}t.softAssert=d;function v(h){if(!h()){debugger;h(),(0,r.onUnexpectedError)(new r.BugIndicatingError("Assertion Failed"))}}t.assertFn=v;function L(h,l){let w=0;for(;w<h.length-1;){const e=h[w],s=h[w+1];if(!l(e,s))return!1;w++}return!0}t.checkAdjacentItems=L}),X(Z[20],K([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createSingleCallFunction=void 0;function r(M,R){const d=this;let v=!1,L;return function(){if(v)return L;if(v=!0,R)try{L=M.apply(d,arguments)}finally{R()}else L=M.apply(d,arguments);return L}}t.createSingleCallFunction=r}),X(Z[21],K([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var r;(function(M){function R(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}M.is=R;const d=Object.freeze([]);function v(){return d}M.empty=v;function*L(i){yield i}M.single=L;function h(i){return R(i)?i:L(i)}M.wrap=h;function l(i){return i||d}M.from=l;function*w(i){for(let a=i.length-1;a>=0;a--)yield i[a]}M.reverse=w;function e(i){return!i||i[Symbol.iterator]().next().done===!0}M.isEmpty=e;function s(i){return i[Symbol.iterator]().next().value}M.first=s;function o(i,a){for(const g of i)if(a(g))return!0;return!1}M.some=o;function u(i,a){for(const g of i)if(a(g))return g}M.find=u;function*m(i,a){for(const g of i)a(g)&&(yield g)}M.filter=m;function*c(i,a){let g=0;for(const b of i)yield a(b,g++)}M.map=c;function*y(...i){for(const a of i)yield*a}M.concat=y;function C(i,a,g){let b=g;for(const f of i)b=a(b,f);return b}M.reduce=C;function*E(i,a,g=i.length){for(a<0&&(a+=i.length),g<0?g+=i.length:g>i.length&&(g=i.length);a<g;a++)yield i[a]}M.slice=E;function S(i,a=Number.POSITIVE_INFINITY){const g=[];if(a===0)return[g,i];const b=i[Symbol.iterator]();for(let f=0;f<a;f++){const p=b.next();if(p.done)return[g,M.empty()];g.push(p.value)}return[g,{[Symbol.iterator](){return b}}]}M.consume=S;async function _(i){const a=[];for await(const g of i)a.push(g);return Promise.resolve(a)}M.asyncToArray=_})(r||(t.Iterable=r={}))}),X(Z[36],K([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyChord=t.KeyCodeUtils=t.IMMUTABLE_KEY_CODE_TO_CODE=t.IMMUTABLE_CODE_TO_KEY_CODE=t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=t.EVENT_KEY_CODE_MAP=void 0;class r{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(s,o){this._keyCodeToStr[s]=o,this._strToKeyCode[o.toLowerCase()]=s}keyCodeToStr(s){return this._keyCodeToStr[s]}strToKeyCode(s){return this._strToKeyCode[s.toLowerCase()]||0}}const M=new r,R=new r,d=new r;t.EVENT_KEY_CODE_MAP=new Array(230),t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const v=[],L=Object.create(null),h=Object.create(null);t.IMMUTABLE_CODE_TO_KEY_CODE=[],t.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)t.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=132;e++)t.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",s=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],o=[],u=[];for(const m of s){const[c,y,C,E,S,_,i,a,g]=m;if(u[y]||(u[y]=!0,v[y]=C,L[C]=y,h[C.toLowerCase()]=y,c&&(t.IMMUTABLE_CODE_TO_KEY_CODE[y]=E,E!==0&&E!==3&&E!==5&&E!==4&&E!==6&&E!==57&&(t.IMMUTABLE_KEY_CODE_TO_CODE[E]=y))),!o[E]){if(o[E]=!0,!S)throw new Error(`String representation missing for key code ${E} around scan code ${C}`);M.define(E,S),R.define(E,a||S),d.define(E,g||a||S)}_&&(t.EVENT_KEY_CODE_MAP[_]=E),i&&(t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[i]=E)}t.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var l;(function(e){function s(C){return M.keyCodeToStr(C)}e.toString=s;function o(C){return M.strToKeyCode(C)}e.fromString=o;function u(C){return R.keyCodeToStr(C)}e.toUserSettingsUS=u;function m(C){return d.keyCodeToStr(C)}e.toUserSettingsGeneral=m;function c(C){return R.strToKeyCode(C)||d.strToKeyCode(C)}e.fromUserSettings=c;function y(C){if(C>=98&&C<=113)return null;switch(C){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return M.keyCodeToStr(C)}e.toElectronAccelerator=y})(l||(t.KeyCodeUtils=l={}));function w(e,s){const o=(s&65535)<<16>>>0;return(e|o)>>>0}t.KeyChord=w}),X(Z[37],K([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Lazy=void 0;class r{constructor(R){this.executor=R,this._didRun=!1}get value(){if(!this._didRun)try{this._value=this.executor()}catch(R){this._error=R}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}t.Lazy=r}),X(Z[13],K([0,1,20,21]),function(q,t,r,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DisposableMap=t.ImmortalReference=t.RefCountedDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.dispose=t.isDisposable=t.markAsSingleton=t.markAsDisposed=t.trackDisposable=t.setDisposableTracker=void 0;const R=!1;let d=null;function v(i){d=i}if(t.setDisposableTracker=v,R){const i="__is_disposable_tracked__";v(new class{trackDisposable(a){const g=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[i]||console.log(g)},3e3)}setParent(a,g){if(a&&a!==y.None)try{a[i]=!0}catch{}}markAsDisposed(a){if(a&&a!==y.None)try{a[i]=!0}catch{}}markAsSingleton(a){}})}function L(i){return d?.trackDisposable(i),i}t.trackDisposable=L;function h(i){d?.markAsDisposed(i)}t.markAsDisposed=h;function l(i,a){d?.setParent(i,a)}function w(i,a){if(d)for(const g of i)d.setParent(g,a)}function e(i){return d?.markAsSingleton(i),i}t.markAsSingleton=e;function s(i){return typeof i.dispose=="function"&&i.dispose.length===0}t.isDisposable=s;function o(i){if(M.Iterable.is(i)){const a=[];for(const g of i)if(g)try{g.dispose()}catch(b){a.push(b)}if(a.length===1)throw a[0];if(a.length>1)throw new AggregateError(a,"Encountered errors while disposing of store");return Array.isArray(i)?[]:i}else if(i)return i.dispose(),i}t.dispose=o;function u(...i){const a=m(()=>o(i));return w(i,a),a}t.combinedDisposable=u;function m(i){const a=L({dispose:(0,r.createSingleCallFunction)(()=>{h(a),i()})});return a}t.toDisposable=m;class c{constructor(){this._toDispose=new Set,this._isDisposed=!1,L(this)}dispose(){this._isDisposed||(h(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{o(this._toDispose)}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return l(a,this),this._isDisposed?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}deleteAndLeak(a){a&&this._toDispose.has(a)&&(this._toDispose.delete(a),l(a,null))}}t.DisposableStore=c,c.DISABLE_DISPOSED_WARNING=!1;class y{constructor(){this._store=new c,L(this),l(this._store,this)}dispose(){h(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}t.Disposable=y,y.None=Object.freeze({dispose(){}});class C{constructor(){this._isDisposed=!1,L(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){var g;this._isDisposed||a===this._value||((g=this._value)===null||g===void 0||g.dispose(),a&&l(a,this),this._value=a)}clear(){this.value=void 0}dispose(){var a;this._isDisposed=!0,h(this),(a=this._value)===null||a===void 0||a.dispose(),this._value=void 0}}t.MutableDisposable=C;class E{constructor(a){this._disposable=a,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}t.RefCountedDisposable=E;class S{constructor(a){this.object=a}dispose(){}}t.ImmortalReference=S;class _{constructor(){this._store=new Map,this._isDisposed=!1,L(this)}dispose(){h(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{o(this._store.values())}finally{this._store.clear()}}get(a){return this._store.get(a)}set(a,g,b=!1){var f;this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),b||(f=this._store.get(a))===null||f===void 0||f.dispose(),this._store.set(a,g)}deleteAndDispose(a){var g;(g=this._store.get(a))===null||g===void 0||g.dispose(),this._store.delete(a)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}t.DisposableMap=_}),X(Z[22],K([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class r{constructor(d){this.element=d,this.next=r.Undefined,this.prev=r.Undefined}}r.Undefined=new r(void 0);class M{constructor(){this._first=r.Undefined,this._last=r.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===r.Undefined}clear(){let d=this._first;for(;d!==r.Undefined;){const v=d.next;d.prev=r.Undefined,d.next=r.Undefined,d=v}this._first=r.Undefined,this._last=r.Undefined,this._size=0}unshift(d){return this._insert(d,!1)}push(d){return this._insert(d,!0)}_insert(d,v){const L=new r(d);if(this._first===r.Undefined)this._first=L,this._last=L;else if(v){const l=this._last;this._last=L,L.prev=l,l.next=L}else{const l=this._first;this._first=L,L.next=l,l.prev=L}this._size+=1;let h=!1;return()=>{h||(h=!0,this._remove(L))}}shift(){if(this._first!==r.Undefined){const d=this._first.element;return this._remove(this._first),d}}pop(){if(this._last!==r.Undefined){const d=this._last.element;return this._remove(this._last),d}}_remove(d){if(d.prev!==r.Undefined&&d.next!==r.Undefined){const v=d.prev;v.next=d.next,d.next.prev=v}else d.prev===r.Undefined&&d.next===r.Undefined?(this._first=r.Undefined,this._last=r.Undefined):d.next===r.Undefined?(this._last=this._last.prev,this._last.next=r.Undefined):d.prev===r.Undefined&&(this._first=this._first.next,this._first.prev=r.Undefined);this._size-=1}*[Symbol.iterator](){let d=this._first;for(;d!==r.Undefined;)yield d.element,d=d.next}}t.LinkedList=M}),X(Z[38],K([0,1]),function(q,t){"use strict";var r,M;Object.defineProperty(t,"__esModule",{value:!0}),t.SetMap=t.BidirectionalMap=t.LRUCache=t.LinkedMap=t.ResourceMap=void 0;class R{constructor(s,o){this.uri=s,this.value=o}}function d(e){return Array.isArray(e)}class v{constructor(s,o){if(this[r]="ResourceMap",s instanceof v)this.map=new Map(s.map),this.toKey=o??v.defaultToKey;else if(d(s)){this.map=new Map,this.toKey=o??v.defaultToKey;for(const[u,m]of s)this.set(u,m)}else this.map=new Map,this.toKey=s??v.defaultToKey}set(s,o){return this.map.set(this.toKey(s),new R(s,o)),this}get(s){var o;return(o=this.map.get(this.toKey(s)))===null||o===void 0?void 0:o.value}has(s){return this.map.has(this.toKey(s))}get size(){return this.map.size}clear(){this.map.clear()}delete(s){return this.map.delete(this.toKey(s))}forEach(s,o){typeof o<"u"&&(s=s.bind(o));for(const[u,m]of this.map)s(m.value,m.uri,this)}*values(){for(const s of this.map.values())yield s.value}*keys(){for(const s of this.map.values())yield s.uri}*entries(){for(const s of this.map.values())yield[s.uri,s.value]}*[(r=Symbol.toStringTag,Symbol.iterator)](){for(const[,s]of this.map)yield[s.uri,s.value]}}t.ResourceMap=v,v.defaultToKey=e=>e.toString();class L{constructor(){this[M]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var s;return(s=this._head)===null||s===void 0?void 0:s.value}get last(){var s;return(s=this._tail)===null||s===void 0?void 0:s.value}has(s){return this._map.has(s)}get(s,o=0){const u=this._map.get(s);if(u)return o!==0&&this.touch(u,o),u.value}set(s,o,u=0){let m=this._map.get(s);if(m)m.value=o,u!==0&&this.touch(m,u);else{switch(m={key:s,value:o,next:void 0,previous:void 0},u){case 0:this.addItemLast(m);break;case 1:this.addItemFirst(m);break;case 2:this.addItemLast(m);break;default:this.addItemLast(m);break}this._map.set(s,m),this._size++}return this}delete(s){return!!this.remove(s)}remove(s){const o=this._map.get(s);if(o)return this._map.delete(s),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const s=this._head;return this._map.delete(s.key),this.removeItem(s),this._size--,s.value}forEach(s,o){const u=this._state;let m=this._head;for(;m;){if(o?s.bind(o)(m.value,m.key,this):s(m.value,m.key,this),this._state!==u)throw new Error("LinkedMap got modified during iteration.");m=m.next}}keys(){const s=this,o=this._state;let u=this._head;const m={[Symbol.iterator](){return m},next(){if(s._state!==o)throw new Error("LinkedMap got modified during iteration.");if(u){const c={value:u.key,done:!1};return u=u.next,c}else return{value:void 0,done:!0}}};return m}values(){const s=this,o=this._state;let u=this._head;const m={[Symbol.iterator](){return m},next(){if(s._state!==o)throw new Error("LinkedMap got modified during iteration.");if(u){const c={value:u.value,done:!1};return u=u.next,c}else return{value:void 0,done:!0}}};return m}entries(){const s=this,o=this._state;let u=this._head;const m={[Symbol.iterator](){return m},next(){if(s._state!==o)throw new Error("LinkedMap got modified during iteration.");if(u){const c={value:[u.key,u.value],done:!1};return u=u.next,c}else return{value:void 0,done:!0}}};return m}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(s){if(s>=this.size)return;if(s===0){this.clear();return}let o=this._head,u=this.size;for(;o&&u>s;)this._map.delete(o.key),o=o.next,u--;this._head=o,this._size=u,o&&(o.previous=void 0),this._state++}addItemFirst(s){if(!this._head&&!this._tail)this._tail=s;else if(this._head)s.next=this._head,this._head.previous=s;else throw new Error("Invalid list");this._head=s,this._state++}addItemLast(s){if(!this._head&&!this._tail)this._head=s;else if(this._tail)s.previous=this._tail,this._tail.next=s;else throw new Error("Invalid list");this._tail=s,this._state++}removeItem(s){if(s===this._head&&s===this._tail)this._head=void 0,this._tail=void 0;else if(s===this._head){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this._head=s.next}else if(s===this._tail){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this._tail=s.previous}else{const o=s.next,u=s.previous;if(!o||!u)throw new Error("Invalid list");o.previous=u,u.next=o}s.next=void 0,s.previous=void 0,this._state++}touch(s,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(s===this._head)return;const u=s.next,m=s.previous;s===this._tail?(m.next=void 0,this._tail=m):(u.previous=m,m.next=u),s.previous=void 0,s.next=this._head,this._head.previous=s,this._head=s,this._state++}else if(o===2){if(s===this._tail)return;const u=s.next,m=s.previous;s===this._head?(u.previous=void 0,this._head=u):(u.previous=m,m.next=u),s.next=void 0,s.previous=this._tail,this._tail.next=s,this._tail=s,this._state++}}}toJSON(){const s=[];return this.forEach((o,u)=>{s.push([u,o])}),s}fromJSON(s){this.clear();for(const[o,u]of s)this.set(o,u)}}t.LinkedMap=L;class h extends L{constructor(s,o=1){super(),this._limit=s,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(s){this._limit=s,this.checkTrim()}get(s,o=2){return super.get(s,o)}peek(s){return super.get(s,0)}set(s,o){return super.set(s,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}t.LRUCache=h;class l{constructor(s){if(this._m1=new Map,this._m2=new Map,s)for(const[o,u]of s)this.set(o,u)}clear(){this._m1.clear(),this._m2.clear()}set(s,o){this._m1.set(s,o),this._m2.set(o,s)}get(s){return this._m1.get(s)}getKey(s){return this._m2.get(s)}delete(s){const o=this._m1.get(s);return o===void 0?!1:(this._m1.delete(s),this._m2.delete(o),!0)}keys(){return this._m1.keys()}values(){return this._m1.values()}}t.BidirectionalMap=l;class w{constructor(){this.map=new Map}add(s,o){let u=this.map.get(s);u||(u=new Set,this.map.set(s,u)),u.add(o)}delete(s,o){const u=this.map.get(s);u&&(u.delete(o),u.size===0&&this.map.delete(s))}forEach(s,o){const u=this.map.get(s);u&&u.forEach(o)}get(s){const o=this.map.get(s);return o||new Set}}t.SetMap=w}),X(Z[23],K([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const r=globalThis.performance&&typeof globalThis.performance.now=="function";class M{static create(d){return new M(d)}constructor(d){this._now=r&&d===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}t.StopWatch=M}),X(Z[9],K([0,1,5,20,13,22,23]),function(q,t,r,M,R,d,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.createEventDeliveryQueue=t.Emitter=t.EventProfiling=t.Event=void 0;const L=!1,h=!1;var l;(function(f){f.None=()=>R.Disposable.None;function p(U){if(h){const{onDidAddListener:$}=U,Y=o.create();let J=0;U.onDidAddListener=()=>{++J===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Y.print()),$?.()}}}function N(U,$){return F(U,()=>{},0,void 0,!0,void 0,$)}f.defer=N;function A(U){return($,Y=null,J)=>{let te=!1,re;return re=U(ie=>{if(!te)return re?re.dispose():te=!0,$.call(Y,ie)},null,J),te&&re.dispose(),re}}f.once=A;function D(U,$,Y){return x((J,te=null,re)=>U(ie=>J.call(te,$(ie)),null,re),Y)}f.map=D;function P(U,$,Y){return x((J,te=null,re)=>U(ie=>{$(ie),J.call(te,ie)},null,re),Y)}f.forEach=P;function T(U,$,Y){return x((J,te=null,re)=>U(ie=>$(ie)&&J.call(te,ie),null,re),Y)}f.filter=T;function I(U){return U}f.signal=I;function W(...U){return($,Y=null,J)=>{const te=(0,R.combinedDisposable)(...U.map(re=>re(ie=>$.call(Y,ie))));return O(te,J)}}f.any=W;function H(U,$,Y,J){let te=Y;return D(U,re=>(te=$(te,re),te),J)}f.reduce=H;function x(U,$){let Y;const J={onWillAddFirstListener(){Y=U(te.fire,te)},onDidRemoveLastListener(){Y?.dispose()}};$||p(J);const te=new y(J);return $?.add(te),te.event}function O(U,$){return $ instanceof Array?$.push(U):$&&$.add(U),U}function F(U,$,Y=100,J=!1,te=!1,re,ie){let le,ue,k,B=0,z;const G={leakWarningThreshold:re,onWillAddFirstListener(){le=U(ae=>{B++,ue=$(ue,ae),J&&!k&&(ee.fire(ue),ue=void 0),z=()=>{const fe=ue;ue=void 0,k=void 0,(!J||B>1)&&ee.fire(fe),B=0},typeof Y=="number"?(clearTimeout(k),k=setTimeout(z,Y)):k===void 0&&(k=0,queueMicrotask(z))})},onWillRemoveListener(){te&&B>0&&z?.()},onDidRemoveLastListener(){z=void 0,le.dispose()}};ie||p(G);const ee=new y(G);return ie?.add(ee),ee.event}f.debounce=F;function V(U,$=0,Y){return f.debounce(U,(J,te)=>J?(J.push(te),J):[te],$,void 0,!0,void 0,Y)}f.accumulate=V;function j(U,$=(J,te)=>J===te,Y){let J=!0,te;return T(U,re=>{const ie=J||!$(re,te);return J=!1,te=re,ie},Y)}f.latch=j;function Q(U,$,Y){return[f.filter(U,$,Y),f.filter(U,J=>!$(J),Y)]}f.split=Q;function ne(U,$=!1,Y=[],J){let te=Y.slice(),re=U(ue=>{te?te.push(ue):le.fire(ue)});J&&J.add(re);const ie=()=>{te?.forEach(ue=>le.fire(ue)),te=null},le=new y({onWillAddFirstListener(){re||(re=U(ue=>le.fire(ue)),J&&J.add(re))},onDidAddFirstListener(){te&&($?setTimeout(ie):ie())},onDidRemoveLastListener(){re&&re.dispose(),re=null}});return J&&J.add(le),le.event}f.buffer=ne;function se(U,$){return(J,te,re)=>{const ie=$(new be);return U(function(le){const ue=ie.evaluate(le);ue!==n&&J.call(te,ue)},void 0,re)}}f.chain=se;const n=Symbol("HaltChainable");class be{constructor(){this.steps=[]}map($){return this.steps.push($),this}forEach($){return this.steps.push(Y=>($(Y),Y)),this}filter($){return this.steps.push(Y=>$(Y)?Y:n),this}reduce($,Y){let J=Y;return this.steps.push(te=>(J=$(J,te),J)),this}latch($=(Y,J)=>Y===J){let Y=!0,J;return this.steps.push(te=>{const re=Y||!$(te,J);return Y=!1,J=te,re?te:n}),this}evaluate($){for(const Y of this.steps)if($=Y($),$===n)break;return $}}function Le(U,$,Y=J=>J){const J=(...le)=>ie.fire(Y(...le)),te=()=>U.on($,J),re=()=>U.removeListener($,J),ie=new y({onWillAddFirstListener:te,onDidRemoveLastListener:re});return ie.event}f.fromNodeEventEmitter=Le;function we(U,$,Y=J=>J){const J=(...le)=>ie.fire(Y(...le)),te=()=>U.addEventListener($,J),re=()=>U.removeEventListener($,J),ie=new y({onWillAddFirstListener:te,onDidRemoveLastListener:re});return ie.event}f.fromDOMEventEmitter=we;function Ce(U){return new Promise($=>A(U)($))}f.toPromise=Ce;function _e(U){const $=new y;return U.then(Y=>{$.fire(Y)},()=>{$.fire(void 0)}).finally(()=>{$.dispose()}),$.event}f.fromPromise=_e;function Se(U,$,Y){return $(Y),U(J=>$(J))}f.runAndSubscribe=Se;class ve{constructor($,Y){this._observable=$,this._counter=0,this._hasChanged=!1;const J={onWillAddFirstListener:()=>{$.addObserver(this)},onDidRemoveLastListener:()=>{$.removeObserver(this)}};Y||p(J),this.emitter=new y(J),Y&&Y.add(this.emitter)}beginUpdate($){this._counter++}handlePossibleChange($){}handleChange($,Y){this._hasChanged=!0}endUpdate($){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function ye(U,$){return new ve(U,$).emitter.event}f.fromObservable=ye;function Ee(U){return($,Y,J)=>{let te=0,re=!1;const ie={beginUpdate(){te++},endUpdate(){te--,te===0&&(U.reportChanges(),re&&(re=!1,$.call(Y)))},handlePossibleChange(){},handleChange(){re=!0}};U.addObserver(ie),U.reportChanges();const le={dispose(){U.removeObserver(ie)}};return J instanceof R.DisposableStore?J.add(le):Array.isArray(J)&&J.push(le),le}}f.fromObservableLight=Ee})(l||(t.Event=l={}));class w{constructor(p){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${p}_${w._idPool++}`,w.all.add(this)}start(p){this._stopWatch=new v.StopWatch,this.listenerCount=p}stop(){if(this._stopWatch){const p=this._stopWatch.elapsed();this.durations.push(p),this.elapsedOverall+=p,this.invocationCount+=1,this._stopWatch=void 0}}}t.EventProfiling=w,w.all=new Set,w._idPool=0;let e=-1;class s{constructor(p,N=Math.random().toString(18).slice(2,5)){this.threshold=p,this.name=N,this._warnCountdown=0}dispose(){var p;(p=this._stacks)===null||p===void 0||p.clear()}check(p,N){const A=this.threshold;if(A<=0||N<A)return;this._stacks||(this._stacks=new Map);const D=this._stacks.get(p.value)||0;if(this._stacks.set(p.value,D+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=A*.5;let P,T=0;for(const[I,W]of this._stacks)(!P||T<W)&&(P=I,T=W);console.warn(`[${this.name}] potential listener LEAK detected, having ${N} listeners already. MOST frequent listener (${T}):`),console.warn(P)}return()=>{const P=this._stacks.get(p.value)||0;this._stacks.set(p.value,P-1)}}}class o{static create(){var p;return new o((p=new Error().stack)!==null&&p!==void 0?p:"")}constructor(p){this.value=p}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class u{constructor(p){this.value=p}}const m=2,c=(f,p)=>{if(f instanceof u)p(f);else for(let N=0;N<f.length;N++){const A=f[N];A&&p(A)}};class y{constructor(p){var N,A,D,P,T;this._size=0,this._options=p,this._leakageMon=e>0||!((N=this._options)===null||N===void 0)&&N.leakWarningThreshold?new s((D=(A=this._options)===null||A===void 0?void 0:A.leakWarningThreshold)!==null&&D!==void 0?D:e):void 0,this._perfMon=!((P=this._options)===null||P===void 0)&&P._profName?new w(this._options._profName):void 0,this._deliveryQueue=(T=this._options)===null||T===void 0?void 0:T.deliveryQueue}dispose(){var p,N,A,D;if(!this._disposed){if(this._disposed=!0,((p=this._deliveryQueue)===null||p===void 0?void 0:p.current)===this&&this._deliveryQueue.reset(),this._listeners){if(L){const P=this._listeners;queueMicrotask(()=>{c(P,T=>{var I;return(I=T.stack)===null||I===void 0?void 0:I.print()})})}this._listeners=void 0,this._size=0}(A=(N=this._options)===null||N===void 0?void 0:N.onDidRemoveLastListener)===null||A===void 0||A.call(N),(D=this._leakageMon)===null||D===void 0||D.dispose()}}get event(){var p;return(p=this._event)!==null&&p!==void 0||(this._event=(N,A,D)=>{var P,T,I,W,H;if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),R.Disposable.None;if(this._disposed)return R.Disposable.None;A&&(N=N.bind(A));const x=new u(N);let O,F;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(x.stack=o.create(),O=this._leakageMon.check(x.stack,this._size+1)),L&&(x.stack=F??o.create()),this._listeners?this._listeners instanceof u?((H=this._deliveryQueue)!==null&&H!==void 0||(this._deliveryQueue=new E),this._listeners=[this._listeners,x]):this._listeners.push(x):((T=(P=this._options)===null||P===void 0?void 0:P.onWillAddFirstListener)===null||T===void 0||T.call(P,this),this._listeners=x,(W=(I=this._options)===null||I===void 0?void 0:I.onDidAddFirstListener)===null||W===void 0||W.call(I,this)),this._size++;const V=(0,R.toDisposable)(()=>{O?.(),this._removeListener(x)});return D instanceof R.DisposableStore?D.add(V):Array.isArray(D)&&D.push(V),V}),this._event}_removeListener(p){var N,A,D,P;if((A=(N=this._options)===null||N===void 0?void 0:N.onWillRemoveListener)===null||A===void 0||A.call(N,this),!this._listeners)return;if(this._size===1){this._listeners=void 0,(P=(D=this._options)===null||D===void 0?void 0:D.onDidRemoveLastListener)===null||P===void 0||P.call(D,this),this._size=0;return}const T=this._listeners,I=T.indexOf(p);if(I===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,T[I]=void 0;const W=this._deliveryQueue.current===this;if(this._size*m<=T.length){let H=0;for(let x=0;x<T.length;x++)T[x]?T[H++]=T[x]:W&&(this._deliveryQueue.end--,H<this._deliveryQueue.i&&this._deliveryQueue.i--);T.length=H}}_deliver(p,N){var A;if(!p)return;const D=((A=this._options)===null||A===void 0?void 0:A.onListenerError)||r.onUnexpectedError;if(!D){p.value(N);return}try{p.value(N)}catch(P){D(P)}}_deliverQueue(p){const N=p.current._listeners;for(;p.i<p.end;)this._deliver(N[p.i++],p.value);p.reset()}fire(p){var N,A,D,P;if(!((N=this._deliveryQueue)===null||N===void 0)&&N.current&&(this._deliverQueue(this._deliveryQueue),(A=this._perfMon)===null||A===void 0||A.stop()),(D=this._perfMon)===null||D===void 0||D.start(this._size),this._listeners)if(this._listeners instanceof u)this._deliver(this._listeners,p);else{const T=this._deliveryQueue;T.enqueue(this,p,this._listeners.length),this._deliverQueue(T)}(P=this._perfMon)===null||P===void 0||P.stop()}hasListeners(){return this._size>0}}t.Emitter=y;const C=()=>new E;t.createEventDeliveryQueue=C;class E{constructor(){this.i=-1,this.end=0}enqueue(p,N,A){this.i=0,this.end=A,this.current=p,this.value=N}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class S extends y{constructor(p){super(p),this._isPaused=0,this._eventQueue=new d.LinkedList,this._mergeFn=p?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const p=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(p))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(p){this._size&&(this._isPaused!==0?this._eventQueue.push(p):super.fire(p))}}t.PauseableEmitter=S;class _ extends S{constructor(p){var N;super(p),this._delay=(N=p.delay)!==null&&N!==void 0?N:100}fire(p){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(p)}}t.DebounceEmitter=_;class i extends y{constructor(p){super(p),this._queuedEvents=[],this._mergeFn=p?.merge}fire(p){this.hasListeners()&&(this._queuedEvents.push(p),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(N=>super.fire(N)),this._queuedEvents=[]}))}}t.MicrotaskEmitter=i;class a{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new y({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(p){const N={event:p,listener:null};this.events.push(N),this.hasListeners&&this.hook(N);const A=()=>{this.hasListeners&&this.unhook(N);const D=this.events.indexOf(N);this.events.splice(D,1)};return(0,R.toDisposable)((0,M.createSingleCallFunction)(A))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(p=>this.hook(p))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(p=>this.unhook(p))}hook(p){p.listener=p.event(N=>this.emitter.fire(N))}unhook(p){var N;(N=p.listener)===null||N===void 0||N.dispose(),p.listener=null}dispose(){var p;this.emitter.dispose();for(const N of this.events)(p=N.listener)===null||p===void 0||p.dispose();this.events=[]}}t.EventMultiplexer=a;class g{constructor(){this.buffers=[]}wrapEvent(p){return(N,A,D)=>p(P=>{const T=this.buffers[this.buffers.length-1];T?T.push(()=>N.call(A,P)):N.call(A,P)},void 0,D)}bufferEvents(p){const N=[];this.buffers.push(N);const A=p();return this.buffers.pop(),N.forEach(D=>D()),A}}t.EventBufferer=g;class b{constructor(){this.listening=!1,this.inputEvent=l.None,this.inputEventListener=R.Disposable.None,this.emitter=new y({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(p){this.inputEvent=p,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=p(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}t.Relay=b}),X(Z[39],K([0,1,9]),function(q,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const M=Object.freeze(function(L,h){const l=setTimeout(L.bind(h),0);return{dispose(){clearTimeout(l)}}});var R;(function(L){function h(l){return l===L.None||l===L.Cancelled||l instanceof d?!0:!l||typeof l!="object"?!1:typeof l.isCancellationRequested=="boolean"&&typeof l.onCancellationRequested=="function"}L.isCancellationToken=h,L.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:r.Event.None}),L.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:M})})(R||(t.CancellationToken=R={}));class d{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?M:(this._emitter||(this._emitter=new r.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class v{constructor(h){this._token=void 0,this._parentListener=void 0,this._parentListener=h&&h.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new d),this._token}cancel(){this._token?this._token instanceof d&&this._token.cancel():this._token=R.Cancelled}dispose(h=!1){var l;h&&this.cancel(),(l=this._parentListener)===null||l===void 0||l.dispose(),this._token?this._token instanceof d&&this._token.dispose():this._token=R.None}}t.CancellationTokenSource=v}),X(Z[6],K([0,1,33,37]),function(q,t,r,M){"use strict";var R;Object.defineProperty(t,"__esModule",{value:!0}),t.InvisibleCharacters=t.AmbiguousCharacters=t.noBreakWhitespace=t.getLeftDeleteOffset=t.singleLetterHash=t.containsUppercaseCharacter=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsRTL=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.GraphemeIterator=t.CodePointIterator=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.isAsciiDigit=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.splitLinesIncludeSeparators=t.splitLines=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.escapeRegExpCharacters=t.escape=t.htmlAttributeEncodeValue=t.format=t.isFalsyOrWhitespace=void 0;function d(k){return!k||typeof k!="string"?!0:k.trim().length===0}t.isFalsyOrWhitespace=d;const v=/{(\d+)}/g;function L(k,...B){return B.length===0?k:k.replace(v,function(z,G){const ee=parseInt(G,10);return isNaN(ee)||ee<0||ee>=B.length?z:B[ee]})}t.format=L;function h(k){return k.replace(/[<>"'&]/g,B=>{switch(B){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return B})}t.htmlAttributeEncodeValue=h;function l(k){return k.replace(/[<>&]/g,function(B){switch(B){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return B}})}t.escape=l;function w(k){return k.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.escapeRegExpCharacters=w;function e(k,B=" "){const z=s(k,B);return o(z,B)}t.trim=e;function s(k,B){if(!k||!B)return k;const z=B.length;if(z===0||k.length===0)return k;let G=0;for(;k.indexOf(B,G)===G;)G=G+z;return k.substring(G)}t.ltrim=s;function o(k,B){if(!k||!B)return k;const z=B.length,G=k.length;if(z===0||G===0)return k;let ee=G,ae=-1;for(;ae=k.lastIndexOf(B,ee-1),!(ae===-1||ae+z!==ee);){if(ae===0)return"";ee=ae}return k.substring(0,ee)}t.rtrim=o;function u(k){return k.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.convertSimple2RegExpPattern=u;function m(k){return k.replace(/\*/g,"")}t.stripWildcards=m;function c(k,B,z={}){if(!k)throw new Error("Cannot create regex from empty string");B||(k=w(k)),z.wholeWord&&(/\B/.test(k.charAt(0))||(k="\\b"+k),/\B/.test(k.charAt(k.length-1))||(k=k+"\\b"));let G="";return z.global&&(G+="g"),z.matchCase||(G+="i"),z.multiline&&(G+="m"),z.unicode&&(G+="u"),new RegExp(k,G)}t.createRegExp=c;function y(k){return k.source==="^"||k.source==="^$"||k.source==="$"||k.source==="^\\s*$"?!1:!!(k.exec("")&&k.lastIndex===0)}t.regExpLeadsToEndlessLoop=y;function C(k){return k.split(/\r\n|\r|\n/)}t.splitLines=C;function E(k){var B;const z=[],G=k.split(/(\r\n|\r|\n)/);for(let ee=0;ee<Math.ceil(G.length/2);ee++)z.push(G[2*ee]+((B=G[2*ee+1])!==null&&B!==void 0?B:""));return z}t.splitLinesIncludeSeparators=E;function S(k){for(let B=0,z=k.length;B<z;B++){const G=k.charCodeAt(B);if(G!==32&&G!==9)return B}return-1}t.firstNonWhitespaceIndex=S;function _(k,B=0,z=k.length){for(let G=B;G<z;G++){const ee=k.charCodeAt(G);if(ee!==32&&ee!==9)return k.substring(B,G)}return k.substring(B,z)}t.getLeadingWhitespace=_;function i(k,B=k.length-1){for(let z=B;z>=0;z--){const G=k.charCodeAt(z);if(G!==32&&G!==9)return z}return-1}t.lastNonWhitespaceIndex=i;function a(k,B){return k<B?-1:k>B?1:0}t.compare=a;function g(k,B,z=0,G=k.length,ee=0,ae=B.length){for(;z<G&&ee<ae;z++,ee++){const de=k.charCodeAt(z),oe=B.charCodeAt(ee);if(de<oe)return-1;if(de>oe)return 1}const fe=G-z,me=ae-ee;return fe<me?-1:fe>me?1:0}t.compareSubstring=g;function b(k,B){return f(k,B,0,k.length,0,B.length)}t.compareIgnoreCase=b;function f(k,B,z=0,G=k.length,ee=0,ae=B.length){for(;z<G&&ee<ae;z++,ee++){let de=k.charCodeAt(z),oe=B.charCodeAt(ee);if(de===oe)continue;if(de>=128||oe>=128)return g(k.toLowerCase(),B.toLowerCase(),z,G,ee,ae);N(de)&&(de-=32),N(oe)&&(oe-=32);const ce=de-oe;if(ce!==0)return ce}const fe=G-z,me=ae-ee;return fe<me?-1:fe>me?1:0}t.compareSubstringIgnoreCase=f;function p(k){return k>=48&&k<=57}t.isAsciiDigit=p;function N(k){return k>=97&&k<=122}t.isLowerAsciiLetter=N;function A(k){return k>=65&&k<=90}t.isUpperAsciiLetter=A;function D(k,B){return k.length===B.length&&f(k,B)===0}t.equalsIgnoreCase=D;function P(k,B){const z=B.length;return B.length>k.length?!1:f(k,B,0,z)===0}t.startsWithIgnoreCase=P;function T(k,B){const z=Math.min(k.length,B.length);let G;for(G=0;G<z;G++)if(k.charCodeAt(G)!==B.charCodeAt(G))return G;return z}t.commonPrefixLength=T;function I(k,B){const z=Math.min(k.length,B.length);let G;const ee=k.length-1,ae=B.length-1;for(G=0;G<z;G++)if(k.charCodeAt(ee-G)!==B.charCodeAt(ae-G))return G;return z}t.commonSuffixLength=I;function W(k){return 55296<=k&&k<=56319}t.isHighSurrogate=W;function H(k){return 56320<=k&&k<=57343}t.isLowSurrogate=H;function x(k,B){return(k-55296<<10)+(B-56320)+65536}t.computeCodePoint=x;function O(k,B,z){const G=k.charCodeAt(z);if(W(G)&&z+1<B){const ee=k.charCodeAt(z+1);if(H(ee))return x(G,ee)}return G}t.getNextCodePoint=O;function F(k,B){const z=k.charCodeAt(B-1);if(H(z)&&B>1){const G=k.charCodeAt(B-2);if(W(G))return x(G,z)}return z}class V{get offset(){return this._offset}constructor(B,z=0){this._str=B,this._len=B.length,this._offset=z}setOffset(B){this._offset=B}prevCodePoint(){const B=F(this._str,this._offset);return this._offset-=B>=65536?2:1,B}nextCodePoint(){const B=O(this._str,this._len,this._offset);return this._offset+=B>=65536?2:1,B}eol(){return this._offset>=this._len}}t.CodePointIterator=V;class j{get offset(){return this._iterator.offset}constructor(B,z=0){this._iterator=new V(B,z)}nextGraphemeLength(){const B=Y.getInstance(),z=this._iterator,G=z.offset;let ee=B.getGraphemeBreakType(z.nextCodePoint());for(;!z.eol();){const ae=z.offset,fe=B.getGraphemeBreakType(z.nextCodePoint());if($(ee,fe)){z.setOffset(ae);break}ee=fe}return z.offset-G}prevGraphemeLength(){const B=Y.getInstance(),z=this._iterator,G=z.offset;let ee=B.getGraphemeBreakType(z.prevCodePoint());for(;z.offset>0;){const ae=z.offset,fe=B.getGraphemeBreakType(z.prevCodePoint());if($(fe,ee)){z.setOffset(ae);break}ee=fe}return G-z.offset}eol(){return this._iterator.eol()}}t.GraphemeIterator=j;function Q(k,B){return new j(k,B).nextGraphemeLength()}t.nextCharLength=Q;function ne(k,B){return new j(k,B).prevGraphemeLength()}t.prevCharLength=ne;function se(k,B){B>0&&H(k.charCodeAt(B))&&B--;const z=B+Q(k,B);return[z-ne(k,z),z]}t.getCharContainingOffset=se;let n;function be(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Le(k){return n||(n=be()),n.test(k)}t.containsRTL=Le;const we=/^[\t\n\r\x20-\x7E]*$/;function Ce(k){return we.test(k)}t.isBasicASCII=Ce,t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function _e(k){return t.UNUSUAL_LINE_TERMINATORS.test(k)}t.containsUnusualLineTerminators=_e;function Se(k){return k>=11904&&k<=55215||k>=63744&&k<=64255||k>=65281&&k<=65374}t.isFullWidthCharacter=Se;function ve(k){return k>=127462&&k<=127487||k===8986||k===8987||k===9200||k===9203||k>=9728&&k<=10175||k===11088||k===11093||k>=127744&&k<=128591||k>=128640&&k<=128764||k>=128992&&k<=129008||k>=129280&&k<=129535||k>=129648&&k<=129782}t.isEmojiImprecise=ve,t.UTF8_BOM_CHARACTER="\uFEFF";function ye(k){return!!(k&&k.length>0&&k.charCodeAt(0)===65279)}t.startsWithUTF8BOM=ye;function Ee(k,B=!1){return k?(B&&(k=k.replace(/\\./g,"")),k.toLowerCase()!==k):!1}t.containsUppercaseCharacter=Ee;function U(k){return k=k%(2*26),k<26?String.fromCharCode(97+k):String.fromCharCode(65+k-26)}t.singleLetterHash=U;function $(k,B){return k===0?B!==5&&B!==7:k===2&&B===3?!1:k===4||k===2||k===3||B===4||B===2||B===3?!0:!(k===8&&(B===8||B===9||B===11||B===12)||(k===11||k===9)&&(B===9||B===10)||(k===12||k===10)&&B===10||B===5||B===13||B===7||k===1||k===13&&B===14||k===6&&B===6)}class Y{static getInstance(){return Y._INSTANCE||(Y._INSTANCE=new Y),Y._INSTANCE}constructor(){this._data=J()}getGraphemeBreakType(B){if(B<32)return B===10?3:B===13?2:4;if(B<127)return 0;const z=this._data,G=z.length/3;let ee=1;for(;ee<=G;)if(B<z[3*ee])ee=2*ee;else if(B>z[3*ee+1])ee=2*ee+1;else return z[3*ee+2];return 0}}Y._INSTANCE=null;function J(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function te(k,B){if(k===0)return 0;const z=re(k,B);if(z!==void 0)return z;const G=new V(B,k);return G.prevCodePoint(),G.offset}t.getLeftDeleteOffset=te;function re(k,B){const z=new V(B,k);let G=z.prevCodePoint();for(;ie(G)||G===65039||G===8419;){if(z.offset===0)return;G=z.prevCodePoint()}if(!ve(G))return;let ee=z.offset;return ee>0&&z.prevCodePoint()===8205&&(ee=z.offset),ee}function ie(k){return 127995<=k&&k<=127999}t.noBreakWhitespace="\xA0";class le{static getInstance(B){return R.cache.get(Array.from(B))}static getLocales(){return R._locales.value}constructor(B){this.confusableDictionary=B}isAmbiguous(B){return this.confusableDictionary.has(B)}getPrimaryConfusable(B){return this.confusableDictionary.get(B)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}t.AmbiguousCharacters=le,R=le,le.ambiguousCharacterData=new M.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),le.cache=new r.LRUCachedFunction(k=>{function B(oe){const ce=new Map;for(let ge=0;ge<oe.length;ge+=2)ce.set(oe[ge],oe[ge+1]);return ce}function z(oe,ce){const ge=new Map(oe);for(const[pe,Ne]of ce)ge.set(pe,Ne);return ge}function G(oe,ce){if(!oe)return ce;const ge=new Map;for(const[pe,Ne]of oe)ce.has(pe)&&ge.set(pe,Ne);return ge}const ee=R.ambiguousCharacterData.value;let ae=k.filter(oe=>!oe.startsWith("_")&&oe in ee);ae.length===0&&(ae=["_default"]);let fe;for(const oe of ae){const ce=B(ee[oe]);fe=G(fe,ce)}const me=B(ee._common),de=z(me,fe);return new R(de)}),le._locales=new M.Lazy(()=>Object.keys(R.ambiguousCharacterData.value).filter(k=>!k.startsWith("_")));class ue{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(ue.getRawData())),this._data}static isInvisibleCharacter(B){return ue.getData().has(B)}static get codePoints(){return ue.getData()}}t.InvisibleCharacters=ue,ue._data=void 0}),X(Z[40],K([0,1,6]),function(q,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.stringHash=t.numberHash=t.doHash=t.hash=void 0;function M(m){return R(m,0)}t.hash=M;function R(m,c){switch(typeof m){case"object":return m===null?d(349,c):Array.isArray(m)?h(m,c):l(m,c);case"string":return L(m,c);case"boolean":return v(m,c);case"number":return d(m,c);case"undefined":return d(937,c);default:return d(617,c)}}t.doHash=R;function d(m,c){return(c<<5)-c+m|0}t.numberHash=d;function v(m,c){return d(m?433:863,c)}function L(m,c){c=d(149417,c);for(let y=0,C=m.length;y<C;y++)c=d(m.charCodeAt(y),c);return c}t.stringHash=L;function h(m,c){return c=d(104579,c),m.reduce((y,C)=>R(C,y),c)}function l(m,c){return c=d(181387,c),Object.keys(m).sort().reduce((y,C)=>(y=L(C,y),R(m[C],y)),c)}function w(m,c,y=32){const C=y-c,E=~((1<<C)-1);return(m<<c|(E&m)>>>C)>>>0}function e(m,c=0,y=m.byteLength,C=0){for(let E=0;E<y;E++)m[c+E]=C}function s(m,c,y="0"){for(;m.length<c;)m=y+m;return m}function o(m,c=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(y=>y.toString(16).padStart(2,"0")).join(""):s((m>>>0).toString(16),c/4)}t.toHexString=o;class u{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(67),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(c){const y=c.length;if(y===0)return;const C=this._buff;let E=this._buffLen,S=this._leftoverHighSurrogate,_,i;for(S!==0?(_=S,i=-1,S=0):(_=c.charCodeAt(0),i=0);;){let a=_;if(r.isHighSurrogate(_))if(i+1<y){const g=c.charCodeAt(i+1);r.isLowSurrogate(g)?(i++,a=r.computeCodePoint(_,g)):a=65533}else{S=_;break}else r.isLowSurrogate(_)&&(a=65533);if(E=this._push(C,E,a),i++,i<y)_=c.charCodeAt(i);else break}this._buffLen=E,this._leftoverHighSurrogate=S}_push(c,y,C){return C<128?c[y++]=C:C<2048?(c[y++]=192|(C&1984)>>>6,c[y++]=128|(C&63)>>>0):C<65536?(c[y++]=224|(C&61440)>>>12,c[y++]=128|(C&4032)>>>6,c[y++]=128|(C&63)>>>0):(c[y++]=240|(C&1835008)>>>18,c[y++]=128|(C&258048)>>>12,c[y++]=128|(C&4032)>>>6,c[y++]=128|(C&63)>>>0),y>=64&&(this._step(),y-=64,this._totalLen+=64,c[0]=c[64],c[1]=c[65],c[2]=c[66]),y}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),o(this._h0)+o(this._h1)+o(this._h2)+o(this._h3)+o(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,e(this._buff,this._buffLen),this._buffLen>56&&(this._step(),e(this._buff));const c=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(c/4294967296),!1),this._buffDV.setUint32(60,c%4294967296,!1),this._step()}_step(){const c=u._bigBlock32,y=this._buffDV;for(let f=0;f<64;f+=4)c.setUint32(f,y.getUint32(f,!1),!1);for(let f=64;f<320;f+=4)c.setUint32(f,w(c.getUint32(f-12,!1)^c.getUint32(f-32,!1)^c.getUint32(f-56,!1)^c.getUint32(f-64,!1),1),!1);let C=this._h0,E=this._h1,S=this._h2,_=this._h3,i=this._h4,a,g,b;for(let f=0;f<80;f++)f<20?(a=E&S|~E&_,g=1518500249):f<40?(a=E^S^_,g=1859775393):f<60?(a=E&S|E&_|S&_,g=2400959708):(a=E^S^_,g=3395469782),b=w(C,5)+a+i+g+c.getUint32(f*4,!1)&4294967295,i=_,_=S,S=w(E,30),E=C,C=b;this._h0=this._h0+C&4294967295,this._h1=this._h1+E&4294967295,this._h2=this._h2+S&4294967295,this._h3=this._h3+_&4294967295,this._h4=this._h4+i&4294967295}}t.StringSHA1=u,u._bigBlock32=new DataView(new ArrayBuffer(320))}),X(Z[24],K([0,1,35,40]),function(q,t,r,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.stringDiff=t.StringDiffSequence=void 0;class R{constructor(e){this.source=e}getElements(){const e=this.source,s=new Int32Array(e.length);for(let o=0,u=e.length;o<u;o++)s[o]=e.charCodeAt(o);return s}}t.StringDiffSequence=R;function d(w,e,s){return new l(new R(w),new R(e)).ComputeDiff(s).changes}t.stringDiff=d;class v{static Assert(e,s){if(!e)throw new Error(s)}}class L{static Copy(e,s,o,u,m){for(let c=0;c<m;c++)o[u+c]=e[s+c]}static Copy2(e,s,o,u,m){for(let c=0;c<m;c++)o[u+c]=e[s+c]}}class h{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new r.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(e,s){this.m_originalStart=Math.min(this.m_originalStart,e),this.m_modifiedStart=Math.min(this.m_modifiedStart,s),this.m_originalCount++}AddModifiedElement(e,s){this.m_originalStart=Math.min(this.m_originalStart,e),this.m_modifiedStart=Math.min(this.m_modifiedStart,s),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class l{constructor(e,s,o=null){this.ContinueProcessingPredicate=o,this._originalSequence=e,this._modifiedSequence=s;const[u,m,c]=l._getElements(e),[y,C,E]=l._getElements(s);this._hasStrings=c&&E,this._originalStringElements=u,this._originalElementsOrHash=m,this._modifiedStringElements=y,this._modifiedElementsOrHash=C,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(e){return e.length>0&&typeof e[0]=="string"}static _getElements(e){const s=e.getElements();if(l._isStringArray(s)){const o=new Int32Array(s.length);for(let u=0,m=s.length;u<m;u++)o[u]=(0,M.stringHash)(s[u],0);return[s,o,!0]}return s instanceof Int32Array?[[],s,!1]:[[],new Int32Array(s),!1]}ElementsAreEqual(e,s){return this._originalElementsOrHash[e]!==this._modifiedElementsOrHash[s]?!1:this._hasStrings?this._originalStringElements[e]===this._modifiedStringElements[s]:!0}ElementsAreStrictEqual(e,s){if(!this.ElementsAreEqual(e,s))return!1;const o=l._getStrictElement(this._originalSequence,e),u=l._getStrictElement(this._modifiedSequence,s);return o===u}static _getStrictElement(e,s){return typeof e.getStrictElement=="function"?e.getStrictElement(s):null}OriginalElementsAreEqual(e,s){return this._originalElementsOrHash[e]!==this._originalElementsOrHash[s]?!1:this._hasStrings?this._originalStringElements[e]===this._originalStringElements[s]:!0}ModifiedElementsAreEqual(e,s){return this._modifiedElementsOrHash[e]!==this._modifiedElementsOrHash[s]?!1:this._hasStrings?this._modifiedStringElements[e]===this._modifiedStringElements[s]:!0}ComputeDiff(e){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,e)}_ComputeDiff(e,s,o,u,m){const c=[!1];let y=this.ComputeDiffRecursive(e,s,o,u,c);return m&&(y=this.PrettifyChanges(y)),{quitEarly:c[0],changes:y}}ComputeDiffRecursive(e,s,o,u,m){for(m[0]=!1;e<=s&&o<=u&&this.ElementsAreEqual(e,o);)e++,o++;for(;s>=e&&u>=o&&this.ElementsAreEqual(s,u);)s--,u--;if(e>s||o>u){let _;return o<=u?(v.Assert(e===s+1,"originalStart should only be one more than originalEnd"),_=[new r.DiffChange(e,0,o,u-o+1)]):e<=s?(v.Assert(o===u+1,"modifiedStart should only be one more than modifiedEnd"),_=[new r.DiffChange(e,s-e+1,o,0)]):(v.Assert(e===s+1,"originalStart should only be one more than originalEnd"),v.Assert(o===u+1,"modifiedStart should only be one more than modifiedEnd"),_=[]),_}const c=[0],y=[0],C=this.ComputeRecursionPoint(e,s,o,u,c,y,m),E=c[0],S=y[0];if(C!==null)return C;if(!m[0]){const _=this.ComputeDiffRecursive(e,E,o,S,m);let i=[];return m[0]?i=[new r.DiffChange(E+1,s-(E+1)+1,S+1,u-(S+1)+1)]:i=this.ComputeDiffRecursive(E+1,s,S+1,u,m),this.ConcatenateChanges(_,i)}return[new r.DiffChange(e,s-e+1,o,u-o+1)]}WALKTRACE(e,s,o,u,m,c,y,C,E,S,_,i,a,g,b,f,p,N){let A=null,D=null,P=new h,T=s,I=o,W=a[0]-f[0]-u,H=-1073741824,x=this.m_forwardHistory.length-1;do{const O=W+e;O===T||O<I&&E[O-1]<E[O+1]?(_=E[O+1],g=_-W-u,_<H&&P.MarkNextChange(),H=_,P.AddModifiedElement(_+1,g),W=O+1-e):(_=E[O-1]+1,g=_-W-u,_<H&&P.MarkNextChange(),H=_-1,P.AddOriginalElement(_,g+1),W=O-1-e),x>=0&&(E=this.m_forwardHistory[x],e=E[0],T=1,I=E.length-1)}while(--x>=-1);if(A=P.getReverseChanges(),N[0]){let O=a[0]+1,F=f[0]+1;if(A!==null&&A.length>0){const V=A[A.length-1];O=Math.max(O,V.getOriginalEnd()),F=Math.max(F,V.getModifiedEnd())}D=[new r.DiffChange(O,i-O+1,F,b-F+1)]}else{P=new h,T=c,I=y,W=a[0]-f[0]-C,H=1073741824,x=p?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const O=W+m;O===T||O<I&&S[O-1]>=S[O+1]?(_=S[O+1]-1,g=_-W-C,_>H&&P.MarkNextChange(),H=_+1,P.AddOriginalElement(_+1,g+1),W=O+1-m):(_=S[O-1],g=_-W-C,_>H&&P.MarkNextChange(),H=_,P.AddModifiedElement(_+1,g+1),W=O-1-m),x>=0&&(S=this.m_reverseHistory[x],m=S[0],T=1,I=S.length-1)}while(--x>=-1);D=P.getChanges()}return this.ConcatenateChanges(A,D)}ComputeRecursionPoint(e,s,o,u,m,c,y){let C=0,E=0,S=0,_=0,i=0,a=0;e--,o--,m[0]=0,c[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const g=s-e+(u-o),b=g+1,f=new Int32Array(b),p=new Int32Array(b),N=u-o,A=s-e,D=e-o,P=s-u,I=(A-N)%2===0;f[N]=e,p[A]=s,y[0]=!1;for(let W=1;W<=g/2+1;W++){let H=0,x=0;S=this.ClipDiagonalBound(N-W,W,N,b),_=this.ClipDiagonalBound(N+W,W,N,b);for(let F=S;F<=_;F+=2){F===S||F<_&&f[F-1]<f[F+1]?C=f[F+1]:C=f[F-1]+1,E=C-(F-N)-D;const V=C;for(;C<s&&E<u&&this.ElementsAreEqual(C+1,E+1);)C++,E++;if(f[F]=C,C+E>H+x&&(H=C,x=E),!I&&Math.abs(F-A)<=W-1&&C>=p[F])return m[0]=C,c[0]=E,V<=p[F]&&1447>0&&W<=1448?this.WALKTRACE(N,S,_,D,A,i,a,P,f,p,C,s,m,E,u,c,I,y):null}const O=(H-e+(x-o)-W)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(H,O))return y[0]=!0,m[0]=H,c[0]=x,O>0&&1447>0&&W<=1448?this.WALKTRACE(N,S,_,D,A,i,a,P,f,p,C,s,m,E,u,c,I,y):(e++,o++,[new r.DiffChange(e,s-e+1,o,u-o+1)]);i=this.ClipDiagonalBound(A-W,W,A,b),a=this.ClipDiagonalBound(A+W,W,A,b);for(let F=i;F<=a;F+=2){F===i||F<a&&p[F-1]>=p[F+1]?C=p[F+1]-1:C=p[F-1],E=C-(F-A)-P;const V=C;for(;C>e&&E>o&&this.ElementsAreEqual(C,E);)C--,E--;if(p[F]=C,I&&Math.abs(F-N)<=W&&C<=f[F])return m[0]=C,c[0]=E,V>=f[F]&&1447>0&&W<=1448?this.WALKTRACE(N,S,_,D,A,i,a,P,f,p,C,s,m,E,u,c,I,y):null}if(W<=1447){let F=new Int32Array(_-S+2);F[0]=N-S+1,L.Copy2(f,S,F,1,_-S+1),this.m_forwardHistory.push(F),F=new Int32Array(a-i+2),F[0]=A-i+1,L.Copy2(p,i,F,1,a-i+1),this.m_reverseHistory.push(F)}}return this.WALKTRACE(N,S,_,D,A,i,a,P,f,p,C,s,m,E,u,c,I,y)}PrettifyChanges(e){for(let s=0;s<e.length;s++){const o=e[s],u=s<e.length-1?e[s+1].originalStart:this._originalElementsOrHash.length,m=s<e.length-1?e[s+1].modifiedStart:this._modifiedElementsOrHash.length,c=o.originalLength>0,y=o.modifiedLength>0;for(;o.originalStart+o.originalLength<u&&o.modifiedStart+o.modifiedLength<m&&(!c||this.OriginalElementsAreEqual(o.originalStart,o.originalStart+o.originalLength))&&(!y||this.ModifiedElementsAreEqual(o.modifiedStart,o.modifiedStart+o.modifiedLength));){const E=this.ElementsAreStrictEqual(o.originalStart,o.modifiedStart);if(this.ElementsAreStrictEqual(o.originalStart+o.originalLength,o.modifiedStart+o.modifiedLength)&&!E)break;o.originalStart++,o.modifiedStart++}const C=[null];if(s<e.length-1&&this.ChangesOverlap(e[s],e[s+1],C)){e[s]=C[0],e.splice(s+1,1),s--;continue}}for(let s=e.length-1;s>=0;s--){const o=e[s];let u=0,m=0;if(s>0){const _=e[s-1];u=_.originalStart+_.originalLength,m=_.modifiedStart+_.modifiedLength}const c=o.originalLength>0,y=o.modifiedLength>0;let C=0,E=this._boundaryScore(o.originalStart,o.originalLength,o.modifiedStart,o.modifiedLength);for(let _=1;;_++){const i=o.originalStart-_,a=o.modifiedStart-_;if(i<u||a<m||c&&!this.OriginalElementsAreEqual(i,i+o.originalLength)||y&&!this.ModifiedElementsAreEqual(a,a+o.modifiedLength))break;const b=(i===u&&a===m?5:0)+this._boundaryScore(i,o.originalLength,a,o.modifiedLength);b>E&&(E=b,C=_)}o.originalStart-=C,o.modifiedStart-=C;const S=[null];if(s>0&&this.ChangesOverlap(e[s-1],e[s],S)){e[s-1]=S[0],e.splice(s,1),s++;continue}}if(this._hasStrings)for(let s=1,o=e.length;s<o;s++){const u=e[s-1],m=e[s],c=m.originalStart-u.originalStart-u.originalLength,y=u.originalStart,C=m.originalStart+m.originalLength,E=C-y,S=u.modifiedStart,_=m.modifiedStart+m.modifiedLength,i=_-S;if(c<5&&E<20&&i<20){const a=this._findBetterContiguousSequence(y,E,S,i,c);if(a){const[g,b]=a;(g!==u.originalStart+u.originalLength||b!==u.modifiedStart+u.modifiedLength)&&(u.originalLength=g-u.originalStart,u.modifiedLength=b-u.modifiedStart,m.originalStart=g+c,m.modifiedStart=b+c,m.originalLength=C-m.originalStart,m.modifiedLength=_-m.modifiedStart)}}}return e}_findBetterContiguousSequence(e,s,o,u,m){if(s<m||u<m)return null;const c=e+s-m+1,y=o+u-m+1;let C=0,E=0,S=0;for(let _=e;_<c;_++)for(let i=o;i<y;i++){const a=this._contiguousSequenceScore(_,i,m);a>0&&a>C&&(C=a,E=_,S=i)}return C>0?[E,S]:null}_contiguousSequenceScore(e,s,o){let u=0;for(let m=0;m<o;m++){if(!this.ElementsAreEqual(e+m,s+m))return 0;u+=this._originalStringElements[e+m].length}return u}_OriginalIsBoundary(e){return e<=0||e>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[e])}_OriginalRegionIsBoundary(e,s){if(this._OriginalIsBoundary(e)||this._OriginalIsBoundary(e-1))return!0;if(s>0){const o=e+s;if(this._OriginalIsBoundary(o-1)||this._OriginalIsBoundary(o))return!0}return!1}_ModifiedIsBoundary(e){return e<=0||e>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[e])}_ModifiedRegionIsBoundary(e,s){if(this._ModifiedIsBoundary(e)||this._ModifiedIsBoundary(e-1))return!0;if(s>0){const o=e+s;if(this._ModifiedIsBoundary(o-1)||this._ModifiedIsBoundary(o))return!0}return!1}_boundaryScore(e,s,o,u){const m=this._OriginalRegionIsBoundary(e,s)?1:0,c=this._ModifiedRegionIsBoundary(o,u)?1:0;return m+c}ConcatenateChanges(e,s){const o=[];if(e.length===0||s.length===0)return s.length>0?s:e;if(this.ChangesOverlap(e[e.length-1],s[0],o)){const u=new Array(e.length+s.length-1);return L.Copy(e,0,u,0,e.length-1),u[e.length-1]=o[0],L.Copy(s,1,u,e.length,s.length-1),u}else{const u=new Array(e.length+s.length);return L.Copy(e,0,u,0,e.length),L.Copy(s,0,u,e.length,s.length),u}}ChangesOverlap(e,s,o){if(v.Assert(e.originalStart<=s.originalStart,"Left change is not less than or equal to right change"),v.Assert(e.modifiedStart<=s.modifiedStart,"Left change is not less than or equal to right change"),e.originalStart+e.originalLength>=s.originalStart||e.modifiedStart+e.modifiedLength>=s.modifiedStart){const u=e.originalStart;let m=e.originalLength;const c=e.modifiedStart;let y=e.modifiedLength;return e.originalStart+e.originalLength>=s.originalStart&&(m=s.originalStart+s.originalLength-e.originalStart),e.modifiedStart+e.modifiedLength>=s.modifiedStart&&(y=s.modifiedStart+s.modifiedLength-e.modifiedStart),o[0]=new r.DiffChange(u,m,c,y),!0}else return o[0]=null,!1}ClipDiagonalBound(e,s,o,u){if(e>=0&&e<u)return e;const m=o,c=u-o-1,y=s%2===0;if(e<0){const C=m%2===0;return y===C?0:1}else{const C=c%2===0;return y===C?u-1:u-2}}}t.LcsDiff=l}),X(Z[25],K([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.validateConstraint=t.validateConstraints=t.isFunction=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isIterable=t.isNumber=t.isTypedArray=t.isObject=t.isString=void 0;function r(c){return typeof c=="string"}t.isString=r;function M(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}t.isObject=M;function R(c){const y=Object.getPrototypeOf(Uint8Array);return typeof c=="object"&&c instanceof y}t.isTypedArray=R;function d(c){return typeof c=="number"&&!isNaN(c)}t.isNumber=d;function v(c){return!!c&&typeof c[Symbol.iterator]=="function"}t.isIterable=v;function L(c){return c===!0||c===!1}t.isBoolean=L;function h(c){return typeof c>"u"}t.isUndefined=h;function l(c){return!w(c)}t.isDefined=l;function w(c){return h(c)||c===null}t.isUndefinedOrNull=w;function e(c,y){if(!c)throw new Error(y?`Unexpected type, expected '${y}'`:"Unexpected type")}t.assertType=e;function s(c){if(w(c))throw new Error("Assertion Failed: argument is undefined or null");return c}t.assertIsDefined=s;function o(c){return typeof c=="function"}t.isFunction=o;function u(c,y){const C=Math.min(c.length,y.length);for(let E=0;E<C;E++)m(c[E],y[E])}t.validateConstraints=u;function m(c,y){if(r(y)){if(typeof c!==y)throw new Error(`argument does not match constraint: typeof ${y}`)}else if(o(y)){try{if(c instanceof y)return}catch{}if(!w(c)&&c.constructor===y||y.length===1&&y.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.validateConstraint=m}),X(Z[26],K([0,1,25]),function(q,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getCodiconFontCharacters=t.register=void 0;const M=Object.create(null);function R(v,L){if((0,r.isString)(L)){const h=M[L];if(h===void 0)throw new Error(`${v} references an unknown codicon: ${L}`);L=h}return M[v]=L,{id:v}}t.register=R;function d(){return M}t.getCodiconFontCharacters=d}),X(Z[41],K([0,1,26]),function(q,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.codiconsLibrary=void 0,t.codiconsLibrary={add:(0,r.register)("add",6e4),plus:(0,r.register)("plus",6e4),gistNew:(0,r.register)("gist-new",6e4),repoCreate:(0,r.register)("repo-create",6e4),lightbulb:(0,r.register)("lightbulb",60001),lightBulb:(0,r.register)("light-bulb",60001),repo:(0,r.register)("repo",60002),repoDelete:(0,r.register)("repo-delete",60002),gistFork:(0,r.register)("gist-fork",60003),repoForked:(0,r.register)("repo-forked",60003),gitPullRequest:(0,r.register)("git-pull-request",60004),gitPullRequestAbandoned:(0,r.register)("git-pull-request-abandoned",60004),recordKeys:(0,r.register)("record-keys",60005),keyboard:(0,r.register)("keyboard",60005),tag:(0,r.register)("tag",60006),tagAdd:(0,r.register)("tag-add",60006),tagRemove:(0,r.register)("tag-remove",60006),gitPullRequestLabel:(0,r.register)("git-pull-request-label",60006),person:(0,r.register)("person",60007),personFollow:(0,r.register)("person-follow",60007),personOutline:(0,r.register)("person-outline",60007),personFilled:(0,r.register)("person-filled",60007),gitBranch:(0,r.register)("git-branch",60008),gitBranchCreate:(0,r.register)("git-branch-create",60008),gitBranchDelete:(0,r.register)("git-branch-delete",60008),sourceControl:(0,r.register)("source-control",60008),mirror:(0,r.register)("mirror",60009),mirrorPublic:(0,r.register)("mirror-public",60009),star:(0,r.register)("star",60010),starAdd:(0,r.register)("star-add",60010),starDelete:(0,r.register)("star-delete",60010),starEmpty:(0,r.register)("star-empty",60010),comment:(0,r.register)("comment",60011),commentAdd:(0,r.register)("comment-add",60011),alert:(0,r.register)("alert",60012),warning:(0,r.register)("warning",60012),search:(0,r.register)("search",60013),searchSave:(0,r.register)("search-save",60013),logOut:(0,r.register)("log-out",60014),signOut:(0,r.register)("sign-out",60014),logIn:(0,r.register)("log-in",60015),signIn:(0,r.register)("sign-in",60015),eye:(0,r.register)("eye",60016),eyeUnwatch:(0,r.register)("eye-unwatch",60016),eyeWatch:(0,r.register)("eye-watch",60016),circleFilled:(0,r.register)("circle-filled",60017),primitiveDot:(0,r.register)("primitive-dot",60017),closeDirty:(0,r.register)("close-dirty",60017),debugBreakpoint:(0,r.register)("debug-breakpoint",60017),debugBreakpointDisabled:(0,r.register)("debug-breakpoint-disabled",60017),debugBreakpointPending:(0,r.register)("debug-breakpoint-pending",60377),debugHint:(0,r.register)("debug-hint",60017),primitiveSquare:(0,r.register)("primitive-square",60018),edit:(0,r.register)("edit",60019),pencil:(0,r.register)("pencil",60019),info:(0,r.register)("info",60020),issueOpened:(0,r.register)("issue-opened",60020),gistPrivate:(0,r.register)("gist-private",60021),gitForkPrivate:(0,r.register)("git-fork-private",60021),lock:(0,r.register)("lock",60021),mirrorPrivate:(0,r.register)("mirror-private",60021),close:(0,r.register)("close",60022),removeClose:(0,r.register)("remove-close",60022),x:(0,r.register)("x",60022),repoSync:(0,r.register)("repo-sync",60023),sync:(0,r.register)("sync",60023),clone:(0,r.register)("clone",60024),desktopDownload:(0,r.register)("desktop-download",60024),beaker:(0,r.register)("beaker",60025),microscope:(0,r.register)("microscope",60025),vm:(0,r.register)("vm",60026),deviceDesktop:(0,r.register)("device-desktop",60026),file:(0,r.register)("file",60027),fileText:(0,r.register)("file-text",60027),more:(0,r.register)("more",60028),ellipsis:(0,r.register)("ellipsis",60028),kebabHorizontal:(0,r.register)("kebab-horizontal",60028),mailReply:(0,r.register)("mail-reply",60029),reply:(0,r.register)("reply",60029),organization:(0,r.register)("organization",60030),organizationFilled:(0,r.register)("organization-filled",60030),organizationOutline:(0,r.register)("organization-outline",60030),newFile:(0,r.register)("new-file",60031),fileAdd:(0,r.register)("file-add",60031),newFolder:(0,r.register)("new-folder",60032),fileDirectoryCreate:(0,r.register)("file-directory-create",60032),trash:(0,r.register)("trash",60033),trashcan:(0,r.register)("trashcan",60033),history:(0,r.register)("history",60034),clock:(0,r.register)("clock",60034),folder:(0,r.register)("folder",60035),fileDirectory:(0,r.register)("file-directory",60035),symbolFolder:(0,r.register)("symbol-folder",60035),logoGithub:(0,r.register)("logo-github",60036),markGithub:(0,r.register)("mark-github",60036),github:(0,r.register)("github",60036),terminal:(0,r.register)("terminal",60037),console:(0,r.register)("console",60037),repl:(0,r.register)("repl",60037),zap:(0,r.register)("zap",60038),symbolEvent:(0,r.register)("symbol-event",60038),error:(0,r.register)("error",60039),stop:(0,r.register)("stop",60039),variable:(0,r.register)("variable",60040),symbolVariable:(0,r.register)("symbol-variable",60040),array:(0,r.register)("array",60042),symbolArray:(0,r.register)("symbol-array",60042),symbolModule:(0,r.register)("symbol-module",60043),symbolPackage:(0,r.register)("symbol-package",60043),symbolNamespace:(0,r.register)("symbol-namespace",60043),symbolObject:(0,r.register)("symbol-object",60043),symbolMethod:(0,r.register)("symbol-method",60044),symbolFunction:(0,r.register)("symbol-function",60044),symbolConstructor:(0,r.register)("symbol-constructor",60044),symbolBoolean:(0,r.register)("symbol-boolean",60047),symbolNull:(0,r.register)("symbol-null",60047),symbolNumeric:(0,r.register)("symbol-numeric",60048),symbolNumber:(0,r.register)("symbol-number",60048),symbolStructure:(0,r.register)("symbol-structure",60049),symbolStruct:(0,r.register)("symbol-struct",60049),symbolParameter:(0,r.register)("symbol-parameter",60050),symbolTypeParameter:(0,r.register)("symbol-type-parameter",60050),symbolKey:(0,r.register)("symbol-key",60051),symbolText:(0,r.register)("symbol-text",60051),symbolReference:(0,r.register)("symbol-reference",60052),goToFile:(0,r.register)("go-to-file",60052),symbolEnum:(0,r.register)("symbol-enum",60053),symbolValue:(0,r.register)("symbol-value",60053),symbolRuler:(0,r.register)("symbol-ruler",60054),symbolUnit:(0,r.register)("symbol-unit",60054),activateBreakpoints:(0,r.register)("activate-breakpoints",60055),archive:(0,r.register)("archive",60056),arrowBoth:(0,r.register)("arrow-both",60057),arrowDown:(0,r.register)("arrow-down",60058),arrowLeft:(0,r.register)("arrow-left",60059),arrowRight:(0,r.register)("arrow-right",60060),arrowSmallDown:(0,r.register)("arrow-small-down",60061),arrowSmallLeft:(0,r.register)("arrow-small-left",60062),arrowSmallRight:(0,r.register)("arrow-small-right",60063),arrowSmallUp:(0,r.register)("arrow-small-up",60064),arrowUp:(0,r.register)("arrow-up",60065),bell:(0,r.register)("bell",60066),bold:(0,r.register)("bold",60067),book:(0,r.register)("book",60068),bookmark:(0,r.register)("bookmark",60069),debugBreakpointConditionalUnverified:(0,r.register)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,r.register)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,r.register)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,r.register)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,r.register)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,r.register)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,r.register)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,r.register)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,r.register)("debug-breakpoint-log-disabled",60075),briefcase:(0,r.register)("briefcase",60076),broadcast:(0,r.register)("broadcast",60077),browser:(0,r.register)("browser",60078),bug:(0,r.register)("bug",60079),calendar:(0,r.register)("calendar",60080),caseSensitive:(0,r.register)("case-sensitive",60081),check:(0,r.register)("check",60082),checklist:(0,r.register)("checklist",60083),chevronDown:(0,r.register)("chevron-down",60084),dropDownButton:(0,r.register)("drop-down-button",60084),chevronLeft:(0,r.register)("chevron-left",60085),chevronRight:(0,r.register)("chevron-right",60086),chevronUp:(0,r.register)("chevron-up",60087),chromeClose:(0,r.register)("chrome-close",60088),chromeMaximize:(0,r.register)("chrome-maximize",60089),chromeMinimize:(0,r.register)("chrome-minimize",60090),chromeRestore:(0,r.register)("chrome-restore",60091),circle:(0,r.register)("circle",60092),circleOutline:(0,r.register)("circle-outline",60092),debugBreakpointUnverified:(0,r.register)("debug-breakpoint-unverified",60092),circleSlash:(0,r.register)("circle-slash",60093),circuitBoard:(0,r.register)("circuit-board",60094),clearAll:(0,r.register)("clear-all",60095),clippy:(0,r.register)("clippy",60096),closeAll:(0,r.register)("close-all",60097),cloudDownload:(0,r.register)("cloud-download",60098),cloudUpload:(0,r.register)("cloud-upload",60099),code:(0,r.register)("code",60100),collapseAll:(0,r.register)("collapse-all",60101),colorMode:(0,r.register)("color-mode",60102),commentDiscussion:(0,r.register)("comment-discussion",60103),compareChanges:(0,r.register)("compare-changes",60157),creditCard:(0,r.register)("credit-card",60105),dash:(0,r.register)("dash",60108),dashboard:(0,r.register)("dashboard",60109),database:(0,r.register)("database",60110),debugContinue:(0,r.register)("debug-continue",60111),debugDisconnect:(0,r.register)("debug-disconnect",60112),debugPause:(0,r.register)("debug-pause",60113),debugRestart:(0,r.register)("debug-restart",60114),debugStart:(0,r.register)("debug-start",60115),debugStepInto:(0,r.register)("debug-step-into",60116),debugStepOut:(0,r.register)("debug-step-out",60117),debugStepOver:(0,r.register)("debug-step-over",60118),debugStop:(0,r.register)("debug-stop",60119),debug:(0,r.register)("debug",60120),deviceCameraVideo:(0,r.register)("device-camera-video",60121),deviceCamera:(0,r.register)("device-camera",60122),deviceMobile:(0,r.register)("device-mobile",60123),diffAdded:(0,r.register)("diff-added",60124),diffIgnored:(0,r.register)("diff-ignored",60125),diffModified:(0,r.register)("diff-modified",60126),diffRemoved:(0,r.register)("diff-removed",60127),diffRenamed:(0,r.register)("diff-renamed",60128),diff:(0,r.register)("diff",60129),discard:(0,r.register)("discard",60130),editorLayout:(0,r.register)("editor-layout",60131),emptyWindow:(0,r.register)("empty-window",60132),exclude:(0,r.register)("exclude",60133),extensions:(0,r.register)("extensions",60134),eyeClosed:(0,r.register)("eye-closed",60135),fileBinary:(0,r.register)("file-binary",60136),fileCode:(0,r.register)("file-code",60137),fileMedia:(0,r.register)("file-media",60138),filePdf:(0,r.register)("file-pdf",60139),fileSubmodule:(0,r.register)("file-submodule",60140),fileSymlinkDirectory:(0,r.register)("file-symlink-directory",60141),fileSymlinkFile:(0,r.register)("file-symlink-file",60142),fileZip:(0,r.register)("file-zip",60143),files:(0,r.register)("files",60144),filter:(0,r.register)("filter",60145),flame:(0,r.register)("flame",60146),foldDown:(0,r.register)("fold-down",60147),foldUp:(0,r.register)("fold-up",60148),fold:(0,r.register)("fold",60149),folderActive:(0,r.register)("folder-active",60150),folderOpened:(0,r.register)("folder-opened",60151),gear:(0,r.register)("gear",60152),gift:(0,r.register)("gift",60153),gistSecret:(0,r.register)("gist-secret",60154),gist:(0,r.register)("gist",60155),gitCommit:(0,r.register)("git-commit",60156),gitCompare:(0,r.register)("git-compare",60157),gitMerge:(0,r.register)("git-merge",60158),githubAction:(0,r.register)("github-action",60159),githubAlt:(0,r.register)("github-alt",60160),globe:(0,r.register)("globe",60161),grabber:(0,r.register)("grabber",60162),graph:(0,r.register)("graph",60163),gripper:(0,r.register)("gripper",60164),heart:(0,r.register)("heart",60165),home:(0,r.register)("home",60166),horizontalRule:(0,r.register)("horizontal-rule",60167),hubot:(0,r.register)("hubot",60168),inbox:(0,r.register)("inbox",60169),issueClosed:(0,r.register)("issue-closed",60324),issueReopened:(0,r.register)("issue-reopened",60171),issues:(0,r.register)("issues",60172),italic:(0,r.register)("italic",60173),jersey:(0,r.register)("jersey",60174),json:(0,r.register)("json",60175),bracket:(0,r.register)("bracket",60175),kebabVertical:(0,r.register)("kebab-vertical",60176),key:(0,r.register)("key",60177),law:(0,r.register)("law",60178),lightbulbAutofix:(0,r.register)("lightbulb-autofix",60179),linkExternal:(0,r.register)("link-external",60180),link:(0,r.register)("link",60181),listOrdered:(0,r.register)("list-ordered",60182),listUnordered:(0,r.register)("list-unordered",60183),liveShare:(0,r.register)("live-share",60184),loading:(0,r.register)("loading",60185),location:(0,r.register)("location",60186),mailRead:(0,r.register)("mail-read",60187),mail:(0,r.register)("mail",60188),markdown:(0,r.register)("markdown",60189),megaphone:(0,r.register)("megaphone",60190),mention:(0,r.register)("mention",60191),milestone:(0,r.register)("milestone",60192),gitPullRequestMilestone:(0,r.register)("git-pull-request-milestone",60192),mortarBoard:(0,r.register)("mortar-board",60193),move:(0,r.register)("move",60194),multipleWindows:(0,r.register)("multiple-windows",60195),mute:(0,r.register)("mute",60196),noNewline:(0,r.register)("no-newline",60197),note:(0,r.register)("note",60198),octoface:(0,r.register)("octoface",60199),openPreview:(0,r.register)("open-preview",60200),package:(0,r.register)("package",60201),paintcan:(0,r.register)("paintcan",60202),pin:(0,r.register)("pin",60203),play:(0,r.register)("play",60204),run:(0,r.register)("run",60204),plug:(0,r.register)("plug",60205),preserveCase:(0,r.register)("preserve-case",60206),preview:(0,r.register)("preview",60207),project:(0,r.register)("project",60208),pulse:(0,r.register)("pulse",60209),question:(0,r.register)("question",60210),quote:(0,r.register)("quote",60211),radioTower:(0,r.register)("radio-tower",60212),reactions:(0,r.register)("reactions",60213),references:(0,r.register)("references",60214),refresh:(0,r.register)("refresh",60215),regex:(0,r.register)("regex",60216),remoteExplorer:(0,r.register)("remote-explorer",60217),remote:(0,r.register)("remote",60218),remove:(0,r.register)("remove",60219),replaceAll:(0,r.register)("replace-all",60220),replace:(0,r.register)("replace",60221),repoClone:(0,r.register)("repo-clone",60222),repoForcePush:(0,r.register)("repo-force-push",60223),repoPull:(0,r.register)("repo-pull",60224),repoPush:(0,r.register)("repo-push",60225),report:(0,r.register)("report",60226),requestChanges:(0,r.register)("request-changes",60227),rocket:(0,r.register)("rocket",60228),rootFolderOpened:(0,r.register)("root-folder-opened",60229),rootFolder:(0,r.register)("root-folder",60230),rss:(0,r.register)("rss",60231),ruby:(0,r.register)("ruby",60232),saveAll:(0,r.register)("save-all",60233),saveAs:(0,r.register)("save-as",60234),save:(0,r.register)("save",60235),screenFull:(0,r.register)("screen-full",60236),screenNormal:(0,r.register)("screen-normal",60237),searchStop:(0,r.register)("search-stop",60238),server:(0,r.register)("server",60240),settingsGear:(0,r.register)("settings-gear",60241),settings:(0,r.register)("settings",60242),shield:(0,r.register)("shield",60243),smiley:(0,r.register)("smiley",60244),sortPrecedence:(0,r.register)("sort-precedence",60245),splitHorizontal:(0,r.register)("split-horizontal",60246),splitVertical:(0,r.register)("split-vertical",60247),squirrel:(0,r.register)("squirrel",60248),starFull:(0,r.register)("star-full",60249),starHalf:(0,r.register)("star-half",60250),symbolClass:(0,r.register)("symbol-class",60251),symbolColor:(0,r.register)("symbol-color",60252),symbolCustomColor:(0,r.register)("symbol-customcolor",60252),symbolConstant:(0,r.register)("symbol-constant",60253),symbolEnumMember:(0,r.register)("symbol-enum-member",60254),symbolField:(0,r.register)("symbol-field",60255),symbolFile:(0,r.register)("symbol-file",60256),symbolInterface:(0,r.register)("symbol-interface",60257),symbolKeyword:(0,r.register)("symbol-keyword",60258),symbolMisc:(0,r.register)("symbol-misc",60259),symbolOperator:(0,r.register)("symbol-operator",60260),symbolProperty:(0,r.register)("symbol-property",60261),wrench:(0,r.register)("wrench",60261),wrenchSubaction:(0,r.register)("wrench-subaction",60261),symbolSnippet:(0,r.register)("symbol-snippet",60262),tasklist:(0,r.register)("tasklist",60263),telescope:(0,r.register)("telescope",60264),textSize:(0,r.register)("text-size",60265),threeBars:(0,r.register)("three-bars",60266),thumbsdown:(0,r.register)("thumbsdown",60267),thumbsup:(0,r.register)("thumbsup",60268),tools:(0,r.register)("tools",60269),triangleDown:(0,r.register)("triangle-down",60270),triangleLeft:(0,r.register)("triangle-left",60271),triangleRight:(0,r.register)("triangle-right",60272),triangleUp:(0,r.register)("triangle-up",60273),twitter:(0,r.register)("twitter",60274),unfold:(0,r.register)("unfold",60275),unlock:(0,r.register)("unlock",60276),unmute:(0,r.register)("unmute",60277),unverified:(0,r.register)("unverified",60278),verified:(0,r.register)("verified",60279),versions:(0,r.register)("versions",60280),vmActive:(0,r.register)("vm-active",60281),vmOutline:(0,r.register)("vm-outline",60282),vmRunning:(0,r.register)("vm-running",60283),watch:(0,r.register)("watch",60284),whitespace:(0,r.register)("whitespace",60285),wholeWord:(0,r.register)("whole-word",60286),window:(0,r.register)("window",60287),wordWrap:(0,r.register)("word-wrap",60288),zoomIn:(0,r.register)("zoom-in",60289),zoomOut:(0,r.register)("zoom-out",60290),listFilter:(0,r.register)("list-filter",60291),listFlat:(0,r.register)("list-flat",60292),listSelection:(0,r.register)("list-selection",60293),selection:(0,r.register)("selection",60293),listTree:(0,r.register)("list-tree",60294),debugBreakpointFunctionUnverified:(0,r.register)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,r.register)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,r.register)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,r.register)("debug-stackframe-active",60297),circleSmallFilled:(0,r.register)("circle-small-filled",60298),debugStackframeDot:(0,r.register)("debug-stackframe-dot",60298),debugStackframe:(0,r.register)("debug-stackframe",60299),debugStackframeFocused:(0,r.register)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,r.register)("debug-breakpoint-unsupported",60300),symbolString:(0,r.register)("symbol-string",60301),debugReverseContinue:(0,r.register)("debug-reverse-continue",60302),debugStepBack:(0,r.register)("debug-step-back",60303),debugRestartFrame:(0,r.register)("debug-restart-frame",60304),callIncoming:(0,r.register)("call-incoming",60306),callOutgoing:(0,r.register)("call-outgoing",60307),menu:(0,r.register)("menu",60308),expandAll:(0,r.register)("expand-all",60309),feedback:(0,r.register)("feedback",60310),gitPullRequestReviewer:(0,r.register)("git-pull-request-reviewer",60310),groupByRefType:(0,r.register)("group-by-ref-type",60311),ungroupByRefType:(0,r.register)("ungroup-by-ref-type",60312),account:(0,r.register)("account",60313),gitPullRequestAssignee:(0,r.register)("git-pull-request-assignee",60313),bellDot:(0,r.register)("bell-dot",60314),debugConsole:(0,r.register)("debug-console",60315),library:(0,r.register)("library",60316),output:(0,r.register)("output",60317),runAll:(0,r.register)("run-all",60318),syncIgnored:(0,r.register)("sync-ignored",60319),pinned:(0,r.register)("pinned",60320),githubInverted:(0,r.register)("github-inverted",60321),debugAlt:(0,r.register)("debug-alt",60305),serverProcess:(0,r.register)("server-process",60322),serverEnvironment:(0,r.register)("server-environment",60323),pass:(0,r.register)("pass",60324),stopCircle:(0,r.register)("stop-circle",60325),playCircle:(0,r.register)("play-circle",60326),record:(0,r.register)("record",60327),debugAltSmall:(0,r.register)("debug-alt-small",60328),vmConnect:(0,r.register)("vm-connect",60329),cloud:(0,r.register)("cloud",60330),merge:(0,r.register)("merge",60331),exportIcon:(0,r.register)("export",60332),graphLeft:(0,r.register)("graph-left",60333),magnet:(0,r.register)("magnet",60334),notebook:(0,r.register)("notebook",60335),redo:(0,r.register)("redo",60336),checkAll:(0,r.register)("check-all",60337),pinnedDirty:(0,r.register)("pinned-dirty",60338),passFilled:(0,r.register)("pass-filled",60339),circleLargeFilled:(0,r.register)("circle-large-filled",60340),circleLarge:(0,r.register)("circle-large",60341),circleLargeOutline:(0,r.register)("circle-large-outline",60341),combine:(0,r.register)("combine",60342),gather:(0,r.register)("gather",60342),table:(0,r.register)("table",60343),variableGroup:(0,r.register)("variable-group",60344),typeHierarchy:(0,r.register)("type-hierarchy",60345),typeHierarchySub:(0,r.register)("type-hierarchy-sub",60346),typeHierarchySuper:(0,r.register)("type-hierarchy-super",60347),gitPullRequestCreate:(0,r.register)("git-pull-request-create",60348),runAbove:(0,r.register)("run-above",60349),runBelow:(0,r.register)("run-below",60350),notebookTemplate:(0,r.register)("notebook-template",60351),debugRerun:(0,r.register)("debug-rerun",60352),workspaceTrusted:(0,r.register)("workspace-trusted",60353),workspaceUntrusted:(0,r.register)("workspace-untrusted",60354),workspaceUnspecified:(0,r.register)("workspace-unspecified",60355),terminalCmd:(0,r.register)("terminal-cmd",60356),terminalDebian:(0,r.register)("terminal-debian",60357),terminalLinux:(0,r.register)("terminal-linux",60358),terminalPowershell:(0,r.register)("terminal-powershell",60359),terminalTmux:(0,r.register)("terminal-tmux",60360),terminalUbuntu:(0,r.register)("terminal-ubuntu",60361),terminalBash:(0,r.register)("terminal-bash",60362),arrowSwap:(0,r.register)("arrow-swap",60363),copy:(0,r.register)("copy",60364),personAdd:(0,r.register)("person-add",60365),filterFilled:(0,r.register)("filter-filled",60366),wand:(0,r.register)("wand",60367),debugLineByLine:(0,r.register)("debug-line-by-line",60368),inspect:(0,r.register)("inspect",60369),layers:(0,r.register)("layers",60370),layersDot:(0,r.register)("layers-dot",60371),layersActive:(0,r.register)("layers-active",60372),compass:(0,r.register)("compass",60373),compassDot:(0,r.register)("compass-dot",60374),compassActive:(0,r.register)("compass-active",60375),azure:(0,r.register)("azure",60376),issueDraft:(0,r.register)("issue-draft",60377),gitPullRequestClosed:(0,r.register)("git-pull-request-closed",60378),gitPullRequestDraft:(0,r.register)("git-pull-request-draft",60379),debugAll:(0,r.register)("debug-all",60380),debugCoverage:(0,r.register)("debug-coverage",60381),runErrors:(0,r.register)("run-errors",60382),folderLibrary:(0,r.register)("folder-library",60383),debugContinueSmall:(0,r.register)("debug-continue-small",60384),beakerStop:(0,r.register)("beaker-stop",60385),graphLine:(0,r.register)("graph-line",60386),graphScatter:(0,r.register)("graph-scatter",60387),pieChart:(0,r.register)("pie-chart",60388),bracketDot:(0,r.register)("bracket-dot",60389),bracketError:(0,r.register)("bracket-error",60390),lockSmall:(0,r.register)("lock-small",60391),azureDevops:(0,r.register)("azure-devops",60392),verifiedFilled:(0,r.register)("verified-filled",60393),newLine:(0,r.register)("newline",60394),layout:(0,r.register)("layout",60395),layoutActivitybarLeft:(0,r.register)("layout-activitybar-left",60396),layoutActivitybarRight:(0,r.register)("layout-activitybar-right",60397),layoutPanelLeft:(0,r.register)("layout-panel-left",60398),layoutPanelCenter:(0,r.register)("layout-panel-center",60399),layoutPanelJustify:(0,r.register)("layout-panel-justify",60400),layoutPanelRight:(0,r.register)("layout-panel-right",60401),layoutPanel:(0,r.register)("layout-panel",60402),layoutSidebarLeft:(0,r.register)("layout-sidebar-left",60403),layoutSidebarRight:(0,r.register)("layout-sidebar-right",60404),layoutStatusbar:(0,r.register)("layout-statusbar",60405),layoutMenubar:(0,r.register)("layout-menubar",60406),layoutCentered:(0,r.register)("layout-centered",60407),layoutSidebarRightOff:(0,r.register)("layout-sidebar-right-off",60416),layoutPanelOff:(0,r.register)("layout-panel-off",60417),layoutSidebarLeftOff:(0,r.register)("layout-sidebar-left-off",60418),target:(0,r.register)("target",60408),indent:(0,r.register)("indent",60409),recordSmall:(0,r.register)("record-small",60410),errorSmall:(0,r.register)("error-small",60411),arrowCircleDown:(0,r.register)("arrow-circle-down",60412),arrowCircleLeft:(0,r.register)("arrow-circle-left",60413),arrowCircleRight:(0,r.register)("arrow-circle-right",60414),arrowCircleUp:(0,r.register)("arrow-circle-up",60415),heartFilled:(0,r.register)("heart-filled",60420),map:(0,r.register)("map",60421),mapFilled:(0,r.register)("map-filled",60422),circleSmall:(0,r.register)("circle-small",60423),bellSlash:(0,r.register)("bell-slash",60424),bellSlashDot:(0,r.register)("bell-slash-dot",60425),commentUnresolved:(0,r.register)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,r.register)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,r.register)("git-pull-request-new-changes",60428),searchFuzzy:(0,r.register)("search-fuzzy",60429),commentDraft:(0,r.register)("comment-draft",60430),send:(0,r.register)("send",60431),sparkle:(0,r.register)("sparkle",60432),insert:(0,r.register)("insert",60433),mic:(0,r.register)("mic",60434),thumbsDownFilled:(0,r.register)("thumbsdown-filled",60435),thumbsUpFilled:(0,r.register)("thumbsup-filled",60436),coffee:(0,r.register)("coffee",60437),snake:(0,r.register)("snake",60438),game:(0,r.register)("game",60439),vr:(0,r.register)("vr",60440),chip:(0,r.register)("chip",60441),piano:(0,r.register)("piano",60442),music:(0,r.register)("music",60443),micFilled:(0,r.register)("mic-filled",60444),gitFetch:(0,r.register)("git-fetch",60445),copilot:(0,r.register)("copilot",60446),lightbulbSparkle:(0,r.register)("lightbulb-sparkle",60447),lightbulbSparkleAutofix:(0,r.register)("lightbulb-sparkle-autofix",60447),robot:(0,r.register)("robot",60448),sparkleFilled:(0,r.register)("sparkle-filled",60449),diffSingle:(0,r.register)("diff-single",60450),diffMultiple:(0,r.register)("diff-multiple",60451),surroundWith:(0,r.register)("surround-with",60452),gitStash:(0,r.register)("git-stash",60454),gitStashApply:(0,r.register)("git-stash-apply",60455),gitStashPop:(0,r.register)("git-stash-pop",60456),runAllCoverage:(0,r.register)("run-all-coverage",60461),runCoverage:(0,r.register)("run-all-coverage",60460),coverage:(0,r.register)("coverage",60462),githubProject:(0,r.register)("github-project",60463)}}),X(Z[42],K([0,1,26,41]),function(q,t,r,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Codicon=t.codiconsDerived=void 0,t.codiconsDerived={dialogError:(0,r.register)("dialog-error","error"),dialogWarning:(0,r.register)("dialog-warning","warning"),dialogInfo:(0,r.register)("dialog-info","info"),dialogClose:(0,r.register)("dialog-close","close"),treeItemExpanded:(0,r.register)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,r.register)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,r.register)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,r.register)("tree-filter-clear","close"),treeItemLoading:(0,r.register)("tree-item-loading","loading"),menuSelection:(0,r.register)("menu-selection","check"),menuSubmenu:(0,r.register)("menu-submenu","chevron-right"),menuBarMore:(0,r.register)("menubar-more","more"),scrollbarButtonLeft:(0,r.register)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,r.register)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,r.register)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,r.register)("scrollbar-button-down","triangle-down"),toolBarMore:(0,r.register)("toolbar-more","more"),quickInputBack:(0,r.register)("quick-input-back","arrow-left")},t.Codicon={...M.codiconsLibrary,...t.codiconsDerived}}),X(Z[14],K([0,1,25]),function(q,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function M(o){if(!o||typeof o!="object"||o instanceof RegExp)return o;const u=Array.isArray(o)?[]:{};return Object.entries(o).forEach(([m,c])=>{u[m]=c&&typeof c=="object"?M(c):c}),u}t.deepClone=M;function R(o){if(!o||typeof o!="object")return o;const u=[o];for(;u.length>0;){const m=u.shift();Object.freeze(m);for(const c in m)if(d.call(m,c)){const y=m[c];typeof y=="object"&&!Object.isFrozen(y)&&!(0,r.isTypedArray)(y)&&u.push(y)}}return o}t.deepFreeze=R;const d=Object.prototype.hasOwnProperty;function v(o,u){return L(o,u,new Set)}t.cloneAndChange=v;function L(o,u,m){if((0,r.isUndefinedOrNull)(o))return o;const c=u(o);if(typeof c<"u")return c;if(Array.isArray(o)){const y=[];for(const C of o)y.push(L(C,u,m));return y}if((0,r.isObject)(o)){if(m.has(o))throw new Error("Cannot clone recursive data-structure");m.add(o);const y={};for(const C in o)d.call(o,C)&&(y[C]=L(o[C],u,m));return m.delete(o),y}return o}function h(o,u,m=!0){return(0,r.isObject)(o)?((0,r.isObject)(u)&&Object.keys(u).forEach(c=>{c in o?m&&((0,r.isObject)(o[c])&&(0,r.isObject)(u[c])?h(o[c],u[c],m):o[c]=u[c]):o[c]=u[c]}),o):u}t.mixin=h;function l(o,u){if(o===u)return!0;if(o==null||u===null||u===void 0||typeof o!=typeof u||typeof o!="object"||Array.isArray(o)!==Array.isArray(u))return!1;let m,c;if(Array.isArray(o)){if(o.length!==u.length)return!1;for(m=0;m<o.length;m++)if(!l(o[m],u[m]))return!1}else{const y=[];for(c in o)y.push(c);y.sort();const C=[];for(c in u)C.push(c);if(C.sort(),!l(y,C))return!1;for(m=0;m<y.length;m++)if(!l(o[y[m]],u[y[m]]))return!1}return!0}t.equals=l;function w(o){let u=[];for(;Object.prototype!==o;)u=u.concat(Object.getOwnPropertyNames(o)),o=Object.getPrototypeOf(o);return u}t.getAllPropertyNames=w;function e(o){const u=[];for(const m of w(o))typeof o[m]=="function"&&u.push(m);return u}t.getAllMethodNames=e;function s(o,u){const m=y=>function(){const C=Array.prototype.slice.call(arguments,0);return u(y,C)},c={};for(const y of o)c[y]=m(y);return c}t.createProxyObject=s}),X(Z[27],K([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toUint32=t.toUint8=void 0;function r(R){return R<0?0:R>255?255:R|0}t.toUint8=r;function M(R){return R<0?0:R>4294967295?4294967295:R|0}t.toUint32=M}),X(Z[28],K([0,1,27]),function(q,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CharacterSet=t.CharacterClassifier=void 0;class M{constructor(v){const L=(0,r.toUint8)(v);this._defaultValue=L,this._asciiMap=M._createAsciiMap(L),this._map=new Map}static _createAsciiMap(v){const L=new Uint8Array(256);return L.fill(v),L}set(v,L){const h=(0,r.toUint8)(L);v>=0&&v<256?this._asciiMap[v]=h:this._map.set(v,h)}get(v){return v>=0&&v<256?this._asciiMap[v]:this._map.get(v)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}t.CharacterClassifier=M;class R{constructor(){this._actual=new M(0)}add(v){this._actual.set(v,1)}has(v){return this._actual.get(v)===1}clear(){return this._actual.clear()}}t.CharacterSet=R}),X(Z[3],K([0,1,5]),function(q,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OffsetRangeSet=t.OffsetRange=void 0;class M{static addRange(v,L){let h=0;for(;h<L.length&&L[h].endExclusive<v.start;)h++;let l=h;for(;l<L.length&&L[l].start<=v.endExclusive;)l++;if(h===l)L.splice(h,0,v);else{const w=Math.min(v.start,L[h].start),e=Math.max(v.endExclusive,L[l-1].endExclusive);L.splice(h,l-h,new M(w,e))}}static ofLength(v){return new M(0,v)}static ofStartAndLength(v,L){return new M(v,v+L)}constructor(v,L){if(this.start=v,this.endExclusive=L,v>L)throw new r.BugIndicatingError(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(v){return new M(this.start+v,this.endExclusive+v)}deltaStart(v){return new M(this.start+v,this.endExclusive)}deltaEnd(v){return new M(this.start,this.endExclusive+v)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}contains(v){return this.start<=v&&v<this.endExclusive}join(v){return new M(Math.min(this.start,v.start),Math.max(this.endExclusive,v.endExclusive))}intersect(v){const L=Math.max(this.start,v.start),h=Math.min(this.endExclusive,v.endExclusive);if(L<=h)return new M(L,h)}intersects(v){const L=Math.max(this.start,v.start),h=Math.min(this.endExclusive,v.endExclusive);return L<h}isBefore(v){return this.endExclusive<=v.start}isAfter(v){return this.start>=v.endExclusive}slice(v){return v.slice(this.start,this.endExclusive)}clip(v){if(this.isEmpty)throw new r.BugIndicatingError(`Invalid clipping range: ${this.toString()}`);return Math.max(this.start,Math.min(this.endExclusive-1,v))}clipCyclic(v){if(this.isEmpty)throw new r.BugIndicatingError(`Invalid clipping range: ${this.toString()}`);return v<this.start?this.endExclusive-(this.start-v)%this.length:v>=this.endExclusive?this.start+(v-this.start)%this.length:v}forEach(v){for(let L=this.start;L<this.endExclusive;L++)v(L)}}t.OffsetRange=M;class R{constructor(){this._sortedRanges=[]}addRange(v){let L=0;for(;L<this._sortedRanges.length&&this._sortedRanges[L].endExclusive<v.start;)L++;let h=L;for(;h<this._sortedRanges.length&&this._sortedRanges[h].start<=v.endExclusive;)h++;if(L===h)this._sortedRanges.splice(L,0,v);else{const l=Math.min(v.start,this._sortedRanges[L].start),w=Math.max(v.endExclusive,this._sortedRanges[h-1].endExclusive);this._sortedRanges.splice(L,h-L,new M(l,w))}}toString(){return this._sortedRanges.map(v=>v.toString()).join(", ")}intersectsStrict(v){let L=0;for(;L<this._sortedRanges.length&&this._sortedRanges[L].endExclusive<=v.start;)L++;return L<this._sortedRanges.length&&this._sortedRanges[L].start<v.endExclusive}intersectWithRange(v){const L=new R;for(const h of this._sortedRanges){const l=h.intersect(v);l&&L.addRange(l)}return L}intersectWithRangeLength(v){return this.intersectWithRange(v).length}get length(){return this._sortedRanges.reduce((v,L)=>v+L.length,0)}}t.OffsetRangeSet=R}),X(Z[4],K([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Position=void 0;class r{constructor(R,d){this.lineNumber=R,this.column=d}with(R=this.lineNumber,d=this.column){return R===this.lineNumber&&d===this.column?this:new r(R,d)}delta(R=0,d=0){return this.with(this.lineNumber+R,this.column+d)}equals(R){return r.equals(this,R)}static equals(R,d){return!R&&!d?!0:!!R&&!!d&&R.lineNumber===d.lineNumber&&R.column===d.column}isBefore(R){return r.isBefore(this,R)}static isBefore(R,d){return R.lineNumber<d.lineNumber?!0:d.lineNumber<R.lineNumber?!1:R.column<d.column}isBeforeOrEqual(R){return r.isBeforeOrEqual(this,R)}static isBeforeOrEqual(R,d){return R.lineNumber<d.lineNumber?!0:d.lineNumber<R.lineNumber?!1:R.column<=d.column}static compare(R,d){const v=R.lineNumber|0,L=d.lineNumber|0;if(v===L){const h=R.column|0,l=d.column|0;return h-l}return v-L}clone(){return new r(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(R){return new r(R.lineNumber,R.column)}static isIPosition(R){return R&&typeof R.lineNumber=="number"&&typeof R.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}t.Position=r}),X(Z[2],K([0,1,4]),function(q,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;class M{constructor(d,v,L,h){d>L||d===L&&v>h?(this.startLineNumber=L,this.startColumn=h,this.endLineNumber=d,this.endColumn=v):(this.startLineNumber=d,this.startColumn=v,this.endLineNumber=L,this.endColumn=h)}isEmpty(){return M.isEmpty(this)}static isEmpty(d){return d.startLineNumber===d.endLineNumber&&d.startColumn===d.endColumn}containsPosition(d){return M.containsPosition(this,d)}static containsPosition(d,v){return!(v.lineNumber<d.startLineNumber||v.lineNumber>d.endLineNumber||v.lineNumber===d.startLineNumber&&v.column<d.startColumn||v.lineNumber===d.endLineNumber&&v.column>d.endColumn)}static strictContainsPosition(d,v){return!(v.lineNumber<d.startLineNumber||v.lineNumber>d.endLineNumber||v.lineNumber===d.startLineNumber&&v.column<=d.startColumn||v.lineNumber===d.endLineNumber&&v.column>=d.endColumn)}containsRange(d){return M.containsRange(this,d)}static containsRange(d,v){return!(v.startLineNumber<d.startLineNumber||v.endLineNumber<d.startLineNumber||v.startLineNumber>d.endLineNumber||v.endLineNumber>d.endLineNumber||v.startLineNumber===d.startLineNumber&&v.startColumn<d.startColumn||v.endLineNumber===d.endLineNumber&&v.endColumn>d.endColumn)}strictContainsRange(d){return M.strictContainsRange(this,d)}static strictContainsRange(d,v){return!(v.startLineNumber<d.startLineNumber||v.endLineNumber<d.startLineNumber||v.startLineNumber>d.endLineNumber||v.endLineNumber>d.endLineNumber||v.startLineNumber===d.startLineNumber&&v.startColumn<=d.startColumn||v.endLineNumber===d.endLineNumber&&v.endColumn>=d.endColumn)}plusRange(d){return M.plusRange(this,d)}static plusRange(d,v){let L,h,l,w;return v.startLineNumber<d.startLineNumber?(L=v.startLineNumber,h=v.startColumn):v.startLineNumber===d.startLineNumber?(L=v.startLineNumber,h=Math.min(v.startColumn,d.startColumn)):(L=d.startLineNumber,h=d.startColumn),v.endLineNumber>d.endLineNumber?(l=v.endLineNumber,w=v.endColumn):v.endLineNumber===d.endLineNumber?(l=v.endLineNumber,w=Math.max(v.endColumn,d.endColumn)):(l=d.endLineNumber,w=d.endColumn),new M(L,h,l,w)}intersectRanges(d){return M.intersectRanges(this,d)}static intersectRanges(d,v){let L=d.startLineNumber,h=d.startColumn,l=d.endLineNumber,w=d.endColumn;const e=v.startLineNumber,s=v.startColumn,o=v.endLineNumber,u=v.endColumn;return L<e?(L=e,h=s):L===e&&(h=Math.max(h,s)),l>o?(l=o,w=u):l===o&&(w=Math.min(w,u)),L>l||L===l&&h>w?null:new M(L,h,l,w)}equalsRange(d){return M.equalsRange(this,d)}static equalsRange(d,v){return!d&&!v?!0:!!d&&!!v&&d.startLineNumber===v.startLineNumber&&d.startColumn===v.startColumn&&d.endLineNumber===v.endLineNumber&&d.endColumn===v.endColumn}getEndPosition(){return M.getEndPosition(this)}static getEndPosition(d){return new r.Position(d.endLineNumber,d.endColumn)}getStartPosition(){return M.getStartPosition(this)}static getStartPosition(d){return new r.Position(d.startLineNumber,d.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(d,v){return new M(this.startLineNumber,this.startColumn,d,v)}setStartPosition(d,v){return new M(d,v,this.endLineNumber,this.endColumn)}collapseToStart(){return M.collapseToStart(this)}static collapseToStart(d){return new M(d.startLineNumber,d.startColumn,d.startLineNumber,d.startColumn)}collapseToEnd(){return M.collapseToEnd(this)}static collapseToEnd(d){return new M(d.endLineNumber,d.endColumn,d.endLineNumber,d.endColumn)}delta(d){return new M(this.startLineNumber+d,this.startColumn,this.endLineNumber+d,this.endColumn)}static fromPositions(d,v=d){return new M(d.lineNumber,d.column,v.lineNumber,v.column)}static lift(d){return d?new M(d.startLineNumber,d.startColumn,d.endLineNumber,d.endColumn):null}static isIRange(d){return d&&typeof d.startLineNumber=="number"&&typeof d.startColumn=="number"&&typeof d.endLineNumber=="number"&&typeof d.endColumn=="number"}static areIntersectingOrTouching(d,v){return!(d.endLineNumber<v.startLineNumber||d.endLineNumber===v.startLineNumber&&d.endColumn<v.startColumn||v.endLineNumber<d.startLineNumber||v.endLineNumber===d.startLineNumber&&v.endColumn<d.startColumn)}static areIntersecting(d,v){return!(d.endLineNumber<v.startLineNumber||d.endLineNumber===v.startLineNumber&&d.endColumn<=v.startColumn||v.endLineNumber<d.startLineNumber||v.endLineNumber===d.startLineNumber&&v.endColumn<=d.startColumn)}static compareRangesUsingStarts(d,v){if(d&&v){const l=d.startLineNumber|0,w=v.startLineNumber|0;if(l===w){const e=d.startColumn|0,s=v.startColumn|0;if(e===s){const o=d.endLineNumber|0,u=v.endLineNumber|0;if(o===u){const m=d.endColumn|0,c=v.endColumn|0;return m-c}return o-u}return e-s}return l-w}return(d?1:0)-(v?1:0)}static compareRangesUsingEnds(d,v){return d.endLineNumber===v.endLineNumber?d.endColumn===v.endColumn?d.startLineNumber===v.startLineNumber?d.startColumn-v.startColumn:d.startLineNumber-v.startLineNumber:d.endColumn-v.endColumn:d.endLineNumber-v.endLineNumber}static spansMultipleLines(d){return d.endLineNumber>d.startLineNumber}toJSON(){return this}}t.Range=M}),X(Z[10],K([0,1,5,3,2,11]),function(q,t,r,M,R,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineRangeSet=t.LineRange=void 0;class v{static fromRangeInclusive(l){return new v(l.startLineNumber,l.endLineNumber+1)}static joinMany(l){if(l.length===0)return[];let w=new L(l[0].slice());for(let e=1;e<l.length;e++)w=w.getUnion(new L(l[e].slice()));return w.ranges}static ofLength(l,w){return new v(l,l+w)}static deserialize(l){return new v(l[0],l[1])}constructor(l,w){if(l>w)throw new r.BugIndicatingError(`startLineNumber ${l} cannot be after endLineNumberExclusive ${w}`);this.startLineNumber=l,this.endLineNumberExclusive=w}contains(l){return this.startLineNumber<=l&&l<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(l){return new v(this.startLineNumber+l,this.endLineNumberExclusive+l)}deltaLength(l){return new v(this.startLineNumber,this.endLineNumberExclusive+l)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(l){return new v(Math.min(this.startLineNumber,l.startLineNumber),Math.max(this.endLineNumberExclusive,l.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(l){const w=Math.max(this.startLineNumber,l.startLineNumber),e=Math.min(this.endLineNumberExclusive,l.endLineNumberExclusive);if(w<=e)return new v(w,e)}intersectsStrict(l){return this.startLineNumber<l.endLineNumberExclusive&&l.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(l){return this.startLineNumber<=l.endLineNumberExclusive&&l.startLineNumber<=this.endLineNumberExclusive}equals(l){return this.startLineNumber===l.startLineNumber&&this.endLineNumberExclusive===l.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new R.Range(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new R.Range(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(l){const w=[];for(let e=this.startLineNumber;e<this.endLineNumberExclusive;e++)w.push(l(e));return w}forEach(l){for(let w=this.startLineNumber;w<this.endLineNumberExclusive;w++)l(w)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(l){return this.startLineNumber<=l&&l<this.endLineNumberExclusive}toOffsetRange(){return new M.OffsetRange(this.startLineNumber-1,this.endLineNumberExclusive-1)}}t.LineRange=v;class L{constructor(l=[]){this._normalizedRanges=l}get ranges(){return this._normalizedRanges}addRange(l){if(l.length===0)return;const w=(0,d.findFirstIdxMonotonousOrArrLen)(this._normalizedRanges,s=>s.endLineNumberExclusive>=l.startLineNumber),e=(0,d.findLastIdxMonotonous)(this._normalizedRanges,s=>s.startLineNumber<=l.endLineNumberExclusive)+1;if(w===e)this._normalizedRanges.splice(w,0,l);else if(w===e-1){const s=this._normalizedRanges[w];this._normalizedRanges[w]=s.join(l)}else{const s=this._normalizedRanges[w].join(this._normalizedRanges[e-1]).join(l);this._normalizedRanges.splice(w,e-w,s)}}contains(l){const w=(0,d.findLastMonotonous)(this._normalizedRanges,e=>e.startLineNumber<=l);return!!w&&w.endLineNumberExclusive>l}intersects(l){const w=(0,d.findLastMonotonous)(this._normalizedRanges,e=>e.startLineNumber<l.endLineNumberExclusive);return!!w&&w.endLineNumberExclusive>l.startLineNumber}getUnion(l){if(this._normalizedRanges.length===0)return l;if(l._normalizedRanges.length===0)return this;const w=[];let e=0,s=0,o=null;for(;e<this._normalizedRanges.length||s<l._normalizedRanges.length;){let u=null;if(e<this._normalizedRanges.length&&s<l._normalizedRanges.length){const m=this._normalizedRanges[e],c=l._normalizedRanges[s];m.startLineNumber<c.startLineNumber?(u=m,e++):(u=c,s++)}else e<this._normalizedRanges.length?(u=this._normalizedRanges[e],e++):(u=l._normalizedRanges[s],s++);o===null?o=u:o.endLineNumberExclusive>=u.startLineNumber?o=new v(o.startLineNumber,Math.max(o.endLineNumberExclusive,u.endLineNumberExclusive)):(w.push(o),o=u)}return o!==null&&w.push(o),new L(w)}subtractFrom(l){const w=(0,d.findFirstIdxMonotonousOrArrLen)(this._normalizedRanges,u=>u.endLineNumberExclusive>=l.startLineNumber),e=(0,d.findLastIdxMonotonous)(this._normalizedRanges,u=>u.startLineNumber<=l.endLineNumberExclusive)+1;if(w===e)return new L([l]);const s=[];let o=l.startLineNumber;for(let u=w;u<e;u++){const m=this._normalizedRanges[u];m.startLineNumber>o&&s.push(new v(o,m.startLineNumber)),o=m.endLineNumberExclusive}return o<l.endLineNumberExclusive&&s.push(new v(o,l.endLineNumberExclusive)),new L(s)}toString(){return this._normalizedRanges.map(l=>l.toString()).join(", ")}getIntersection(l){const w=[];let e=0,s=0;for(;e<this._normalizedRanges.length&&s<l._normalizedRanges.length;){const o=this._normalizedRanges[e],u=l._normalizedRanges[s],m=o.intersect(u);m&&!m.isEmpty&&w.push(m),o.endLineNumberExclusive<u.endLineNumberExclusive?e++:s++}return new L(w)}getWithDelta(l){return new L(this._normalizedRanges.map(w=>w.delta(l)))}}t.LineRangeSet=L}),X(Z[43],K([0,1,4,2]),function(q,t,r,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Selection=void 0;class R extends M.Range{constructor(v,L,h,l){super(v,L,h,l),this.selectionStartLineNumber=v,this.selectionStartColumn=L,this.positionLineNumber=h,this.positionColumn=l}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(v){return R.selectionsEqual(this,v)}static selectionsEqual(v,L){return v.selectionStartLineNumber===L.selectionStartLineNumber&&v.selectionStartColumn===L.selectionStartColumn&&v.positionLineNumber===L.positionLineNumber&&v.positionColumn===L.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(v,L){return this.getDirection()===0?new R(this.startLineNumber,this.startColumn,v,L):new R(v,L,this.startLineNumber,this.startColumn)}getPosition(){return new r.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new r.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(v,L){return this.getDirection()===0?new R(v,L,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,v,L)}static fromPositions(v,L=v){return new R(v.lineNumber,v.column,L.lineNumber,L.column)}static fromRange(v,L){return L===0?new R(v.startLineNumber,v.startColumn,v.endLineNumber,v.endColumn):new R(v.endLineNumber,v.endColumn,v.startLineNumber,v.startColumn)}static liftSelection(v){return new R(v.selectionStartLineNumber,v.selectionStartColumn,v.positionLineNumber,v.positionColumn)}static selectionsArrEqual(v,L){if(v&&!L||!v&&L)return!1;if(!v&&!L)return!0;if(v.length!==L.length)return!1;for(let h=0,l=v.length;h<l;h++)if(!this.selectionsEqual(v[h],L[h]))return!1;return!0}static isISelection(v){return v&&typeof v.selectionStartLineNumber=="number"&&typeof v.selectionStartColumn=="number"&&typeof v.positionLineNumber=="number"&&typeof v.positionColumn=="number"}static createWithDirection(v,L,h,l,w){return w===0?new R(v,L,h,l):new R(h,l,v,L)}}t.Selection=R}),X(Z[44],K([0,1,28]),function(q,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMapForWordSeparators=t.WordCharacterClassifier=void 0;class M extends r.CharacterClassifier{constructor(v){super(0);for(let L=0,h=v.length;L<h;L++)this.set(v.charCodeAt(L),2);this.set(32,1),this.set(9,1)}}t.WordCharacterClassifier=M;function R(d){const v={};return L=>(v.hasOwnProperty(L)||(v[L]=d(L)),v[L])}t.getMapForWordSeparators=R(d=>new M(d))}),X(Z[29],K([0,1,21,22]),function(q,t,r,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getWordAtText=t.ensureValidWordDefinition=t.DEFAULT_WORD_REGEXP=t.USUAL_WORD_SEPARATORS=void 0,t.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(l=""){let w="(-?\\d*\\.\\d\\w*)|([^";for(const e of t.USUAL_WORD_SEPARATORS)l.indexOf(e)>=0||(w+="\\"+e);return w+="\\s]+)",new RegExp(w,"g")}t.DEFAULT_WORD_REGEXP=R();function d(l){let w=t.DEFAULT_WORD_REGEXP;if(l&&l instanceof RegExp)if(l.global)w=l;else{let e="g";l.ignoreCase&&(e+="i"),l.multiline&&(e+="m"),l.unicode&&(e+="u"),w=new RegExp(l.source,e)}return w.lastIndex=0,w}t.ensureValidWordDefinition=d;const v=new M.LinkedList;v.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function L(l,w,e,s,o){if(w=d(w),o||(o=r.Iterable.first(v)),e.length>o.maxLen){let C=l-o.maxLen/2;return C<0?C=0:s+=C,e=e.substring(C,l+o.maxLen/2),L(l,w,e,s,o)}const u=Date.now(),m=l-1-s;let c=-1,y=null;for(let C=1;!(Date.now()-u>=o.timeBudget);C++){const E=m-o.windowSize*C;w.lastIndex=Math.max(0,E);const S=h(w,e,m,c);if(!S&&y||(y=S,E<=0))break;c=E}if(y){const C={word:y[0],startColumn:s+1+y.index,endColumn:s+1+y.index+y[0].length};return w.lastIndex=0,C}return null}t.getWordAtText=L;function h(l,w,e,s){let o;for(;o=l.exec(w);){const u=o.index||0;if(u<=e&&l.lastIndex>=e)return o;if(s>0&&u>s)return null}return null}}),X(Z[8],K([0,1,7,5,3]),function(q,t,r,M,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DateTimeout=t.InfiniteTimeout=t.OffsetPair=t.SequenceDiff=t.DiffAlgorithmResult=void 0;class d{static trivial(e,s){return new d([new v(R.OffsetRange.ofLength(e.length),R.OffsetRange.ofLength(s.length))],!1)}static trivialTimedOut(e,s){return new d([new v(R.OffsetRange.ofLength(e.length),R.OffsetRange.ofLength(s.length))],!0)}constructor(e,s){this.diffs=e,this.hitTimeout=s}}t.DiffAlgorithmResult=d;class v{static invert(e,s){const o=[];return(0,r.forEachAdjacent)(e,(u,m)=>{o.push(v.fromOffsetPairs(u?u.getEndExclusives():L.zero,m?m.getStarts():new L(s,(u?u.seq2Range.endExclusive-u.seq1Range.endExclusive:0)+s)))}),o}static fromOffsetPairs(e,s){return new v(new R.OffsetRange(e.offset1,s.offset1),new R.OffsetRange(e.offset2,s.offset2))}constructor(e,s){this.seq1Range=e,this.seq2Range=s}swap(){return new v(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(e){return new v(this.seq1Range.join(e.seq1Range),this.seq2Range.join(e.seq2Range))}delta(e){return e===0?this:new v(this.seq1Range.delta(e),this.seq2Range.delta(e))}deltaStart(e){return e===0?this:new v(this.seq1Range.deltaStart(e),this.seq2Range.deltaStart(e))}deltaEnd(e){return e===0?this:new v(this.seq1Range.deltaEnd(e),this.seq2Range.deltaEnd(e))}intersect(e){const s=this.seq1Range.intersect(e.seq1Range),o=this.seq2Range.intersect(e.seq2Range);if(!(!s||!o))return new v(s,o)}getStarts(){return new L(this.seq1Range.start,this.seq2Range.start)}getEndExclusives(){return new L(this.seq1Range.endExclusive,this.seq2Range.endExclusive)}}t.SequenceDiff=v;class L{constructor(e,s){this.offset1=e,this.offset2=s}toString(){return`${this.offset1} <-> ${this.offset2}`}delta(e){return e===0?this:new L(this.offset1+e,this.offset2+e)}equals(e){return this.offset1===e.offset1&&this.offset2===e.offset2}}t.OffsetPair=L,L.zero=new L(0,0),L.max=new L(Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER);class h{isValid(){return!0}}t.InfiniteTimeout=h,h.instance=new h;class l{constructor(e){if(this.timeout=e,this.startTime=Date.now(),this.valid=!0,e<=0)throw new M.BugIndicatingError("timeout must be positive")}isValid(){if(!(Date.now()-this.startTime<this.timeout)&&this.valid){this.valid=!1;debugger}return this.valid}}t.DateTimeout=l}),X(Z[30],K([0,1,3,8]),function(q,t,r,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MyersDiffAlgorithm=void 0;class R{compute(l,w,e=M.InfiniteTimeout.instance){if(l.length===0||w.length===0)return M.DiffAlgorithmResult.trivial(l,w);const s=l,o=w;function u(a,g){for(;a<s.length&&g<o.length&&s.getElement(a)===o.getElement(g);)a++,g++;return a}let m=0;const c=new v;c.set(0,u(0,0));const y=new L;y.set(0,c.get(0)===0?null:new d(null,0,0,c.get(0)));let C=0;e:for(;;){if(m++,!e.isValid())return M.DiffAlgorithmResult.trivialTimedOut(s,o);const a=-Math.min(m,o.length+m%2),g=Math.min(m,s.length+m%2);for(C=a;C<=g;C+=2){let b=0;const f=C===g?-1:c.get(C+1),p=C===a?-1:c.get(C-1)+1;b++;const N=Math.min(Math.max(f,p),s.length),A=N-C;if(b++,N>s.length||A>o.length)continue;const D=u(N,A);c.set(C,D);const P=N===f?y.get(C+1):y.get(C-1);if(y.set(C,D!==N?new d(P,N,A,D-N):P),c.get(C)===s.length&&c.get(C)-C===o.length)break e}}let E=y.get(C);const S=[];let _=s.length,i=o.length;for(;;){const a=E?E.x+E.length:0,g=E?E.y+E.length:0;if((a!==_||g!==i)&&S.push(new M.SequenceDiff(new r.OffsetRange(a,_),new r.OffsetRange(g,i))),!E)break;_=E.x,i=E.y,E=E.prev}return S.reverse(),new M.DiffAlgorithmResult(S,!1)}}t.MyersDiffAlgorithm=R;class d{constructor(l,w,e,s){this.prev=l,this.x=w,this.y=e,this.length=s}}class v{constructor(){this.positiveArr=new Int32Array(10),this.negativeArr=new Int32Array(10)}get(l){return l<0?(l=-l-1,this.negativeArr[l]):this.positiveArr[l]}set(l,w){if(l<0){if(l=-l-1,l>=this.negativeArr.length){const e=this.negativeArr;this.negativeArr=new Int32Array(e.length*2),this.negativeArr.set(e)}this.negativeArr[l]=w}else{if(l>=this.positiveArr.length){const e=this.positiveArr;this.positiveArr=new Int32Array(e.length*2),this.positiveArr.set(e)}this.positiveArr[l]=w}}}class L{constructor(){this.positiveArr=[],this.negativeArr=[]}get(l){return l<0?(l=-l-1,this.negativeArr[l]):this.positiveArr[l]}set(l,w){l<0?(l=-l-1,this.negativeArr[l]=w):this.positiveArr[l]=w}}}),X(Z[45],K([0,1,7,3,8]),function(q,t,r,M,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.removeVeryShortMatchingTextBetweenLongDiffs=t.removeVeryShortMatchingLinesBetweenDiffs=t.extendDiffsToEntireWordIfAppropriate=t.removeShortMatches=t.optimizeSequenceDiffs=void 0;function d(u,m,c){let y=c;return y=v(u,m,y),y=v(u,m,y),y=L(u,m,y),y}t.optimizeSequenceDiffs=d;function v(u,m,c){if(c.length===0)return c;const y=[];y.push(c[0]);for(let E=1;E<c.length;E++){const S=y[y.length-1];let _=c[E];if(_.seq1Range.isEmpty||_.seq2Range.isEmpty){const i=_.seq1Range.start-S.seq1Range.endExclusive;let a;for(a=1;a<=i&&!(u.getElement(_.seq1Range.start-a)!==u.getElement(_.seq1Range.endExclusive-a)||m.getElement(_.seq2Range.start-a)!==m.getElement(_.seq2Range.endExclusive-a));a++);if(a--,a===i){y[y.length-1]=new R.SequenceDiff(new M.OffsetRange(S.seq1Range.start,_.seq1Range.endExclusive-i),new M.OffsetRange(S.seq2Range.start,_.seq2Range.endExclusive-i));continue}_=_.delta(-a)}y.push(_)}const C=[];for(let E=0;E<y.length-1;E++){const S=y[E+1];let _=y[E];if(_.seq1Range.isEmpty||_.seq2Range.isEmpty){const i=S.seq1Range.start-_.seq1Range.endExclusive;let a;for(a=0;a<i&&!(!u.isStronglyEqual(_.seq1Range.start+a,_.seq1Range.endExclusive+a)||!m.isStronglyEqual(_.seq2Range.start+a,_.seq2Range.endExclusive+a));a++);if(a===i){y[E+1]=new R.SequenceDiff(new M.OffsetRange(_.seq1Range.start+i,S.seq1Range.endExclusive),new M.OffsetRange(_.seq2Range.start+i,S.seq2Range.endExclusive));continue}a>0&&(_=_.delta(a))}C.push(_)}return y.length>0&&C.push(y[y.length-1]),C}function L(u,m,c){if(!u.getBoundaryScore||!m.getBoundaryScore)return c;for(let y=0;y<c.length;y++){const C=y>0?c[y-1]:void 0,E=c[y],S=y+1<c.length?c[y+1]:void 0,_=new M.OffsetRange(C?C.seq1Range.endExclusive+1:0,S?S.seq1Range.start-1:u.length),i=new M.OffsetRange(C?C.seq2Range.endExclusive+1:0,S?S.seq2Range.start-1:m.length);E.seq1Range.isEmpty?c[y]=h(E,u,m,_,i):E.seq2Range.isEmpty&&(c[y]=h(E.swap(),m,u,i,_).swap())}return c}function h(u,m,c,y,C){let S=1;for(;u.seq1Range.start-S>=y.start&&u.seq2Range.start-S>=C.start&&c.isStronglyEqual(u.seq2Range.start-S,u.seq2Range.endExclusive-S)&&S<100;)S++;S--;let _=0;for(;u.seq1Range.start+_<y.endExclusive&&u.seq2Range.endExclusive+_<C.endExclusive&&c.isStronglyEqual(u.seq2Range.start+_,u.seq2Range.endExclusive+_)&&_<100;)_++;if(S===0&&_===0)return u;let i=0,a=-1;for(let g=-S;g<=_;g++){const b=u.seq2Range.start+g,f=u.seq2Range.endExclusive+g,p=u.seq1Range.start+g,N=m.getBoundaryScore(p)+c.getBoundaryScore(b)+c.getBoundaryScore(f);N>a&&(a=N,i=g)}return u.delta(i)}function l(u,m,c){const y=[];for(const C of c){const E=y[y.length-1];if(!E){y.push(C);continue}C.seq1Range.start-E.seq1Range.endExclusive<=2||C.seq2Range.start-E.seq2Range.endExclusive<=2?y[y.length-1]=new R.SequenceDiff(E.seq1Range.join(C.seq1Range),E.seq2Range.join(C.seq2Range)):y.push(C)}return y}t.removeShortMatches=l;function w(u,m,c){const y=R.SequenceDiff.invert(c,u.length),C=[];let E=new R.OffsetPair(0,0);function S(i,a){if(i.offset1<E.offset1||i.offset2<E.offset2)return;const g=u.findWordContaining(i.offset1),b=m.findWordContaining(i.offset2);if(!g||!b)return;let f=new R.SequenceDiff(g,b);const p=f.intersect(a);let N=p.seq1Range.length,A=p.seq2Range.length;for(;y.length>0;){const D=y[0];if(!(D.seq1Range.intersects(f.seq1Range)||D.seq2Range.intersects(f.seq2Range)))break;const T=u.findWordContaining(D.seq1Range.start),I=m.findWordContaining(D.seq2Range.start),W=new R.SequenceDiff(T,I),H=W.intersect(D);if(N+=H.seq1Range.length,A+=H.seq2Range.length,f=f.join(W),f.seq1Range.endExclusive>=D.seq1Range.endExclusive)y.shift();else break}N+A<(f.seq1Range.length+f.seq2Range.length)*2/3&&C.push(f),E=f.getEndExclusives()}for(;y.length>0;){const i=y.shift();i.seq1Range.isEmpty||(S(i.getStarts(),i),S(i.getEndExclusives().delta(-1),i))}return e(c,C)}t.extendDiffsToEntireWordIfAppropriate=w;function e(u,m){const c=[];for(;u.length>0||m.length>0;){const y=u[0],C=m[0];let E;y&&(!C||y.seq1Range.start<C.seq1Range.start)?E=u.shift():E=m.shift(),c.length>0&&c[c.length-1].seq1Range.endExclusive>=E.seq1Range.start?c[c.length-1]=c[c.length-1].join(E):c.push(E)}return c}function s(u,m,c){let y=c;if(y.length===0)return y;let C=0,E;do{E=!1;const S=[y[0]];for(let _=1;_<y.length;_++){let g=function(f,p){const N=new M.OffsetRange(a.seq1Range.endExclusive,i.seq1Range.start);return u.getText(N).replace(/\s/g,"").length<=4&&(f.seq1Range.length+f.seq2Range.length>5||p.seq1Range.length+p.seq2Range.length>5)};const i=y[_],a=S[S.length-1];g(a,i)?(E=!0,S[S.length-1]=S[S.length-1].join(i)):S.push(i)}y=S}while(C++<10&&E);return y}t.removeVeryShortMatchingLinesBetweenDiffs=s;function o(u,m,c){let y=c;if(y.length===0)return y;let C=0,E;do{E=!1;const _=[y[0]];for(let i=1;i<y.length;i++){let b=function(p,N){const A=new M.OffsetRange(g.seq1Range.endExclusive,a.seq1Range.start);if(u.countLinesIn(A)>5||A.length>500)return!1;const P=u.getText(A).trim();if(P.length>20||P.split(/\r\n|\r|\n/).length>1)return!1;const T=u.countLinesIn(p.seq1Range),I=p.seq1Range.length,W=m.countLinesIn(p.seq2Range),H=p.seq2Range.length,x=u.countLinesIn(N.seq1Range),O=N.seq1Range.length,F=m.countLinesIn(N.seq2Range),V=N.seq2Range.length,j=2*40+50;function Q(ne){return Math.min(ne,j)}return Math.pow(Math.pow(Q(T*40+I),1.5)+Math.pow(Q(W*40+H),1.5),1.5)+Math.pow(Math.pow(Q(x*40+O),1.5)+Math.pow(Q(F*40+V),1.5),1.5)>(j**1.5)**1.5*1.3};const a=y[i],g=_[_.length-1];b(g,a)?(E=!0,_[_.length-1]=_[_.length-1].join(a)):_.push(a)}y=_}while(C++<10&&E);const S=[];return(0,r.forEachWithNeighbors)(y,(_,i,a)=>{let g=i;function b(P){return P.length>0&&P.trim().length<=3&&i.seq1Range.length+i.seq2Range.length>100}const f=u.extendToFullLines(i.seq1Range),p=u.getText(new M.OffsetRange(f.start,i.seq1Range.start));b(p)&&(g=g.deltaStart(-p.length));const N=u.getText(new M.OffsetRange(i.seq1Range.endExclusive,f.endExclusive));b(N)&&(g=g.deltaEnd(N.length));const A=R.SequenceDiff.fromOffsetPairs(_?_.getEndExclusives():R.OffsetPair.zero,a?a.getStarts():R.OffsetPair.max),D=g.intersect(A);S.length>0&&D.getStarts().equals(S[S.length-1].getEndExclusives())?S[S.length-1]=S[S.length-1].join(D):S.push(D)}),S}t.removeVeryShortMatchingTextBetweenLongDiffs=o}),X(Z[46],K([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineSequence=void 0;class r{constructor(d,v){this.trimmedHash=d,this.lines=v}getElement(d){return this.trimmedHash[d]}get length(){return this.trimmedHash.length}getBoundaryScore(d){const v=d===0?0:M(this.lines[d-1]),L=d===this.lines.length?0:M(this.lines[d]);return 1e3-(v+L)}getText(d){return this.lines.slice(d.start,d.endExclusive).join(`
`)}isStronglyEqual(d,v){return this.lines[d]===this.lines[v]}}t.LineSequence=r;function M(R){let d=0;for(;d<R.length&&(R.charCodeAt(d)===32||R.charCodeAt(d)===9);)d++;return d}}),X(Z[15],K([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineRangeFragment=t.isSpace=t.Array2D=void 0;class r{constructor(v,L){this.width=v,this.height=L,this.array=[],this.array=new Array(v*L)}get(v,L){return this.array[v+L*this.width]}set(v,L,h){this.array[v+L*this.width]=h}}t.Array2D=r;function M(d){return d===32||d===9}t.isSpace=M;class R{static getKey(v){let L=this.chrKeys.get(v);return L===void 0&&(L=this.chrKeys.size,this.chrKeys.set(v,L)),L}constructor(v,L,h){this.range=v,this.lines=L,this.source=h,this.histogram=[];let l=0;for(let w=v.startLineNumber-1;w<v.endLineNumberExclusive-1;w++){const e=L[w];for(let o=0;o<e.length;o++){l++;const u=e[o],m=R.getKey(u);this.histogram[m]=(this.histogram[m]||0)+1}l++;const s=R.getKey(`
`);this.histogram[s]=(this.histogram[s]||0)+1}this.totalCount=l}computeSimilarity(v){var L,h;let l=0;const w=Math.max(this.histogram.length,v.histogram.length);for(let e=0;e<w;e++)l+=Math.abs(((L=this.histogram[e])!==null&&L!==void 0?L:0)-((h=v.histogram[e])!==null&&h!==void 0?h:0));return 1-l/(this.totalCount+v.totalCount)}}t.LineRangeFragment=R,R.chrKeys=new Map}),X(Z[47],K([0,1,3,8,15]),function(q,t,r,M,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DynamicProgrammingDiffing=void 0;class d{compute(L,h,l=M.InfiniteTimeout.instance,w){if(L.length===0||h.length===0)return M.DiffAlgorithmResult.trivial(L,h);const e=new R.Array2D(L.length,h.length),s=new R.Array2D(L.length,h.length),o=new R.Array2D(L.length,h.length);for(let S=0;S<L.length;S++)for(let _=0;_<h.length;_++){if(!l.isValid())return M.DiffAlgorithmResult.trivialTimedOut(L,h);const i=S===0?0:e.get(S-1,_),a=_===0?0:e.get(S,_-1);let g;L.getElement(S)===h.getElement(_)?(S===0||_===0?g=0:g=e.get(S-1,_-1),S>0&&_>0&&s.get(S-1,_-1)===3&&(g+=o.get(S-1,_-1)),g+=w?w(S,_):1):g=-1;const b=Math.max(i,a,g);if(b===g){const f=S>0&&_>0?o.get(S-1,_-1):0;o.set(S,_,f+1),s.set(S,_,3)}else b===i?(o.set(S,_,0),s.set(S,_,1)):b===a&&(o.set(S,_,0),s.set(S,_,2));e.set(S,_,b)}const u=[];let m=L.length,c=h.length;function y(S,_){(S+1!==m||_+1!==c)&&u.push(new M.SequenceDiff(new r.OffsetRange(S+1,m),new r.OffsetRange(_+1,c))),m=S,c=_}let C=L.length-1,E=h.length-1;for(;C>=0&&E>=0;)s.get(C,E)===3?(y(C,E),C--,E--):s.get(C,E)===1?C--:E--;return y(-1,-1),u.reverse(),new M.DiffAlgorithmResult(u,!1)}}t.DynamicProgrammingDiffing=d}),X(Z[31],K([0,1,11,3,4,2,15]),function(q,t,r,M,R,d,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinesSliceCharSequence=void 0;class L{constructor(o,u,m){this.lines=o,this.considerWhitespaceChanges=m,this.elements=[],this.firstCharOffsetByLine=[],this.additionalOffsetByLine=[];let c=!1;u.start>0&&u.endExclusive>=o.length&&(u=new M.OffsetRange(u.start-1,u.endExclusive),c=!0),this.lineRange=u,this.firstCharOffsetByLine[0]=0;for(let y=this.lineRange.start;y<this.lineRange.endExclusive;y++){let C=o[y],E=0;if(c)E=C.length,C="",c=!1;else if(!m){const S=C.trimStart();E=C.length-S.length,C=S.trimEnd()}this.additionalOffsetByLine.push(E);for(let S=0;S<C.length;S++)this.elements.push(C.charCodeAt(S));y<o.length-1&&(this.elements.push(10),this.firstCharOffsetByLine[y-this.lineRange.start+1]=this.elements.length)}this.additionalOffsetByLine.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new M.OffsetRange(0,this.length))}getText(o){return this.elements.slice(o.start,o.endExclusive).map(u=>String.fromCharCode(u)).join("")}getElement(o){return this.elements[o]}get length(){return this.elements.length}getBoundaryScore(o){const u=e(o>0?this.elements[o-1]:-1),m=e(o<this.elements.length?this.elements[o]:-1);if(u===7&&m===8)return 0;if(u===8)return 150;let c=0;return u!==m&&(c+=10,u===0&&m===1&&(c+=1)),c+=w(u),c+=w(m),c}translateOffset(o){if(this.lineRange.isEmpty)return new R.Position(this.lineRange.start+1,1);const u=(0,r.findLastIdxMonotonous)(this.firstCharOffsetByLine,m=>m<=o);return new R.Position(this.lineRange.start+u+1,o-this.firstCharOffsetByLine[u]+this.additionalOffsetByLine[u]+1)}translateRange(o){return d.Range.fromPositions(this.translateOffset(o.start),this.translateOffset(o.endExclusive))}findWordContaining(o){if(o<0||o>=this.elements.length||!h(this.elements[o]))return;let u=o;for(;u>0&&h(this.elements[u-1]);)u--;let m=o;for(;m<this.elements.length&&h(this.elements[m]);)m++;return new M.OffsetRange(u,m)}countLinesIn(o){return this.translateOffset(o.endExclusive).lineNumber-this.translateOffset(o.start).lineNumber}isStronglyEqual(o,u){return this.elements[o]===this.elements[u]}extendToFullLines(o){var u,m;const c=(u=(0,r.findLastMonotonous)(this.firstCharOffsetByLine,C=>C<=o.start))!==null&&u!==void 0?u:0,y=(m=(0,r.findFirstMonotonous)(this.firstCharOffsetByLine,C=>o.endExclusive<=C))!==null&&m!==void 0?m:this.elements.length;return new M.OffsetRange(c,y)}}t.LinesSliceCharSequence=L;function h(s){return s>=97&&s<=122||s>=65&&s<=90||s>=48&&s<=57}const l={0:0,1:0,2:0,3:10,4:2,5:30,6:3,7:10,8:10};function w(s){return l[s]}function e(s){return s===10?8:s===13?7:(0,v.isSpace)(s)?6:s>=97&&s<=122?0:s>=65&&s<=90?1:s>=48&&s<=57?2:s===-1?3:s===44||s===59?5:4}}),X(Z[32],K([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MovedText=t.LinesDiff=void 0;class r{constructor(d,v,L){this.changes=d,this.moves=v,this.hitTimeout=L}}t.LinesDiff=r;class M{constructor(d,v){this.lineRangeMapping=d,this.changes=v}}t.MovedText=M}),X(Z[16],K([0,1,10]),function(q,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RangeMapping=t.DetailedLineRangeMapping=t.LineRangeMapping=void 0;class M{static inverse(L,h,l){const w=[];let e=1,s=1;for(const u of L){const m=new M(new r.LineRange(e,u.original.startLineNumber),new r.LineRange(s,u.modified.startLineNumber));m.modified.isEmpty||w.push(m),e=u.original.endLineNumberExclusive,s=u.modified.endLineNumberExclusive}const o=new M(new r.LineRange(e,h+1),new r.LineRange(s,l+1));return o.modified.isEmpty||w.push(o),w}static clip(L,h,l){const w=[];for(const e of L){const s=e.original.intersect(h),o=e.modified.intersect(l);s&&!s.isEmpty&&o&&!o.isEmpty&&w.push(new M(s,o))}return w}constructor(L,h){this.original=L,this.modified=h}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new M(this.modified,this.original)}join(L){return new M(this.original.join(L.original),this.modified.join(L.modified))}}t.LineRangeMapping=M;class R extends M{constructor(L,h,l){super(L,h),this.innerChanges=l}flip(){var L;return new R(this.modified,this.original,(L=this.innerChanges)===null||L===void 0?void 0:L.map(h=>h.flip()))}}t.DetailedLineRangeMapping=R;class d{constructor(L,h){this.originalRange=L,this.modifiedRange=h}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new d(this.modifiedRange,this.originalRange)}}t.RangeMapping=d}),X(Z[48],K([0,1,8,16,7,11,38,10,3,31,15,30]),function(q,t,r,M,R,d,v,L,h,l,w,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeMovedLines=void 0;function s(E,S,_,i,a,g){let{moves:b,excludedChanges:f}=u(E,S,_,g);if(!g.isValid())return[];const p=E.filter(A=>!f.has(A)),N=m(p,i,a,S,_,g);return(0,R.pushMany)(b,N),b=y(b),b=b.filter(A=>{const D=A.original.toOffsetRange().slice(S).map(T=>T.trim());return D.join(`
`).length>=15&&o(D,T=>T.length>=2)>=2}),b=C(E,b),b}t.computeMovedLines=s;function o(E,S){let _=0;for(const i of E)S(i)&&_++;return _}function u(E,S,_,i){const a=[],g=E.filter(p=>p.modified.isEmpty&&p.original.length>=3).map(p=>new w.LineRangeFragment(p.original,S,p)),b=new Set(E.filter(p=>p.original.isEmpty&&p.modified.length>=3).map(p=>new w.LineRangeFragment(p.modified,_,p))),f=new Set;for(const p of g){let N=-1,A;for(const D of b){const P=p.computeSimilarity(D);P>N&&(N=P,A=D)}if(N>.9&&A&&(b.delete(A),a.push(new M.LineRangeMapping(p.range,A.range)),f.add(p.source),f.add(A.source)),!i.isValid())return{moves:a,excludedChanges:f}}return{moves:a,excludedChanges:f}}function m(E,S,_,i,a,g){const b=[],f=new v.SetMap;for(const P of E)for(let T=P.original.startLineNumber;T<P.original.endLineNumberExclusive-2;T++){const I=`${S[T-1]}:${S[T+1-1]}:${S[T+2-1]}`;f.add(I,{range:new L.LineRange(T,T+3)})}const p=[];E.sort((0,R.compareBy)(P=>P.modified.startLineNumber,R.numberComparator));for(const P of E){let T=[];for(let I=P.modified.startLineNumber;I<P.modified.endLineNumberExclusive-2;I++){const W=`${_[I-1]}:${_[I+1-1]}:${_[I+2-1]}`,H=new L.LineRange(I,I+3),x=[];f.forEach(W,({range:O})=>{for(const V of T)if(V.originalLineRange.endLineNumberExclusive+1===O.endLineNumberExclusive&&V.modifiedLineRange.endLineNumberExclusive+1===H.endLineNumberExclusive){V.originalLineRange=new L.LineRange(V.originalLineRange.startLineNumber,O.endLineNumberExclusive),V.modifiedLineRange=new L.LineRange(V.modifiedLineRange.startLineNumber,H.endLineNumberExclusive),x.push(V);return}const F={modifiedLineRange:H,originalLineRange:O};p.push(F),x.push(F)}),T=x}if(!g.isValid())return[]}p.sort((0,R.reverseOrder)((0,R.compareBy)(P=>P.modifiedLineRange.length,R.numberComparator)));const N=new L.LineRangeSet,A=new L.LineRangeSet;for(const P of p){const T=P.modifiedLineRange.startLineNumber-P.originalLineRange.startLineNumber,I=N.subtractFrom(P.modifiedLineRange),W=A.subtractFrom(P.originalLineRange).getWithDelta(T),H=I.getIntersection(W);for(const x of H.ranges){if(x.length<3)continue;const O=x,F=x.delta(-T);b.push(new M.LineRangeMapping(F,O)),N.addRange(O),A.addRange(F)}}b.sort((0,R.compareBy)(P=>P.original.startLineNumber,R.numberComparator));const D=new d.MonotonousArray(E);for(let P=0;P<b.length;P++){const T=b[P],I=D.findLastMonotonous(Q=>Q.original.startLineNumber<=T.original.startLineNumber),W=(0,d.findLastMonotonous)(E,Q=>Q.modified.startLineNumber<=T.modified.startLineNumber),H=Math.max(T.original.startLineNumber-I.original.startLineNumber,T.modified.startLineNumber-W.modified.startLineNumber),x=D.findLastMonotonous(Q=>Q.original.startLineNumber<T.original.endLineNumberExclusive),O=(0,d.findLastMonotonous)(E,Q=>Q.modified.startLineNumber<T.modified.endLineNumberExclusive),F=Math.max(x.original.endLineNumberExclusive-T.original.endLineNumberExclusive,O.modified.endLineNumberExclusive-T.modified.endLineNumberExclusive);let V;for(V=0;V<H;V++){const Q=T.original.startLineNumber-V-1,ne=T.modified.startLineNumber-V-1;if(Q>i.length||ne>a.length||N.contains(ne)||A.contains(Q)||!c(i[Q-1],a[ne-1],g))break}V>0&&(A.addRange(new L.LineRange(T.original.startLineNumber-V,T.original.startLineNumber)),N.addRange(new L.LineRange(T.modified.startLineNumber-V,T.modified.startLineNumber)));let j;for(j=0;j<F;j++){const Q=T.original.endLineNumberExclusive+j,ne=T.modified.endLineNumberExclusive+j;if(Q>i.length||ne>a.length||N.contains(ne)||A.contains(Q)||!c(i[Q-1],a[ne-1],g))break}j>0&&(A.addRange(new L.LineRange(T.original.endLineNumberExclusive,T.original.endLineNumberExclusive+j)),N.addRange(new L.LineRange(T.modified.endLineNumberExclusive,T.modified.endLineNumberExclusive+j))),(V>0||j>0)&&(b[P]=new M.LineRangeMapping(new L.LineRange(T.original.startLineNumber-V,T.original.endLineNumberExclusive+j),new L.LineRange(T.modified.startLineNumber-V,T.modified.endLineNumberExclusive+j)))}return b}function c(E,S,_){if(E.trim()===S.trim())return!0;if(E.length>300&&S.length>300)return!1;const a=new e.MyersDiffAlgorithm().compute(new l.LinesSliceCharSequence([E],new h.OffsetRange(0,1),!1),new l.LinesSliceCharSequence([S],new h.OffsetRange(0,1),!1),_);let g=0;const b=r.SequenceDiff.invert(a.diffs,E.length);for(const A of b)A.seq1Range.forEach(D=>{(0,w.isSpace)(E.charCodeAt(D))||g++});function f(A){let D=0;for(let P=0;P<E.length;P++)(0,w.isSpace)(A.charCodeAt(P))||D++;return D}const p=f(E.length>S.length?E:S);return g/p>.6&&p>10}function y(E){if(E.length===0)return E;E.sort((0,R.compareBy)(_=>_.original.startLineNumber,R.numberComparator));const S=[E[0]];for(let _=1;_<E.length;_++){const i=S[S.length-1],a=E[_],g=a.original.startLineNumber-i.original.endLineNumberExclusive,b=a.modified.startLineNumber-i.modified.endLineNumberExclusive;if(g>=0&&b>=0&&g+b<=2){S[S.length-1]=i.join(a);continue}S.push(a)}return S}function C(E,S){const _=new d.MonotonousArray(E);return S=S.filter(i=>{const a=_.findLastMonotonous(f=>f.original.startLineNumber<i.original.endLineNumberExclusive)||new M.LineRangeMapping(new L.LineRange(1,1),new L.LineRange(1,1)),g=(0,d.findLastMonotonous)(E,f=>f.modified.startLineNumber<i.modified.endLineNumberExclusive);return a!==g}),S}}),X(Z[49],K([0,1,7,12,10,3,2,8,47,30,48,45,46,31,32,16]),function(q,t,r,M,R,d,v,L,h,l,w,e,s,o,u,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getLineRangeMapping=t.lineRangeMappingFromRangeMappings=t.DefaultLinesDiffComputer=void 0;class c{constructor(){this.dynamicProgrammingDiffing=new h.DynamicProgrammingDiffing,this.myersDiffingAlgorithm=new l.MyersDiffAlgorithm}computeDiff(S,_,i){if(S.length<=1&&(0,r.equals)(S,_,(j,Q)=>j===Q))return new u.LinesDiff([],[],!1);if(S.length===1&&S[0].length===0||_.length===1&&_[0].length===0)return new u.LinesDiff([new m.DetailedLineRangeMapping(new R.LineRange(1,S.length+1),new R.LineRange(1,_.length+1),[new m.RangeMapping(new v.Range(1,1,S.length,S[0].length+1),new v.Range(1,1,_.length,_[0].length+1))])],[],!1);const a=i.maxComputationTimeMs===0?L.InfiniteTimeout.instance:new L.DateTimeout(i.maxComputationTimeMs),g=!i.ignoreTrimWhitespace,b=new Map;function f(j){let Q=b.get(j);return Q===void 0&&(Q=b.size,b.set(j,Q)),Q}const p=S.map(j=>f(j.trim())),N=_.map(j=>f(j.trim())),A=new s.LineSequence(p,S),D=new s.LineSequence(N,_),P=A.length+D.length<1700?this.dynamicProgrammingDiffing.compute(A,D,a,(j,Q)=>S[j]===_[Q]?_[Q].length===0?.1:1+Math.log(1+_[Q].length):.99):this.myersDiffingAlgorithm.compute(A,D);let T=P.diffs,I=P.hitTimeout;T=(0,e.optimizeSequenceDiffs)(A,D,T),T=(0,e.removeVeryShortMatchingLinesBetweenDiffs)(A,D,T);const W=[],H=j=>{if(g)for(let Q=0;Q<j;Q++){const ne=x+Q,se=O+Q;if(S[ne]!==_[se]){const n=this.refineDiff(S,_,new L.SequenceDiff(new d.OffsetRange(ne,ne+1),new d.OffsetRange(se,se+1)),a,g);for(const be of n.mappings)W.push(be);n.hitTimeout&&(I=!0)}}};let x=0,O=0;for(const j of T){(0,M.assertFn)(()=>j.seq1Range.start-x===j.seq2Range.start-O);const Q=j.seq1Range.start-x;H(Q),x=j.seq1Range.endExclusive,O=j.seq2Range.endExclusive;const ne=this.refineDiff(S,_,j,a,g);ne.hitTimeout&&(I=!0);for(const se of ne.mappings)W.push(se)}H(S.length-x);const F=y(W,S,_);let V=[];return i.computeMoves&&(V=this.computeMoves(F,S,_,p,N,a,g)),(0,M.assertFn)(()=>{function j(ne,se){if(ne.lineNumber<1||ne.lineNumber>se.length)return!1;const n=se[ne.lineNumber-1];return!(ne.column<1||ne.column>n.length+1)}function Q(ne,se){return!(ne.startLineNumber<1||ne.startLineNumber>se.length+1||ne.endLineNumberExclusive<1||ne.endLineNumberExclusive>se.length+1)}for(const ne of F){if(!ne.innerChanges)return!1;for(const se of ne.innerChanges)if(!(j(se.modifiedRange.getStartPosition(),_)&&j(se.modifiedRange.getEndPosition(),_)&&j(se.originalRange.getStartPosition(),S)&&j(se.originalRange.getEndPosition(),S)))return!1;if(!Q(ne.modified,_)||!Q(ne.original,S))return!1}return!0}),new u.LinesDiff(F,V,I)}computeMoves(S,_,i,a,g,b,f){return(0,w.computeMovedLines)(S,_,i,a,g,b).map(A=>{const D=this.refineDiff(_,i,new L.SequenceDiff(A.original.toOffsetRange(),A.modified.toOffsetRange()),b,f),P=y(D.mappings,_,i,!0);return new u.MovedText(A,P)})}refineDiff(S,_,i,a,g){const b=new o.LinesSliceCharSequence(S,i.seq1Range,g),f=new o.LinesSliceCharSequence(_,i.seq2Range,g),p=b.length+f.length<500?this.dynamicProgrammingDiffing.compute(b,f,a):this.myersDiffingAlgorithm.compute(b,f,a);let N=p.diffs;return N=(0,e.optimizeSequenceDiffs)(b,f,N),N=(0,e.extendDiffsToEntireWordIfAppropriate)(b,f,N),N=(0,e.removeShortMatches)(b,f,N),N=(0,e.removeVeryShortMatchingTextBetweenLongDiffs)(b,f,N),{mappings:N.map(D=>new m.RangeMapping(b.translateRange(D.seq1Range),f.translateRange(D.seq2Range))),hitTimeout:p.hitTimeout}}}t.DefaultLinesDiffComputer=c;function y(E,S,_,i=!1){const a=[];for(const g of(0,r.groupAdjacentBy)(E.map(b=>C(b,S,_)),(b,f)=>b.original.overlapOrTouch(f.original)||b.modified.overlapOrTouch(f.modified))){const b=g[0],f=g[g.length-1];a.push(new m.DetailedLineRangeMapping(b.original.join(f.original),b.modified.join(f.modified),g.map(p=>p.innerChanges[0])))}return(0,M.assertFn)(()=>!i&&a.length>0&&(a[0].modified.startLineNumber!==a[0].original.startLineNumber||_.length-a[a.length-1].modified.endLineNumberExclusive!==S.length-a[a.length-1].original.endLineNumberExclusive)?!1:(0,M.checkAdjacentItems)(a,(g,b)=>b.original.startLineNumber-g.original.endLineNumberExclusive===b.modified.startLineNumber-g.modified.endLineNumberExclusive&&g.original.endLineNumberExclusive<b.original.startLineNumber&&g.modified.endLineNumberExclusive<b.modified.startLineNumber)),a}t.lineRangeMappingFromRangeMappings=y;function C(E,S,_){let i=0,a=0;E.modifiedRange.endColumn===1&&E.originalRange.endColumn===1&&E.originalRange.startLineNumber+i<=E.originalRange.endLineNumber&&E.modifiedRange.startLineNumber+i<=E.modifiedRange.endLineNumber&&(a=-1),E.modifiedRange.startColumn-1>=_[E.modifiedRange.startLineNumber-1].length&&E.originalRange.startColumn-1>=S[E.originalRange.startLineNumber-1].length&&E.originalRange.startLineNumber<=E.originalRange.endLineNumber+a&&E.modifiedRange.startLineNumber<=E.modifiedRange.endLineNumber+a&&(i=1);const g=new R.LineRange(E.originalRange.startLineNumber+i,E.originalRange.endLineNumber+1+a),b=new R.LineRange(E.modifiedRange.startLineNumber+i,E.modifiedRange.endLineNumber+1+a);return new m.DetailedLineRangeMapping(g,b,[E])}t.getLineRangeMapping=C}),X(Z[50],K([0,1,24,32,16,6,2,12,10]),function(q,t,r,M,R,d,v,L,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffComputer=t.LegacyLinesDiffComputer=void 0;const l=3;class w{computeDiff(i,a,g){var b;const p=new y(i,a,{maxComputationTime:g.maxComputationTimeMs,shouldIgnoreTrimWhitespace:g.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),N=[];let A=null;for(const D of p.changes){let P;D.originalEndLineNumber===0?P=new h.LineRange(D.originalStartLineNumber+1,D.originalStartLineNumber+1):P=new h.LineRange(D.originalStartLineNumber,D.originalEndLineNumber+1);let T;D.modifiedEndLineNumber===0?T=new h.LineRange(D.modifiedStartLineNumber+1,D.modifiedStartLineNumber+1):T=new h.LineRange(D.modifiedStartLineNumber,D.modifiedEndLineNumber+1);let I=new R.DetailedLineRangeMapping(P,T,(b=D.charChanges)===null||b===void 0?void 0:b.map(W=>new R.RangeMapping(new v.Range(W.originalStartLineNumber,W.originalStartColumn,W.originalEndLineNumber,W.originalEndColumn),new v.Range(W.modifiedStartLineNumber,W.modifiedStartColumn,W.modifiedEndLineNumber,W.modifiedEndColumn))));A&&(A.modified.endLineNumberExclusive===I.modified.startLineNumber||A.original.endLineNumberExclusive===I.original.startLineNumber)&&(I=new R.DetailedLineRangeMapping(A.original.join(I.original),A.modified.join(I.modified),A.innerChanges&&I.innerChanges?A.innerChanges.concat(I.innerChanges):void 0),N.pop()),N.push(I),A=I}return(0,L.assertFn)(()=>(0,L.checkAdjacentItems)(N,(D,P)=>P.original.startLineNumber-D.original.endLineNumberExclusive===P.modified.startLineNumber-D.modified.endLineNumberExclusive&&D.original.endLineNumberExclusive<P.original.startLineNumber&&D.modified.endLineNumberExclusive<P.modified.startLineNumber)),new M.LinesDiff(N,[],p.quitEarly)}}t.LegacyLinesDiffComputer=w;function e(_,i,a,g){return new r.LcsDiff(_,i,a).ComputeDiff(g)}class s{constructor(i){const a=[],g=[];for(let b=0,f=i.length;b<f;b++)a[b]=C(i[b],1),g[b]=E(i[b],1);this.lines=i,this._startColumns=a,this._endColumns=g}getElements(){const i=[];for(let a=0,g=this.lines.length;a<g;a++)i[a]=this.lines[a].substring(this._startColumns[a]-1,this._endColumns[a]-1);return i}getStrictElement(i){return this.lines[i]}getStartLineNumber(i){return i+1}getEndLineNumber(i){return i+1}createCharSequence(i,a,g){const b=[],f=[],p=[];let N=0;for(let A=a;A<=g;A++){const D=this.lines[A],P=i?this._startColumns[A]:1,T=i?this._endColumns[A]:D.length+1;for(let I=P;I<T;I++)b[N]=D.charCodeAt(I-1),f[N]=A+1,p[N]=I,N++;!i&&A<g&&(b[N]=10,f[N]=A+1,p[N]=D.length+1,N++)}return new o(b,f,p)}}class o{constructor(i,a,g){this._charCodes=i,this._lineNumbers=a,this._columns=g}toString(){return"["+this._charCodes.map((i,a)=>(i===10?"\\n":String.fromCharCode(i))+`-(${this._lineNumbers[a]},${this._columns[a]})`).join(", ")+"]"}_assertIndex(i,a){if(i<0||i>=a.length)throw new Error("Illegal index")}getElements(){return this._charCodes}getStartLineNumber(i){return i>0&&i===this._lineNumbers.length?this.getEndLineNumber(i-1):(this._assertIndex(i,this._lineNumbers),this._lineNumbers[i])}getEndLineNumber(i){return i===-1?this.getStartLineNumber(i+1):(this._assertIndex(i,this._lineNumbers),this._charCodes[i]===10?this._lineNumbers[i]+1:this._lineNumbers[i])}getStartColumn(i){return i>0&&i===this._columns.length?this.getEndColumn(i-1):(this._assertIndex(i,this._columns),this._columns[i])}getEndColumn(i){return i===-1?this.getStartColumn(i+1):(this._assertIndex(i,this._columns),this._charCodes[i]===10?1:this._columns[i]+1)}}class u{constructor(i,a,g,b,f,p,N,A){this.originalStartLineNumber=i,this.originalStartColumn=a,this.originalEndLineNumber=g,this.originalEndColumn=b,this.modifiedStartLineNumber=f,this.modifiedStartColumn=p,this.modifiedEndLineNumber=N,this.modifiedEndColumn=A}static createFromDiffChange(i,a,g){const b=a.getStartLineNumber(i.originalStart),f=a.getStartColumn(i.originalStart),p=a.getEndLineNumber(i.originalStart+i.originalLength-1),N=a.getEndColumn(i.originalStart+i.originalLength-1),A=g.getStartLineNumber(i.modifiedStart),D=g.getStartColumn(i.modifiedStart),P=g.getEndLineNumber(i.modifiedStart+i.modifiedLength-1),T=g.getEndColumn(i.modifiedStart+i.modifiedLength-1);return new u(b,f,p,N,A,D,P,T)}}function m(_){if(_.length<=1)return _;const i=[_[0]];let a=i[0];for(let g=1,b=_.length;g<b;g++){const f=_[g],p=f.originalStart-(a.originalStart+a.originalLength),N=f.modifiedStart-(a.modifiedStart+a.modifiedLength);Math.min(p,N)<l?(a.originalLength=f.originalStart+f.originalLength-a.originalStart,a.modifiedLength=f.modifiedStart+f.modifiedLength-a.modifiedStart):(i.push(f),a=f)}return i}class c{constructor(i,a,g,b,f){this.originalStartLineNumber=i,this.originalEndLineNumber=a,this.modifiedStartLineNumber=g,this.modifiedEndLineNumber=b,this.charChanges=f}static createFromDiffResult(i,a,g,b,f,p,N){let A,D,P,T,I;if(a.originalLength===0?(A=g.getStartLineNumber(a.originalStart)-1,D=0):(A=g.getStartLineNumber(a.originalStart),D=g.getEndLineNumber(a.originalStart+a.originalLength-1)),a.modifiedLength===0?(P=b.getStartLineNumber(a.modifiedStart)-1,T=0):(P=b.getStartLineNumber(a.modifiedStart),T=b.getEndLineNumber(a.modifiedStart+a.modifiedLength-1)),p&&a.originalLength>0&&a.originalLength<20&&a.modifiedLength>0&&a.modifiedLength<20&&f()){const W=g.createCharSequence(i,a.originalStart,a.originalStart+a.originalLength-1),H=b.createCharSequence(i,a.modifiedStart,a.modifiedStart+a.modifiedLength-1);if(W.getElements().length>0&&H.getElements().length>0){let x=e(W,H,f,!0).changes;N&&(x=m(x)),I=[];for(let O=0,F=x.length;O<F;O++)I.push(u.createFromDiffChange(x[O],W,H))}}return new c(A,D,P,T,I)}}class y{constructor(i,a,g){this.shouldComputeCharChanges=g.shouldComputeCharChanges,this.shouldPostProcessCharChanges=g.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=g.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=g.shouldMakePrettyDiff,this.originalLines=i,this.modifiedLines=a,this.original=new s(i),this.modified=new s(a),this.continueLineDiff=S(g.maxComputationTime),this.continueCharDiff=S(g.maxComputationTime===0?0:Math.min(g.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:void 0}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const i=e(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),a=i.changes,g=i.quitEarly;if(this.shouldIgnoreTrimWhitespace){const N=[];for(let A=0,D=a.length;A<D;A++)N.push(c.createFromDiffResult(this.shouldIgnoreTrimWhitespace,a[A],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:g,changes:N}}const b=[];let f=0,p=0;for(let N=-1,A=a.length;N<A;N++){const D=N+1<A?a[N+1]:null,P=D?D.originalStart:this.originalLines.length,T=D?D.modifiedStart:this.modifiedLines.length;for(;f<P&&p<T;){const I=this.originalLines[f],W=this.modifiedLines[p];if(I!==W){{let H=C(I,1),x=C(W,1);for(;H>1&&x>1;){const O=I.charCodeAt(H-2),F=W.charCodeAt(x-2);if(O!==F)break;H--,x--}(H>1||x>1)&&this._pushTrimWhitespaceCharChange(b,f+1,1,H,p+1,1,x)}{let H=E(I,1),x=E(W,1);const O=I.length+1,F=W.length+1;for(;H<O&&x<F;){const V=I.charCodeAt(H-1),j=I.charCodeAt(x-1);if(V!==j)break;H++,x++}(H<O||x<F)&&this._pushTrimWhitespaceCharChange(b,f+1,H,O,p+1,x,F)}}f++,p++}D&&(b.push(c.createFromDiffResult(this.shouldIgnoreTrimWhitespace,D,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),f+=D.originalLength,p+=D.modifiedLength)}return{quitEarly:g,changes:b}}_pushTrimWhitespaceCharChange(i,a,g,b,f,p,N){if(this._mergeTrimWhitespaceCharChange(i,a,g,b,f,p,N))return;let A;this.shouldComputeCharChanges&&(A=[new u(a,g,a,b,f,p,f,N)]),i.push(new c(a,a,f,f,A))}_mergeTrimWhitespaceCharChange(i,a,g,b,f,p,N){const A=i.length;if(A===0)return!1;const D=i[A-1];return D.originalEndLineNumber===0||D.modifiedEndLineNumber===0?!1:D.originalEndLineNumber===a&&D.modifiedEndLineNumber===f?(this.shouldComputeCharChanges&&D.charChanges&&D.charChanges.push(new u(a,g,a,b,f,p,f,N)),!0):D.originalEndLineNumber+1===a&&D.modifiedEndLineNumber+1===f?(D.originalEndLineNumber=a,D.modifiedEndLineNumber=f,this.shouldComputeCharChanges&&D.charChanges&&D.charChanges.push(new u(a,g,a,b,f,p,f,N)),!0):!1}}t.DiffComputer=y;function C(_,i){const a=d.firstNonWhitespaceIndex(_);return a===-1?i:a+1}function E(_,i){const a=d.lastNonWhitespaceIndex(_);return a===-1?i:a+2}function S(_){if(_===0)return()=>!0;const i=Date.now();return()=>Date.now()-i<_}}),X(Z[51],K([0,1,50,49]),function(q,t,r,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.linesDiffComputers=void 0,t.linesDiffComputers={getLegacy:()=>new r.LegacyLinesDiffComputer,getDefault:()=>new M.DefaultLinesDiffComputer}}),X(Z[52],K([0,1,34]),function(q,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeDefaultDocumentColors=void 0;function M(s){const o=[];for(const u of s){const m=Number(u);(m||m===0&&u.replace(/\s/g,"")!=="")&&o.push(m)}return o}function R(s,o,u,m){return{red:s/255,blue:u/255,green:o/255,alpha:m}}function d(s,o){const u=o.index,m=o[0].length;if(!u)return;const c=s.positionAt(u);return{startLineNumber:c.lineNumber,startColumn:c.column,endLineNumber:c.lineNumber,endColumn:c.column+m}}function v(s,o){if(!s)return;const u=r.Color.Format.CSS.parseHex(o);if(u)return{range:s,color:R(u.rgba.r,u.rgba.g,u.rgba.b,u.rgba.a)}}function L(s,o,u){if(!s||o.length!==1)return;const c=o[0].values(),y=M(c);return{range:s,color:R(y[0],y[1],y[2],u?y[3]:1)}}function h(s,o,u){if(!s||o.length!==1)return;const c=o[0].values(),y=M(c),C=new r.Color(new r.HSLA(y[0],y[1]/100,y[2]/100,u?y[3]:1));return{range:s,color:R(C.rgba.r,C.rgba.g,C.rgba.b,C.rgba.a)}}function l(s,o){return typeof s=="string"?[...s.matchAll(o)]:s.findMatches(o)}function w(s){const o=[],m=l(s,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(m.length>0)for(const c of m){const y=c.filter(_=>_!==void 0),C=y[1],E=y[2];if(!E)continue;let S;if(C==="rgb"){const _=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;S=L(d(s,c),l(E,_),!1)}else if(C==="rgba"){const _=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;S=L(d(s,c),l(E,_),!0)}else if(C==="hsl"){const _=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;S=h(d(s,c),l(E,_),!1)}else if(C==="hsla"){const _=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;S=h(d(s,c),l(E,_),!0)}else C==="#"&&(S=v(d(s,c),C+E));S&&o.push(S)}return o}function e(s){return!s||typeof s.getValue!="function"||typeof s.positionAt!="function"?[]:w(s)}t.computeDefaultDocumentColors=e}),X(Z[53],K([0,1,28]),function(q,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeLinks=t.LinkComputer=t.StateMachine=void 0;class M{constructor(s,o,u){const m=new Uint8Array(s*o);for(let c=0,y=s*o;c<y;c++)m[c]=u;this._data=m,this.rows=s,this.cols=o}get(s,o){return this._data[s*this.cols+o]}set(s,o,u){this._data[s*this.cols+o]=u}}class R{constructor(s){let o=0,u=0;for(let c=0,y=s.length;c<y;c++){const[C,E,S]=s[c];E>o&&(o=E),C>u&&(u=C),S>u&&(u=S)}o++,u++;const m=new M(u,o,0);for(let c=0,y=s.length;c<y;c++){const[C,E,S]=s[c];m.set(C,E,S)}this._states=m,this._maxCharCode=o}nextState(s,o){return o<0||o>=this._maxCharCode?0:this._states.get(s,o)}}t.StateMachine=R;let d=null;function v(){return d===null&&(d=new R([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),d}let L=null;function h(){if(L===null){L=new r.CharacterClassifier(0);const e=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let o=0;o<e.length;o++)L.set(e.charCodeAt(o),1);const s=".,;:";for(let o=0;o<s.length;o++)L.set(s.charCodeAt(o),2)}return L}class l{static _createLink(s,o,u,m,c){let y=c-1;do{const C=o.charCodeAt(y);if(s.get(C)!==2)break;y--}while(y>m);if(m>0){const C=o.charCodeAt(m-1),E=o.charCodeAt(y);(C===40&&E===41||C===91&&E===93||C===123&&E===125)&&y--}return{range:{startLineNumber:u,startColumn:m+1,endLineNumber:u,endColumn:y+2},url:o.substring(m,y+1)}}static computeLinks(s,o=v()){const u=h(),m=[];for(let c=1,y=s.getLineCount();c<=y;c++){const C=s.getLineContent(c),E=C.length;let S=0,_=0,i=0,a=1,g=!1,b=!1,f=!1,p=!1;for(;S<E;){let N=!1;const A=C.charCodeAt(S);if(a===13){let D;switch(A){case 40:g=!0,D=0;break;case 41:D=g?0:1;break;case 91:f=!0,b=!0,D=0;break;case 93:f=!1,D=b?0:1;break;case 123:p=!0,D=0;break;case 125:D=p?0:1;break;case 39:case 34:case 96:i===A?D=1:i===39||i===34||i===96?D=0:D=1;break;case 42:D=i===42?1:0;break;case 124:D=i===124?1:0;break;case 32:D=f?0:1;break;default:D=u.get(A)}D===1&&(m.push(l._createLink(u,C,c,_,S)),N=!0)}else if(a===12){let D;A===91?(b=!0,D=0):D=u.get(A),D===1?N=!0:a=13}else a=o.nextState(a,A),a===0&&(N=!0);N&&(a=1,g=!1,b=!1,p=!1,_=S+1,i=A),S++}a===13&&m.push(l._createLink(u,C,c,_,E))}return m}}t.LinkComputer=l;function w(e){return!e||typeof e.getLineCount!="function"||typeof e.getLineContent!="function"?[]:l.computeLinks(e)}t.computeLinks=w}),X(Z[54],K([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BasicInplaceReplace=void 0;class r{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(R,d,v,L,h){if(R&&d){const l=this.doNavigateValueSet(d,h);if(l)return{range:R,value:l}}if(v&&L){const l=this.doNavigateValueSet(L,h);if(l)return{range:v,value:l}}return null}doNavigateValueSet(R,d){const v=this.numberReplace(R,d);return v!==null?v:this.textReplace(R,d)}numberReplace(R,d){const v=Math.pow(10,R.length-(R.lastIndexOf(".")+1));let L=Number(R);const h=parseFloat(R);return!isNaN(L)&&!isNaN(h)&&L===h?L===0&&!d?null:(L=Math.floor(L*v),L+=d?v:-v,String(L/v)):null}textReplace(R,d){return this.valueSetsReplace(this._defaultValueSet,R,d)}valueSetsReplace(R,d,v){let L=null;for(let h=0,l=R.length;L===null&&h<l;h++)L=this.valueSetReplace(R[h],d,v);return L}valueSetReplace(R,d,v){let L=R.indexOf(d);return L>=0?(L+=v?1:-1,L<0?L=R.length-1:L%=R.length,R[L]):null}}t.BasicInplaceReplace=r,r.INSTANCE=new r}),X(Z[55],K([0,1,14]),function(q,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.shouldSynchronizeModel=t.ApplyEditsResult=t.SearchData=t.ValidAnnotatedEditOperation=t.isITextSnapshot=t.FindMatch=t.TextModelResolvedOptions=t.InjectedTextCursorStops=t.MinimapPosition=t.GlyphMarginLane=t.OverviewRulerLane=void 0;var M;(function(u){u[u.Left=1]="Left",u[u.Center=2]="Center",u[u.Right=4]="Right",u[u.Full=7]="Full"})(M||(t.OverviewRulerLane=M={}));var R;(function(u){u[u.Left=1]="Left",u[u.Center=2]="Center",u[u.Right=3]="Right"})(R||(t.GlyphMarginLane=R={}));var d;(function(u){u[u.Inline=1]="Inline",u[u.Gutter=2]="Gutter"})(d||(t.MinimapPosition=d={}));var v;(function(u){u[u.Both=0]="Both",u[u.Right=1]="Right",u[u.Left=2]="Left",u[u.None=3]="None"})(v||(t.InjectedTextCursorStops=v={}));class L{get originalIndentSize(){return this._indentSizeIsTabSize?"tabSize":this.indentSize}constructor(m){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,m.tabSize|0),m.indentSize==="tabSize"?(this.indentSize=this.tabSize,this._indentSizeIsTabSize=!0):(this.indentSize=Math.max(1,m.indentSize|0),this._indentSizeIsTabSize=!1),this.insertSpaces=!!m.insertSpaces,this.defaultEOL=m.defaultEOL|0,this.trimAutoWhitespace=!!m.trimAutoWhitespace,this.bracketPairColorizationOptions=m.bracketPairColorizationOptions}equals(m){return this.tabSize===m.tabSize&&this._indentSizeIsTabSize===m._indentSizeIsTabSize&&this.indentSize===m.indentSize&&this.insertSpaces===m.insertSpaces&&this.defaultEOL===m.defaultEOL&&this.trimAutoWhitespace===m.trimAutoWhitespace&&(0,r.equals)(this.bracketPairColorizationOptions,m.bracketPairColorizationOptions)}createChangeEvent(m){return{tabSize:this.tabSize!==m.tabSize,indentSize:this.indentSize!==m.indentSize,insertSpaces:this.insertSpaces!==m.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==m.trimAutoWhitespace}}}t.TextModelResolvedOptions=L;class h{constructor(m,c){this._findMatchBrand=void 0,this.range=m,this.matches=c}}t.FindMatch=h;function l(u){return u&&typeof u.read=="function"}t.isITextSnapshot=l;class w{constructor(m,c,y,C,E,S){this.identifier=m,this.range=c,this.text=y,this.forceMoveMarkers=C,this.isAutoWhitespaceEdit=E,this._isTracked=S}}t.ValidAnnotatedEditOperation=w;class e{constructor(m,c,y){this.regex=m,this.wordSeparators=c,this.simpleSearch=y}}t.SearchData=e;class s{constructor(m,c,y){this.reverseEdits=m,this.changes=c,this.trimAutoWhitespaceLineNumbers=y}}t.ApplyEditsResult=s;function o(u){return!u.isTooLargeForSyncing()&&!u.isForSimpleWidget}t.shouldSynchronizeModel=o}),X(Z[56],K([0,1,7,27]),function(q,t,r,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PrefixSumIndexOfResult=t.ConstantTimePrefixSumComputer=t.PrefixSumComputer=void 0;class R{constructor(h){this.values=h,this.prefixSum=new Uint32Array(h.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}insertValues(h,l){h=(0,M.toUint32)(h);const w=this.values,e=this.prefixSum,s=l.length;return s===0?!1:(this.values=new Uint32Array(w.length+s),this.values.set(w.subarray(0,h),0),this.values.set(w.subarray(h),h+s),this.values.set(l,h),h-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=h-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(e.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(h,l){return h=(0,M.toUint32)(h),l=(0,M.toUint32)(l),this.values[h]===l?!1:(this.values[h]=l,h-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=h-1),!0)}removeValues(h,l){h=(0,M.toUint32)(h),l=(0,M.toUint32)(l);const w=this.values,e=this.prefixSum;if(h>=w.length)return!1;const s=w.length-h;return l>=s&&(l=s),l===0?!1:(this.values=new Uint32Array(w.length-l),this.values.set(w.subarray(0,h),0),this.values.set(w.subarray(h+l),h),this.prefixSum=new Uint32Array(this.values.length),h-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=h-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(e.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(h){return h<0?0:(h=(0,M.toUint32)(h),this._getPrefixSum(h))}_getPrefixSum(h){if(h<=this.prefixSumValidIndex[0])return this.prefixSum[h];let l=this.prefixSumValidIndex[0]+1;l===0&&(this.prefixSum[0]=this.values[0],l++),h>=this.values.length&&(h=this.values.length-1);for(let w=l;w<=h;w++)this.prefixSum[w]=this.prefixSum[w-1]+this.values[w];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],h),this.prefixSum[h]}getIndexOf(h){h=Math.floor(h),this.getTotalSum();let l=0,w=this.values.length-1,e=0,s=0,o=0;for(;l<=w;)if(e=l+(w-l)/2|0,s=this.prefixSum[e],o=s-this.values[e],h<o)w=e-1;else if(h>=s)l=e+1;else break;return new v(e,h-o)}}t.PrefixSumComputer=R;class d{constructor(h){this._values=h,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(h){return this._ensureValid(),h===0?0:this._prefixSum[h-1]}getIndexOf(h){this._ensureValid();const l=this._indexBySum[h],w=l>0?this._prefixSum[l-1]:0;return new v(l,h-w)}removeValues(h,l){this._values.splice(h,l),this._invalidate(h)}insertValues(h,l){this._values=(0,r.arrayInsert)(this._values,h,l),this._invalidate(h)}_invalidate(h){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,h-1)}_ensureValid(){if(!this._isValid){for(let h=this._validEndIndex+1,l=this._values.length;h<l;h++){const w=this._values[h],e=h>0?this._prefixSum[h-1]:0;this._prefixSum[h]=e+w;for(let s=0;s<w;s++)this._indexBySum[e+s]=h}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(h,l){this._values[h]!==l&&(this._values[h]=l,this._invalidate(h))}}t.ConstantTimePrefixSumComputer=d;class v{constructor(h,l){this.index=h,this.remainder=l,this._prefixSumIndexOfResultBrand=void 0,this.index=h,this.remainder=l}}t.PrefixSumIndexOfResult=v}),X(Z[57],K([0,1,6,4,56]),function(q,t,r,M,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MirrorTextModel=void 0;class d{constructor(L,h,l,w){this._uri=L,this._lines=h,this._eol=l,this._versionId=w,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(L){L.eol&&L.eol!==this._eol&&(this._eol=L.eol,this._lineStarts=null);const h=L.changes;for(const l of h)this._acceptDeleteRange(l.range),this._acceptInsertText(new M.Position(l.range.startLineNumber,l.range.startColumn),l.text);this._versionId=L.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const L=this._eol.length,h=this._lines.length,l=new Uint32Array(h);for(let w=0;w<h;w++)l[w]=this._lines[w].length+L;this._lineStarts=new R.PrefixSumComputer(l)}}_setLineText(L,h){this._lines[L]=h,this._lineStarts&&this._lineStarts.setValue(L,this._lines[L].length+this._eol.length)}_acceptDeleteRange(L){if(L.startLineNumber===L.endLineNumber){if(L.startColumn===L.endColumn)return;this._setLineText(L.startLineNumber-1,this._lines[L.startLineNumber-1].substring(0,L.startColumn-1)+this._lines[L.startLineNumber-1].substring(L.endColumn-1));return}this._setLineText(L.startLineNumber-1,this._lines[L.startLineNumber-1].substring(0,L.startColumn-1)+this._lines[L.endLineNumber-1].substring(L.endColumn-1)),this._lines.splice(L.startLineNumber,L.endLineNumber-L.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(L.startLineNumber,L.endLineNumber-L.startLineNumber)}_acceptInsertText(L,h){if(h.length===0)return;const l=(0,r.splitLines)(h);if(l.length===1){this._setLineText(L.lineNumber-1,this._lines[L.lineNumber-1].substring(0,L.column-1)+l[0]+this._lines[L.lineNumber-1].substring(L.column-1));return}l[l.length-1]+=this._lines[L.lineNumber-1].substring(L.column-1),this._setLineText(L.lineNumber-1,this._lines[L.lineNumber-1].substring(0,L.column-1)+l[0]);const w=new Uint32Array(l.length-1);for(let e=1;e<l.length;e++)this._lines.splice(L.lineNumber+e-1,0,l[e]),w[e-1]=l[e].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(L.lineNumber,w)}}t.MirrorTextModel=d}),X(Z[58],K([0,1,6,44,4,2,55]),function(q,t,r,M,R,d,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Searcher=t.isValidMatch=t.TextModelSearch=t.createFindMatch=t.isMultilineRegexSource=t.SearchParams=void 0;const L=999;class h{constructor(C,E,S,_){this.searchString=C,this.isRegex=E,this.matchCase=S,this.wordSeparators=_}parseSearchRequest(){if(this.searchString==="")return null;let C;this.isRegex?C=l(this.searchString):C=this.searchString.indexOf(`
`)>=0;let E=null;try{E=r.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:C,global:!0,unicode:!0})}catch{return null}if(!E)return null;let S=!this.isRegex&&!C;return S&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(S=this.matchCase),new v.SearchData(E,this.wordSeparators?(0,M.getMapForWordSeparators)(this.wordSeparators):null,S?this.searchString:null)}}t.SearchParams=h;function l(y){if(!y||y.length===0)return!1;for(let C=0,E=y.length;C<E;C++){const S=y.charCodeAt(C);if(S===10)return!0;if(S===92){if(C++,C>=E)break;const _=y.charCodeAt(C);if(_===110||_===114||_===87)return!0}}return!1}t.isMultilineRegexSource=l;function w(y,C,E){if(!E)return new v.FindMatch(y,null);const S=[];for(let _=0,i=C.length;_<i;_++)S[_]=C[_];return new v.FindMatch(y,S)}t.createFindMatch=w;class e{constructor(C){const E=[];let S=0;for(let _=0,i=C.length;_<i;_++)C.charCodeAt(_)===10&&(E[S++]=_);this._lineFeedsOffsets=E}findLineFeedCountBeforeOffset(C){const E=this._lineFeedsOffsets;let S=0,_=E.length-1;if(_===-1||C<=E[0])return 0;for(;S<_;){const i=S+((_-S)/2>>0);E[i]>=C?_=i-1:E[i+1]>=C?(S=i,_=i):S=i+1}return S+1}}class s{static findMatches(C,E,S,_,i){const a=E.parseSearchRequest();return a?a.regex.multiline?this._doFindMatchesMultiline(C,S,new c(a.wordSeparators,a.regex),_,i):this._doFindMatchesLineByLine(C,S,a,_,i):[]}static _getMultilineMatchRange(C,E,S,_,i,a){let g,b=0;_?(b=_.findLineFeedCountBeforeOffset(i),g=E+i+b):g=E+i;let f;if(_){const D=_.findLineFeedCountBeforeOffset(i+a.length)-b;f=g+a.length+D}else f=g+a.length;const p=C.getPositionAt(g),N=C.getPositionAt(f);return new d.Range(p.lineNumber,p.column,N.lineNumber,N.column)}static _doFindMatchesMultiline(C,E,S,_,i){const a=C.getOffsetAt(E.getStartPosition()),g=C.getValueInRange(E,1),b=C.getEOL()===`\r
`?new e(g):null,f=[];let p=0,N;for(S.reset(0);N=S.next(g);)if(f[p++]=w(this._getMultilineMatchRange(C,a,g,b,N.index,N[0]),N,_),p>=i)return f;return f}static _doFindMatchesLineByLine(C,E,S,_,i){const a=[];let g=0;if(E.startLineNumber===E.endLineNumber){const f=C.getLineContent(E.startLineNumber).substring(E.startColumn-1,E.endColumn-1);return g=this._findMatchesInLine(S,f,E.startLineNumber,E.startColumn-1,g,a,_,i),a}const b=C.getLineContent(E.startLineNumber).substring(E.startColumn-1);g=this._findMatchesInLine(S,b,E.startLineNumber,E.startColumn-1,g,a,_,i);for(let f=E.startLineNumber+1;f<E.endLineNumber&&g<i;f++)g=this._findMatchesInLine(S,C.getLineContent(f),f,0,g,a,_,i);if(g<i){const f=C.getLineContent(E.endLineNumber).substring(0,E.endColumn-1);g=this._findMatchesInLine(S,f,E.endLineNumber,0,g,a,_,i)}return a}static _findMatchesInLine(C,E,S,_,i,a,g,b){const f=C.wordSeparators;if(!g&&C.simpleSearch){const A=C.simpleSearch,D=A.length,P=E.length;let T=-D;for(;(T=E.indexOf(A,T+D))!==-1;)if((!f||m(f,E,P,T,D))&&(a[i++]=new v.FindMatch(new d.Range(S,T+1+_,S,T+1+D+_),null),i>=b))return i;return i}const p=new c(C.wordSeparators,C.regex);let N;p.reset(0);do if(N=p.next(E),N&&(a[i++]=w(new d.Range(S,N.index+1+_,S,N.index+1+N[0].length+_),N,g),i>=b))return i;while(N);return i}static findNextMatch(C,E,S,_){const i=E.parseSearchRequest();if(!i)return null;const a=new c(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindNextMatchMultiline(C,S,a,_):this._doFindNextMatchLineByLine(C,S,a,_)}static _doFindNextMatchMultiline(C,E,S,_){const i=new R.Position(E.lineNumber,1),a=C.getOffsetAt(i),g=C.getLineCount(),b=C.getValueInRange(new d.Range(i.lineNumber,i.column,g,C.getLineMaxColumn(g)),1),f=C.getEOL()===`\r
`?new e(b):null;S.reset(E.column-1);const p=S.next(b);return p?w(this._getMultilineMatchRange(C,a,b,f,p.index,p[0]),p,_):E.lineNumber!==1||E.column!==1?this._doFindNextMatchMultiline(C,new R.Position(1,1),S,_):null}static _doFindNextMatchLineByLine(C,E,S,_){const i=C.getLineCount(),a=E.lineNumber,g=C.getLineContent(a),b=this._findFirstMatchInLine(S,g,a,E.column,_);if(b)return b;for(let f=1;f<=i;f++){const p=(a+f-1)%i,N=C.getLineContent(p+1),A=this._findFirstMatchInLine(S,N,p+1,1,_);if(A)return A}return null}static _findFirstMatchInLine(C,E,S,_,i){C.reset(_-1);const a=C.next(E);return a?w(new d.Range(S,a.index+1,S,a.index+1+a[0].length),a,i):null}static findPreviousMatch(C,E,S,_){const i=E.parseSearchRequest();if(!i)return null;const a=new c(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindPreviousMatchMultiline(C,S,a,_):this._doFindPreviousMatchLineByLine(C,S,a,_)}static _doFindPreviousMatchMultiline(C,E,S,_){const i=this._doFindMatchesMultiline(C,new d.Range(1,1,E.lineNumber,E.column),S,_,10*L);if(i.length>0)return i[i.length-1];const a=C.getLineCount();return E.lineNumber!==a||E.column!==C.getLineMaxColumn(a)?this._doFindPreviousMatchMultiline(C,new R.Position(a,C.getLineMaxColumn(a)),S,_):null}static _doFindPreviousMatchLineByLine(C,E,S,_){const i=C.getLineCount(),a=E.lineNumber,g=C.getLineContent(a).substring(0,E.column-1),b=this._findLastMatchInLine(S,g,a,_);if(b)return b;for(let f=1;f<=i;f++){const p=(i+a-f-1)%i,N=C.getLineContent(p+1),A=this._findLastMatchInLine(S,N,p+1,_);if(A)return A}return null}static _findLastMatchInLine(C,E,S,_){let i=null,a;for(C.reset(0);a=C.next(E);)i=w(new d.Range(S,a.index+1,S,a.index+1+a[0].length),a,_);return i}}t.TextModelSearch=s;function o(y,C,E,S,_){if(S===0)return!0;const i=C.charCodeAt(S-1);if(y.get(i)!==0||i===13||i===10)return!0;if(_>0){const a=C.charCodeAt(S);if(y.get(a)!==0)return!0}return!1}function u(y,C,E,S,_){if(S+_===E)return!0;const i=C.charCodeAt(S+_);if(y.get(i)!==0||i===13||i===10)return!0;if(_>0){const a=C.charCodeAt(S+_-1);if(y.get(a)!==0)return!0}return!1}function m(y,C,E,S,_){return o(y,C,E,S,_)&&u(y,C,E,S,_)}t.isValidMatch=m;class c{constructor(C,E){this._wordSeparators=C,this._searchRegex=E,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(C){this._searchRegex.lastIndex=C,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(C){const E=C.length;let S;do{if(this._prevMatchStartIndex+this._prevMatchLength===E||(S=this._searchRegex.exec(C),!S))return null;const _=S.index,i=S[0].length;if(_===this._prevMatchStartIndex&&i===this._prevMatchLength){if(i===0){r.getNextCodePoint(C,E,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=_,this._prevMatchLength=i,!this._wordSeparators||m(this._wordSeparators,C,E,_,i))return S}while(S);return null}}t.Searcher=c}),X(Z[59],K([0,1,2,58,6,12,29]),function(q,t,r,M,R,d,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnicodeTextModelHighlighter=void 0;class L{static computeUnicodeHighlights(s,o,u){const m=u?u.startLineNumber:1,c=u?u.endLineNumber:s.getLineCount(),y=new l(o),C=y.getCandidateCodePoints();let E;C==="allNonBasicAscii"?E=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):E=new RegExp(`${h(Array.from(C))}`,"g");const S=new M.Searcher(null,E),_=[];let i=!1,a,g=0,b=0,f=0;e:for(let p=m,N=c;p<=N;p++){const A=s.getLineContent(p),D=A.length;S.reset(0);do if(a=S.next(A),a){let P=a.index,T=a.index+a[0].length;if(P>0){const x=A.charCodeAt(P-1);R.isHighSurrogate(x)&&P--}if(T+1<D){const x=A.charCodeAt(T-1);R.isHighSurrogate(x)&&T++}const I=A.substring(P,T);let W=(0,v.getWordAtText)(P+1,v.DEFAULT_WORD_REGEXP,A,0);W&&W.endColumn<=P+1&&(W=null);const H=y.shouldHighlightNonBasicASCII(I,W?W.word:null);if(H!==0){if(H===3?g++:H===2?b++:H===1?f++:(0,d.assertNever)(H),_.length>=1e3){i=!0;break e}_.push(new r.Range(p,P+1,p,T+1))}}while(a)}return{ranges:_,hasMore:i,ambiguousCharacterCount:g,invisibleCharacterCount:b,nonBasicAsciiCharacterCount:f}}static computeUnicodeHighlightReason(s,o){const u=new l(o);switch(u.shouldHighlightNonBasicASCII(s,null)){case 0:return null;case 2:return{kind:1};case 3:{const c=s.codePointAt(0),y=u.ambiguousCharacters.getPrimaryConfusable(c),C=R.AmbiguousCharacters.getLocales().filter(E=>!R.AmbiguousCharacters.getInstance(new Set([...o.allowedLocales,E])).isAmbiguous(c));return{kind:0,confusableWith:String.fromCodePoint(y),notAmbiguousInLocales:C}}case 1:return{kind:2}}}}t.UnicodeTextModelHighlighter=L;function h(e,s){return`[${R.escapeRegExpCharacters(e.map(u=>String.fromCodePoint(u)).join(""))}]`}class l{constructor(s){this.options=s,this.allowedCodePoints=new Set(s.allowedCodePoints),this.ambiguousCharacters=R.AmbiguousCharacters.getInstance(new Set(s.allowedLocales))}getCandidateCodePoints(){if(this.options.nonBasicASCII)return"allNonBasicAscii";const s=new Set;if(this.options.invisibleCharacters)for(const o of R.InvisibleCharacters.codePoints)w(String.fromCodePoint(o))||s.add(o);if(this.options.ambiguousCharacters)for(const o of this.ambiguousCharacters.getConfusableCodePoints())s.add(o);for(const o of this.allowedCodePoints)s.delete(o);return s}shouldHighlightNonBasicASCII(s,o){const u=s.codePointAt(0);if(this.allowedCodePoints.has(u))return 0;if(this.options.nonBasicASCII)return 1;let m=!1,c=!1;if(o)for(const y of o){const C=y.codePointAt(0),E=R.isBasicASCII(y);m=m||E,!E&&!this.ambiguousCharacters.isAmbiguous(C)&&!R.InvisibleCharacters.isInvisibleCharacter(C)&&(c=!0)}return!m&&c?0:this.options.invisibleCharacters&&!w(s)&&R.InvisibleCharacters.isInvisibleCharacter(u)?2:this.options.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(u)?3:0}}function w(e){return e===" "||e===`
`||e==="	"}}),X(Z[60],K([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.ShowLightbulbIconMode=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.PositionAffinity=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.NewSymbolNameTag=t.MouseTargetType=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineEditTriggerKind=t.InlineCompletionTriggerKind=t.InlayHintKind=t.InjectedTextCursorStops=t.IndentAction=t.GlyphMarginLane=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.CodeActionTriggerType=t.AccessibilitySupport=void 0;var r;(function(n){n[n.Unknown=0]="Unknown",n[n.Disabled=1]="Disabled",n[n.Enabled=2]="Enabled"})(r||(t.AccessibilitySupport=r={}));var M;(function(n){n[n.Invoke=1]="Invoke",n[n.Auto=2]="Auto"})(M||(t.CodeActionTriggerType=M={}));var R;(function(n){n[n.None=0]="None",n[n.KeepWhitespace=1]="KeepWhitespace",n[n.InsertAsSnippet=4]="InsertAsSnippet"})(R||(t.CompletionItemInsertTextRule=R={}));var d;(function(n){n[n.Method=0]="Method",n[n.Function=1]="Function",n[n.Constructor=2]="Constructor",n[n.Field=3]="Field",n[n.Variable=4]="Variable",n[n.Class=5]="Class",n[n.Struct=6]="Struct",n[n.Interface=7]="Interface",n[n.Module=8]="Module",n[n.Property=9]="Property",n[n.Event=10]="Event",n[n.Operator=11]="Operator",n[n.Unit=12]="Unit",n[n.Value=13]="Value",n[n.Constant=14]="Constant",n[n.Enum=15]="Enum",n[n.EnumMember=16]="EnumMember",n[n.Keyword=17]="Keyword",n[n.Text=18]="Text",n[n.Color=19]="Color",n[n.File=20]="File",n[n.Reference=21]="Reference",n[n.Customcolor=22]="Customcolor",n[n.Folder=23]="Folder",n[n.TypeParameter=24]="TypeParameter",n[n.User=25]="User",n[n.Issue=26]="Issue",n[n.Snippet=27]="Snippet"})(d||(t.CompletionItemKind=d={}));var v;(function(n){n[n.Deprecated=1]="Deprecated"})(v||(t.CompletionItemTag=v={}));var L;(function(n){n[n.Invoke=0]="Invoke",n[n.TriggerCharacter=1]="TriggerCharacter",n[n.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(L||(t.CompletionTriggerKind=L={}));var h;(function(n){n[n.EXACT=0]="EXACT",n[n.ABOVE=1]="ABOVE",n[n.BELOW=2]="BELOW"})(h||(t.ContentWidgetPositionPreference=h={}));var l;(function(n){n[n.NotSet=0]="NotSet",n[n.ContentFlush=1]="ContentFlush",n[n.RecoverFromMarkers=2]="RecoverFromMarkers",n[n.Explicit=3]="Explicit",n[n.Paste=4]="Paste",n[n.Undo=5]="Undo",n[n.Redo=6]="Redo"})(l||(t.CursorChangeReason=l={}));var w;(function(n){n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(w||(t.DefaultEndOfLine=w={}));var e;(function(n){n[n.Text=0]="Text",n[n.Read=1]="Read",n[n.Write=2]="Write"})(e||(t.DocumentHighlightKind=e={}));var s;(function(n){n[n.None=0]="None",n[n.Keep=1]="Keep",n[n.Brackets=2]="Brackets",n[n.Advanced=3]="Advanced",n[n.Full=4]="Full"})(s||(t.EditorAutoIndentStrategy=s={}));var o;(function(n){n[n.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",n[n.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",n[n.accessibilitySupport=2]="accessibilitySupport",n[n.accessibilityPageSize=3]="accessibilityPageSize",n[n.ariaLabel=4]="ariaLabel",n[n.ariaRequired=5]="ariaRequired",n[n.autoClosingBrackets=6]="autoClosingBrackets",n[n.autoClosingComments=7]="autoClosingComments",n[n.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",n[n.autoClosingDelete=9]="autoClosingDelete",n[n.autoClosingOvertype=10]="autoClosingOvertype",n[n.autoClosingQuotes=11]="autoClosingQuotes",n[n.autoIndent=12]="autoIndent",n[n.automaticLayout=13]="automaticLayout",n[n.autoSurround=14]="autoSurround",n[n.bracketPairColorization=15]="bracketPairColorization",n[n.guides=16]="guides",n[n.codeLens=17]="codeLens",n[n.codeLensFontFamily=18]="codeLensFontFamily",n[n.codeLensFontSize=19]="codeLensFontSize",n[n.colorDecorators=20]="colorDecorators",n[n.colorDecoratorsLimit=21]="colorDecoratorsLimit",n[n.columnSelection=22]="columnSelection",n[n.comments=23]="comments",n[n.contextmenu=24]="contextmenu",n[n.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",n[n.cursorBlinking=26]="cursorBlinking",n[n.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",n[n.cursorStyle=28]="cursorStyle",n[n.cursorSurroundingLines=29]="cursorSurroundingLines",n[n.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",n[n.cursorWidth=31]="cursorWidth",n[n.disableLayerHinting=32]="disableLayerHinting",n[n.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",n[n.domReadOnly=34]="domReadOnly",n[n.dragAndDrop=35]="dragAndDrop",n[n.dropIntoEditor=36]="dropIntoEditor",n[n.emptySelectionClipboard=37]="emptySelectionClipboard",n[n.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",n[n.extraEditorClassName=39]="extraEditorClassName",n[n.fastScrollSensitivity=40]="fastScrollSensitivity",n[n.find=41]="find",n[n.fixedOverflowWidgets=42]="fixedOverflowWidgets",n[n.folding=43]="folding",n[n.foldingStrategy=44]="foldingStrategy",n[n.foldingHighlight=45]="foldingHighlight",n[n.foldingImportsByDefault=46]="foldingImportsByDefault",n[n.foldingMaximumRegions=47]="foldingMaximumRegions",n[n.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",n[n.fontFamily=49]="fontFamily",n[n.fontInfo=50]="fontInfo",n[n.fontLigatures=51]="fontLigatures",n[n.fontSize=52]="fontSize",n[n.fontWeight=53]="fontWeight",n[n.fontVariations=54]="fontVariations",n[n.formatOnPaste=55]="formatOnPaste",n[n.formatOnType=56]="formatOnType",n[n.glyphMargin=57]="glyphMargin",n[n.gotoLocation=58]="gotoLocation",n[n.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",n[n.hover=60]="hover",n[n.inDiffEditor=61]="inDiffEditor",n[n.inlineSuggest=62]="inlineSuggest",n[n.inlineEdit=63]="inlineEdit",n[n.letterSpacing=64]="letterSpacing",n[n.lightbulb=65]="lightbulb",n[n.lineDecorationsWidth=66]="lineDecorationsWidth",n[n.lineHeight=67]="lineHeight",n[n.lineNumbers=68]="lineNumbers",n[n.lineNumbersMinChars=69]="lineNumbersMinChars",n[n.linkedEditing=70]="linkedEditing",n[n.links=71]="links",n[n.matchBrackets=72]="matchBrackets",n[n.minimap=73]="minimap",n[n.mouseStyle=74]="mouseStyle",n[n.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",n[n.mouseWheelZoom=76]="mouseWheelZoom",n[n.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",n[n.multiCursorModifier=78]="multiCursorModifier",n[n.multiCursorPaste=79]="multiCursorPaste",n[n.multiCursorLimit=80]="multiCursorLimit",n[n.occurrencesHighlight=81]="occurrencesHighlight",n[n.overviewRulerBorder=82]="overviewRulerBorder",n[n.overviewRulerLanes=83]="overviewRulerLanes",n[n.padding=84]="padding",n[n.pasteAs=85]="pasteAs",n[n.parameterHints=86]="parameterHints",n[n.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",n[n.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",n[n.quickSuggestions=89]="quickSuggestions",n[n.quickSuggestionsDelay=90]="quickSuggestionsDelay",n[n.readOnly=91]="readOnly",n[n.readOnlyMessage=92]="readOnlyMessage",n[n.renameOnType=93]="renameOnType",n[n.renderControlCharacters=94]="renderControlCharacters",n[n.renderFinalNewline=95]="renderFinalNewline",n[n.renderLineHighlight=96]="renderLineHighlight",n[n.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",n[n.renderValidationDecorations=98]="renderValidationDecorations",n[n.renderWhitespace=99]="renderWhitespace",n[n.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",n[n.roundedSelection=101]="roundedSelection",n[n.rulers=102]="rulers",n[n.scrollbar=103]="scrollbar",n[n.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",n[n.scrollBeyondLastLine=105]="scrollBeyondLastLine",n[n.scrollPredominantAxis=106]="scrollPredominantAxis",n[n.selectionClipboard=107]="selectionClipboard",n[n.selectionHighlight=108]="selectionHighlight",n[n.selectOnLineNumbers=109]="selectOnLineNumbers",n[n.showFoldingControls=110]="showFoldingControls",n[n.showUnused=111]="showUnused",n[n.snippetSuggestions=112]="snippetSuggestions",n[n.smartSelect=113]="smartSelect",n[n.smoothScrolling=114]="smoothScrolling",n[n.stickyScroll=115]="stickyScroll",n[n.stickyTabStops=116]="stickyTabStops",n[n.stopRenderingLineAfter=117]="stopRenderingLineAfter",n[n.suggest=118]="suggest",n[n.suggestFontSize=119]="suggestFontSize",n[n.suggestLineHeight=120]="suggestLineHeight",n[n.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",n[n.suggestSelection=122]="suggestSelection",n[n.tabCompletion=123]="tabCompletion",n[n.tabIndex=124]="tabIndex",n[n.unicodeHighlighting=125]="unicodeHighlighting",n[n.unusualLineTerminators=126]="unusualLineTerminators",n[n.useShadowDOM=127]="useShadowDOM",n[n.useTabStops=128]="useTabStops",n[n.wordBreak=129]="wordBreak",n[n.wordSeparators=130]="wordSeparators",n[n.wordWrap=131]="wordWrap",n[n.wordWrapBreakAfterCharacters=132]="wordWrapBreakAfterCharacters",n[n.wordWrapBreakBeforeCharacters=133]="wordWrapBreakBeforeCharacters",n[n.wordWrapColumn=134]="wordWrapColumn",n[n.wordWrapOverride1=135]="wordWrapOverride1",n[n.wordWrapOverride2=136]="wordWrapOverride2",n[n.wrappingIndent=137]="wrappingIndent",n[n.wrappingStrategy=138]="wrappingStrategy",n[n.showDeprecated=139]="showDeprecated",n[n.inlayHints=140]="inlayHints",n[n.editorClassName=141]="editorClassName",n[n.pixelRatio=142]="pixelRatio",n[n.tabFocusMode=143]="tabFocusMode",n[n.layoutInfo=144]="layoutInfo",n[n.wrappingInfo=145]="wrappingInfo",n[n.defaultColorDecorators=146]="defaultColorDecorators",n[n.colorDecoratorsActivatedOn=147]="colorDecoratorsActivatedOn",n[n.inlineCompletionsAccessibilityVerbose=148]="inlineCompletionsAccessibilityVerbose"})(o||(t.EditorOption=o={}));var u;(function(n){n[n.TextDefined=0]="TextDefined",n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(u||(t.EndOfLinePreference=u={}));var m;(function(n){n[n.LF=0]="LF",n[n.CRLF=1]="CRLF"})(m||(t.EndOfLineSequence=m={}));var c;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=3]="Right"})(c||(t.GlyphMarginLane=c={}));var y;(function(n){n[n.None=0]="None",n[n.Indent=1]="Indent",n[n.IndentOutdent=2]="IndentOutdent",n[n.Outdent=3]="Outdent"})(y||(t.IndentAction=y={}));var C;(function(n){n[n.Both=0]="Both",n[n.Right=1]="Right",n[n.Left=2]="Left",n[n.None=3]="None"})(C||(t.InjectedTextCursorStops=C={}));var E;(function(n){n[n.Type=1]="Type",n[n.Parameter=2]="Parameter"})(E||(t.InlayHintKind=E={}));var S;(function(n){n[n.Automatic=0]="Automatic",n[n.Explicit=1]="Explicit"})(S||(t.InlineCompletionTriggerKind=S={}));var _;(function(n){n[n.Invoke=0]="Invoke",n[n.Automatic=1]="Automatic"})(_||(t.InlineEditTriggerKind=_={}));var i;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.Unknown=0]="Unknown",n[n.Backspace=1]="Backspace",n[n.Tab=2]="Tab",n[n.Enter=3]="Enter",n[n.Shift=4]="Shift",n[n.Ctrl=5]="Ctrl",n[n.Alt=6]="Alt",n[n.PauseBreak=7]="PauseBreak",n[n.CapsLock=8]="CapsLock",n[n.Escape=9]="Escape",n[n.Space=10]="Space",n[n.PageUp=11]="PageUp",n[n.PageDown=12]="PageDown",n[n.End=13]="End",n[n.Home=14]="Home",n[n.LeftArrow=15]="LeftArrow",n[n.UpArrow=16]="UpArrow",n[n.RightArrow=17]="RightArrow",n[n.DownArrow=18]="DownArrow",n[n.Insert=19]="Insert",n[n.Delete=20]="Delete",n[n.Digit0=21]="Digit0",n[n.Digit1=22]="Digit1",n[n.Digit2=23]="Digit2",n[n.Digit3=24]="Digit3",n[n.Digit4=25]="Digit4",n[n.Digit5=26]="Digit5",n[n.Digit6=27]="Digit6",n[n.Digit7=28]="Digit7",n[n.Digit8=29]="Digit8",n[n.Digit9=30]="Digit9",n[n.KeyA=31]="KeyA",n[n.KeyB=32]="KeyB",n[n.KeyC=33]="KeyC",n[n.KeyD=34]="KeyD",n[n.KeyE=35]="KeyE",n[n.KeyF=36]="KeyF",n[n.KeyG=37]="KeyG",n[n.KeyH=38]="KeyH",n[n.KeyI=39]="KeyI",n[n.KeyJ=40]="KeyJ",n[n.KeyK=41]="KeyK",n[n.KeyL=42]="KeyL",n[n.KeyM=43]="KeyM",n[n.KeyN=44]="KeyN",n[n.KeyO=45]="KeyO",n[n.KeyP=46]="KeyP",n[n.KeyQ=47]="KeyQ",n[n.KeyR=48]="KeyR",n[n.KeyS=49]="KeyS",n[n.KeyT=50]="KeyT",n[n.KeyU=51]="KeyU",n[n.KeyV=52]="KeyV",n[n.KeyW=53]="KeyW",n[n.KeyX=54]="KeyX",n[n.KeyY=55]="KeyY",n[n.KeyZ=56]="KeyZ",n[n.Meta=57]="Meta",n[n.ContextMenu=58]="ContextMenu",n[n.F1=59]="F1",n[n.F2=60]="F2",n[n.F3=61]="F3",n[n.F4=62]="F4",n[n.F5=63]="F5",n[n.F6=64]="F6",n[n.F7=65]="F7",n[n.F8=66]="F8",n[n.F9=67]="F9",n[n.F10=68]="F10",n[n.F11=69]="F11",n[n.F12=70]="F12",n[n.F13=71]="F13",n[n.F14=72]="F14",n[n.F15=73]="F15",n[n.F16=74]="F16",n[n.F17=75]="F17",n[n.F18=76]="F18",n[n.F19=77]="F19",n[n.F20=78]="F20",n[n.F21=79]="F21",n[n.F22=80]="F22",n[n.F23=81]="F23",n[n.F24=82]="F24",n[n.NumLock=83]="NumLock",n[n.ScrollLock=84]="ScrollLock",n[n.Semicolon=85]="Semicolon",n[n.Equal=86]="Equal",n[n.Comma=87]="Comma",n[n.Minus=88]="Minus",n[n.Period=89]="Period",n[n.Slash=90]="Slash",n[n.Backquote=91]="Backquote",n[n.BracketLeft=92]="BracketLeft",n[n.Backslash=93]="Backslash",n[n.BracketRight=94]="BracketRight",n[n.Quote=95]="Quote",n[n.OEM_8=96]="OEM_8",n[n.IntlBackslash=97]="IntlBackslash",n[n.Numpad0=98]="Numpad0",n[n.Numpad1=99]="Numpad1",n[n.Numpad2=100]="Numpad2",n[n.Numpad3=101]="Numpad3",n[n.Numpad4=102]="Numpad4",n[n.Numpad5=103]="Numpad5",n[n.Numpad6=104]="Numpad6",n[n.Numpad7=105]="Numpad7",n[n.Numpad8=106]="Numpad8",n[n.Numpad9=107]="Numpad9",n[n.NumpadMultiply=108]="NumpadMultiply",n[n.NumpadAdd=109]="NumpadAdd",n[n.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",n[n.NumpadSubtract=111]="NumpadSubtract",n[n.NumpadDecimal=112]="NumpadDecimal",n[n.NumpadDivide=113]="NumpadDivide",n[n.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",n[n.ABNT_C1=115]="ABNT_C1",n[n.ABNT_C2=116]="ABNT_C2",n[n.AudioVolumeMute=117]="AudioVolumeMute",n[n.AudioVolumeUp=118]="AudioVolumeUp",n[n.AudioVolumeDown=119]="AudioVolumeDown",n[n.BrowserSearch=120]="BrowserSearch",n[n.BrowserHome=121]="BrowserHome",n[n.BrowserBack=122]="BrowserBack",n[n.BrowserForward=123]="BrowserForward",n[n.MediaTrackNext=124]="MediaTrackNext",n[n.MediaTrackPrevious=125]="MediaTrackPrevious",n[n.MediaStop=126]="MediaStop",n[n.MediaPlayPause=127]="MediaPlayPause",n[n.LaunchMediaPlayer=128]="LaunchMediaPlayer",n[n.LaunchMail=129]="LaunchMail",n[n.LaunchApp2=130]="LaunchApp2",n[n.Clear=131]="Clear",n[n.MAX_VALUE=132]="MAX_VALUE"})(i||(t.KeyCode=i={}));var a;(function(n){n[n.Hint=1]="Hint",n[n.Info=2]="Info",n[n.Warning=4]="Warning",n[n.Error=8]="Error"})(a||(t.MarkerSeverity=a={}));var g;(function(n){n[n.Unnecessary=1]="Unnecessary",n[n.Deprecated=2]="Deprecated"})(g||(t.MarkerTag=g={}));var b;(function(n){n[n.Inline=1]="Inline",n[n.Gutter=2]="Gutter"})(b||(t.MinimapPosition=b={}));var f;(function(n){n[n.UNKNOWN=0]="UNKNOWN",n[n.TEXTAREA=1]="TEXTAREA",n[n.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",n[n.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",n[n.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",n[n.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",n[n.CONTENT_TEXT=6]="CONTENT_TEXT",n[n.CONTENT_EMPTY=7]="CONTENT_EMPTY",n[n.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",n[n.CONTENT_WIDGET=9]="CONTENT_WIDGET",n[n.OVERVIEW_RULER=10]="OVERVIEW_RULER",n[n.SCROLLBAR=11]="SCROLLBAR",n[n.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",n[n.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(f||(t.MouseTargetType=f={}));var p;(function(n){n[n.AIGenerated=1]="AIGenerated"})(p||(t.NewSymbolNameTag=p={}));var N;(function(n){n[n.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",n[n.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",n[n.TOP_CENTER=2]="TOP_CENTER"})(N||(t.OverlayWidgetPositionPreference=N={}));var A;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=4]="Right",n[n.Full=7]="Full"})(A||(t.OverviewRulerLane=A={}));var D;(function(n){n[n.Left=0]="Left",n[n.Right=1]="Right",n[n.None=2]="None",n[n.LeftOfInjectedText=3]="LeftOfInjectedText",n[n.RightOfInjectedText=4]="RightOfInjectedText"})(D||(t.PositionAffinity=D={}));var P;(function(n){n[n.Off=0]="Off",n[n.On=1]="On",n[n.Relative=2]="Relative",n[n.Interval=3]="Interval",n[n.Custom=4]="Custom"})(P||(t.RenderLineNumbersType=P={}));var T;(function(n){n[n.None=0]="None",n[n.Text=1]="Text",n[n.Blocks=2]="Blocks"})(T||(t.RenderMinimap=T={}));var I;(function(n){n[n.Smooth=0]="Smooth",n[n.Immediate=1]="Immediate"})(I||(t.ScrollType=I={}));var W;(function(n){n[n.Auto=1]="Auto",n[n.Hidden=2]="Hidden",n[n.Visible=3]="Visible"})(W||(t.ScrollbarVisibility=W={}));var H;(function(n){n[n.LTR=0]="LTR",n[n.RTL=1]="RTL"})(H||(t.SelectionDirection=H={}));var x;(function(n){n.Off="off",n.OnCode="onCode",n.On="on"})(x||(t.ShowLightbulbIconMode=x={}));var O;(function(n){n[n.Invoke=1]="Invoke",n[n.TriggerCharacter=2]="TriggerCharacter",n[n.ContentChange=3]="ContentChange"})(O||(t.SignatureHelpTriggerKind=O={}));var F;(function(n){n[n.File=0]="File",n[n.Module=1]="Module",n[n.Namespace=2]="Namespace",n[n.Package=3]="Package",n[n.Class=4]="Class",n[n.Method=5]="Method",n[n.Property=6]="Property",n[n.Field=7]="Field",n[n.Constructor=8]="Constructor",n[n.Enum=9]="Enum",n[n.Interface=10]="Interface",n[n.Function=11]="Function",n[n.Variable=12]="Variable",n[n.Constant=13]="Constant",n[n.String=14]="String",n[n.Number=15]="Number",n[n.Boolean=16]="Boolean",n[n.Array=17]="Array",n[n.Object=18]="Object",n[n.Key=19]="Key",n[n.Null=20]="Null",n[n.EnumMember=21]="EnumMember",n[n.Struct=22]="Struct",n[n.Event=23]="Event",n[n.Operator=24]="Operator",n[n.TypeParameter=25]="TypeParameter"})(F||(t.SymbolKind=F={}));var V;(function(n){n[n.Deprecated=1]="Deprecated"})(V||(t.SymbolTag=V={}));var j;(function(n){n[n.Hidden=0]="Hidden",n[n.Blink=1]="Blink",n[n.Smooth=2]="Smooth",n[n.Phase=3]="Phase",n[n.Expand=4]="Expand",n[n.Solid=5]="Solid"})(j||(t.TextEditorCursorBlinkingStyle=j={}));var Q;(function(n){n[n.Line=1]="Line",n[n.Block=2]="Block",n[n.Underline=3]="Underline",n[n.LineThin=4]="LineThin",n[n.BlockOutline=5]="BlockOutline",n[n.UnderlineThin=6]="UnderlineThin"})(Q||(t.TextEditorCursorStyle=Q={}));var ne;(function(n){n[n.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",n[n.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",n[n.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",n[n.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(ne||(t.TrackedRangeStickiness=ne={}));var se;(function(n){n[n.None=0]="None",n[n.Same=1]="Same",n[n.Indent=2]="Indent",n[n.DeepIndent=3]="DeepIndent"})(se||(t.WrappingIndent=se={}))}),X(Z[61],K([0,1,9,13]),function(q,t,r,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TokenizationRegistry=void 0;class R{constructor(){this._tokenizationSupports=new Map,this._factories=new Map,this._onDidChange=new r.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}handleChange(L){this._onDidChange.fire({changedLanguages:L,changedColorMap:!1})}register(L,h){return this._tokenizationSupports.set(L,h),this.handleChange([L]),(0,M.toDisposable)(()=>{this._tokenizationSupports.get(L)===h&&(this._tokenizationSupports.delete(L),this.handleChange([L]))})}get(L){return this._tokenizationSupports.get(L)||null}registerFactory(L,h){var l;(l=this._factories.get(L))===null||l===void 0||l.dispose();const w=new d(this,L,h);return this._factories.set(L,w),(0,M.toDisposable)(()=>{const e=this._factories.get(L);!e||e!==w||(this._factories.delete(L),e.dispose())})}async getOrCreate(L){const h=this.get(L);if(h)return h;const l=this._factories.get(L);return!l||l.isResolved?null:(await l.resolve(),this.get(L))}isResolved(L){if(this.get(L))return!0;const l=this._factories.get(L);return!!(!l||l.isResolved)}setColorMap(L){this._colorMap=L,this._onDidChange.fire({changedLanguages:Array.from(this._tokenizationSupports.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}t.TokenizationRegistry=R;class d extends M.Disposable{get isResolved(){return this._isResolved}constructor(L,h,l){super(),this._registry=L,this._languageId=h,this._factory=l,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const L=await this._factory.tokenizationSupport;this._isResolved=!0,L&&!this._isDisposed&&this._register(this._registry.register(this._languageId,L))}}}),X(Z[62],K([19,63]),function(q,t){return q.create("vs/base/common/platform",t)}),X(Z[17],K([0,1,62]),function(q,t,r){"use strict";var M;Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isEdge=t.isSafari=t.isFirefox=t.isChrome=t.isLittleEndian=t.OS=t.setTimeout0=t.setTimeout0IsFaster=t.language=t.userAgent=t.isMobile=t.isIOS=t.webWorkerOrigin=t.isWebWorker=t.isWeb=t.isNative=t.isLinux=t.isMacintosh=t.isWindows=t.LANGUAGE_DEFAULT=void 0,t.LANGUAGE_DEFAULT="en";let R=!1,d=!1,v=!1,L=!1,h=!1,l=!1,w=!1,e=!1,s=!1,o=!1,u,m=t.LANGUAGE_DEFAULT,c=t.LANGUAGE_DEFAULT,y,C;const E=globalThis;let S;typeof E.vscode<"u"&&typeof E.vscode.process<"u"?S=E.vscode.process:typeof process<"u"&&(S=process);const _=typeof((M=S?.versions)===null||M===void 0?void 0:M.electron)=="string",i=_&&S?.type==="renderer";if(typeof S=="object"){R=S.platform==="win32",d=S.platform==="darwin",v=S.platform==="linux",L=v&&!!S.env.SNAP&&!!S.env.SNAP_REVISION,w=_,s=!!S.env.CI||!!S.env.BUILD_ARTIFACTSTAGINGDIRECTORY,u=t.LANGUAGE_DEFAULT,m=t.LANGUAGE_DEFAULT;const p=S.env.VSCODE_NLS_CONFIG;if(p)try{const N=JSON.parse(p),A=N.availableLanguages["*"];u=N.locale,c=N.osLocale,m=A||t.LANGUAGE_DEFAULT,y=N._translationsConfigFile}catch{}h=!0}else typeof navigator=="object"&&!i?(C=navigator.userAgent,R=C.indexOf("Windows")>=0,d=C.indexOf("Macintosh")>=0,e=(C.indexOf("Macintosh")>=0||C.indexOf("iPad")>=0||C.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,v=C.indexOf("Linux")>=0,o=C?.indexOf("Mobi")>=0,l=!0,u=r.getConfiguredDefaultLocale(r.localize(0,null))||t.LANGUAGE_DEFAULT,m=u,c=navigator.language):console.error("Unable to resolve platform.");let a=0;d?a=1:R?a=3:v&&(a=2),t.isWindows=R,t.isMacintosh=d,t.isLinux=v,t.isNative=h,t.isWeb=l,t.isWebWorker=l&&typeof E.importScripts=="function",t.webWorkerOrigin=t.isWebWorker?E.origin:void 0,t.isIOS=e,t.isMobile=o,t.userAgent=C,t.language=m,t.setTimeout0IsFaster=typeof E.postMessage=="function"&&!E.importScripts,t.setTimeout0=(()=>{if(t.setTimeout0IsFaster){const p=[];E.addEventListener("message",A=>{if(A.data&&A.data.vscodeScheduleAsyncWork)for(let D=0,P=p.length;D<P;D++){const T=p[D];if(T.id===A.data.vscodeScheduleAsyncWork){p.splice(D,1),T.callback();return}}});let N=0;return A=>{const D=++N;p.push({id:D,callback:A}),E.postMessage({vscodeScheduleAsyncWork:D},"*")}}return p=>setTimeout(p)})(),t.OS=d||e?2:R?1:3;let g=!0,b=!1;function f(){if(!b){b=!0;const p=new Uint8Array(2);p[0]=1,p[1]=2,g=new Uint16Array(p.buffer)[0]===513}return g}t.isLittleEndian=f,t.isChrome=!!(t.userAgent&&t.userAgent.indexOf("Chrome")>=0),t.isFirefox=!!(t.userAgent&&t.userAgent.indexOf("Firefox")>=0),t.isSafari=!!(!t.isChrome&&t.userAgent&&t.userAgent.indexOf("Safari")>=0),t.isEdge=!!(t.userAgent&&t.userAgent.indexOf("Edg/")>=0),t.isAndroid=!!(t.userAgent&&t.userAgent.indexOf("Android")>=0)}),X(Z[64],K([0,1,17]),function(q,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.platform=t.env=t.cwd=void 0;let M;const R=globalThis.vscode;if(typeof R<"u"&&typeof R.process<"u"){const d=R.process;M={get platform(){return d.platform},get arch(){return d.arch},get env(){return d.env},cwd(){return d.cwd()}}}else typeof process<"u"?M={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:M={get platform(){return r.isWindows?"win32":r.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=M.cwd,t.env=M.env,t.platform=M.platform}),X(Z[65],K([0,1,64]),function(q,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.sep=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.normalize=t.posix=t.win32=void 0;const M=65,R=97,d=90,v=122,L=46,h=47,l=92,w=58,e=63;class s extends Error{constructor(a,g,b){let f;typeof g=="string"&&g.indexOf("not ")===0?(f="must not be",g=g.replace(/^not /,"")):f="must be";const p=a.indexOf(".")!==-1?"property":"argument";let N=`The "${a}" ${p} ${f} of type ${g}`;N+=`. Received type ${typeof b}`,super(N),this.code="ERR_INVALID_ARG_TYPE"}}function o(i,a){if(i===null||typeof i!="object")throw new s(a,"Object",i)}function u(i,a){if(typeof i!="string")throw new s(a,"string",i)}const m=r.platform==="win32";function c(i){return i===h||i===l}function y(i){return i===h}function C(i){return i>=M&&i<=d||i>=R&&i<=v}function E(i,a,g,b){let f="",p=0,N=-1,A=0,D=0;for(let P=0;P<=i.length;++P){if(P<i.length)D=i.charCodeAt(P);else{if(b(D))break;D=h}if(b(D)){if(!(N===P-1||A===1))if(A===2){if(f.length<2||p!==2||f.charCodeAt(f.length-1)!==L||f.charCodeAt(f.length-2)!==L){if(f.length>2){const T=f.lastIndexOf(g);T===-1?(f="",p=0):(f=f.slice(0,T),p=f.length-1-f.lastIndexOf(g)),N=P,A=0;continue}else if(f.length!==0){f="",p=0,N=P,A=0;continue}}a&&(f+=f.length>0?`${g}..`:"..",p=2)}else f.length>0?f+=`${g}${i.slice(N+1,P)}`:f=i.slice(N+1,P),p=P-N-1;N=P,A=0}else D===L&&A!==-1?++A:A=-1}return f}function S(i,a){o(a,"pathObject");const g=a.dir||a.root,b=a.base||`${a.name||""}${a.ext||""}`;return g?g===a.root?`${g}${b}`:`${g}${i}${b}`:b}t.win32={resolve(...i){let a="",g="",b=!1;for(let f=i.length-1;f>=-1;f--){let p;if(f>=0){if(p=i[f],u(p,"path"),p.length===0)continue}else a.length===0?p=r.cwd():(p=r.env[`=${a}`]||r.cwd(),(p===void 0||p.slice(0,2).toLowerCase()!==a.toLowerCase()&&p.charCodeAt(2)===l)&&(p=`${a}\\`));const N=p.length;let A=0,D="",P=!1;const T=p.charCodeAt(0);if(N===1)c(T)&&(A=1,P=!0);else if(c(T))if(P=!0,c(p.charCodeAt(1))){let I=2,W=I;for(;I<N&&!c(p.charCodeAt(I));)I++;if(I<N&&I!==W){const H=p.slice(W,I);for(W=I;I<N&&c(p.charCodeAt(I));)I++;if(I<N&&I!==W){for(W=I;I<N&&!c(p.charCodeAt(I));)I++;(I===N||I!==W)&&(D=`\\\\${H}\\${p.slice(W,I)}`,A=I)}}}else A=1;else C(T)&&p.charCodeAt(1)===w&&(D=p.slice(0,2),A=2,N>2&&c(p.charCodeAt(2))&&(P=!0,A=3));if(D.length>0)if(a.length>0){if(D.toLowerCase()!==a.toLowerCase())continue}else a=D;if(b){if(a.length>0)break}else if(g=`${p.slice(A)}\\${g}`,b=P,P&&a.length>0)break}return g=E(g,!b,"\\",c),b?`${a}\\${g}`:`${a}${g}`||"."},normalize(i){u(i,"path");const a=i.length;if(a===0)return".";let g=0,b,f=!1;const p=i.charCodeAt(0);if(a===1)return y(p)?"\\":i;if(c(p))if(f=!0,c(i.charCodeAt(1))){let A=2,D=A;for(;A<a&&!c(i.charCodeAt(A));)A++;if(A<a&&A!==D){const P=i.slice(D,A);for(D=A;A<a&&c(i.charCodeAt(A));)A++;if(A<a&&A!==D){for(D=A;A<a&&!c(i.charCodeAt(A));)A++;if(A===a)return`\\\\${P}\\${i.slice(D)}\\`;A!==D&&(b=`\\\\${P}\\${i.slice(D,A)}`,g=A)}}}else g=1;else C(p)&&i.charCodeAt(1)===w&&(b=i.slice(0,2),g=2,a>2&&c(i.charCodeAt(2))&&(f=!0,g=3));let N=g<a?E(i.slice(g),!f,"\\",c):"";return N.length===0&&!f&&(N="."),N.length>0&&c(i.charCodeAt(a-1))&&(N+="\\"),b===void 0?f?`\\${N}`:N:f?`${b}\\${N}`:`${b}${N}`},isAbsolute(i){u(i,"path");const a=i.length;if(a===0)return!1;const g=i.charCodeAt(0);return c(g)||a>2&&C(g)&&i.charCodeAt(1)===w&&c(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let a,g;for(let p=0;p<i.length;++p){const N=i[p];u(N,"path"),N.length>0&&(a===void 0?a=g=N:a+=`\\${N}`)}if(a===void 0)return".";let b=!0,f=0;if(typeof g=="string"&&c(g.charCodeAt(0))){++f;const p=g.length;p>1&&c(g.charCodeAt(1))&&(++f,p>2&&(c(g.charCodeAt(2))?++f:b=!1))}if(b){for(;f<a.length&&c(a.charCodeAt(f));)f++;f>=2&&(a=`\\${a.slice(f)}`)}return t.win32.normalize(a)},relative(i,a){if(u(i,"from"),u(a,"to"),i===a)return"";const g=t.win32.resolve(i),b=t.win32.resolve(a);if(g===b||(i=g.toLowerCase(),a=b.toLowerCase(),i===a))return"";let f=0;for(;f<i.length&&i.charCodeAt(f)===l;)f++;let p=i.length;for(;p-1>f&&i.charCodeAt(p-1)===l;)p--;const N=p-f;let A=0;for(;A<a.length&&a.charCodeAt(A)===l;)A++;let D=a.length;for(;D-1>A&&a.charCodeAt(D-1)===l;)D--;const P=D-A,T=N<P?N:P;let I=-1,W=0;for(;W<T;W++){const x=i.charCodeAt(f+W);if(x!==a.charCodeAt(A+W))break;x===l&&(I=W)}if(W!==T){if(I===-1)return b}else{if(P>T){if(a.charCodeAt(A+W)===l)return b.slice(A+W+1);if(W===2)return b.slice(A+W)}N>T&&(i.charCodeAt(f+W)===l?I=W:W===2&&(I=3)),I===-1&&(I=0)}let H="";for(W=f+I+1;W<=p;++W)(W===p||i.charCodeAt(W)===l)&&(H+=H.length===0?"..":"\\..");return A+=I,H.length>0?`${H}${b.slice(A,D)}`:(b.charCodeAt(A)===l&&++A,b.slice(A,D))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const a=t.win32.resolve(i);if(a.length<=2)return i;if(a.charCodeAt(0)===l){if(a.charCodeAt(1)===l){const g=a.charCodeAt(2);if(g!==e&&g!==L)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(C(a.charCodeAt(0))&&a.charCodeAt(1)===w&&a.charCodeAt(2)===l)return`\\\\?\\${a}`;return i},dirname(i){u(i,"path");const a=i.length;if(a===0)return".";let g=-1,b=0;const f=i.charCodeAt(0);if(a===1)return c(f)?i:".";if(c(f)){if(g=b=1,c(i.charCodeAt(1))){let A=2,D=A;for(;A<a&&!c(i.charCodeAt(A));)A++;if(A<a&&A!==D){for(D=A;A<a&&c(i.charCodeAt(A));)A++;if(A<a&&A!==D){for(D=A;A<a&&!c(i.charCodeAt(A));)A++;if(A===a)return i;A!==D&&(g=b=A+1)}}}}else C(f)&&i.charCodeAt(1)===w&&(g=a>2&&c(i.charCodeAt(2))?3:2,b=g);let p=-1,N=!0;for(let A=a-1;A>=b;--A)if(c(i.charCodeAt(A))){if(!N){p=A;break}}else N=!1;if(p===-1){if(g===-1)return".";p=g}return i.slice(0,p)},basename(i,a){a!==void 0&&u(a,"ext"),u(i,"path");let g=0,b=-1,f=!0,p;if(i.length>=2&&C(i.charCodeAt(0))&&i.charCodeAt(1)===w&&(g=2),a!==void 0&&a.length>0&&a.length<=i.length){if(a===i)return"";let N=a.length-1,A=-1;for(p=i.length-1;p>=g;--p){const D=i.charCodeAt(p);if(c(D)){if(!f){g=p+1;break}}else A===-1&&(f=!1,A=p+1),N>=0&&(D===a.charCodeAt(N)?--N===-1&&(b=p):(N=-1,b=A))}return g===b?b=A:b===-1&&(b=i.length),i.slice(g,b)}for(p=i.length-1;p>=g;--p)if(c(i.charCodeAt(p))){if(!f){g=p+1;break}}else b===-1&&(f=!1,b=p+1);return b===-1?"":i.slice(g,b)},extname(i){u(i,"path");let a=0,g=-1,b=0,f=-1,p=!0,N=0;i.length>=2&&i.charCodeAt(1)===w&&C(i.charCodeAt(0))&&(a=b=2);for(let A=i.length-1;A>=a;--A){const D=i.charCodeAt(A);if(c(D)){if(!p){b=A+1;break}continue}f===-1&&(p=!1,f=A+1),D===L?g===-1?g=A:N!==1&&(N=1):g!==-1&&(N=-1)}return g===-1||f===-1||N===0||N===1&&g===f-1&&g===b+1?"":i.slice(g,f)},format:S.bind(null,"\\"),parse(i){u(i,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return a;const g=i.length;let b=0,f=i.charCodeAt(0);if(g===1)return c(f)?(a.root=a.dir=i,a):(a.base=a.name=i,a);if(c(f)){if(b=1,c(i.charCodeAt(1))){let I=2,W=I;for(;I<g&&!c(i.charCodeAt(I));)I++;if(I<g&&I!==W){for(W=I;I<g&&c(i.charCodeAt(I));)I++;if(I<g&&I!==W){for(W=I;I<g&&!c(i.charCodeAt(I));)I++;I===g?b=I:I!==W&&(b=I+1)}}}}else if(C(f)&&i.charCodeAt(1)===w){if(g<=2)return a.root=a.dir=i,a;if(b=2,c(i.charCodeAt(2))){if(g===3)return a.root=a.dir=i,a;b=3}}b>0&&(a.root=i.slice(0,b));let p=-1,N=b,A=-1,D=!0,P=i.length-1,T=0;for(;P>=b;--P){if(f=i.charCodeAt(P),c(f)){if(!D){N=P+1;break}continue}A===-1&&(D=!1,A=P+1),f===L?p===-1?p=P:T!==1&&(T=1):p!==-1&&(T=-1)}return A!==-1&&(p===-1||T===0||T===1&&p===A-1&&p===N+1?a.base=a.name=i.slice(N,A):(a.name=i.slice(N,p),a.base=i.slice(N,A),a.ext=i.slice(p,A))),N>0&&N!==b?a.dir=i.slice(0,N-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null};const _=(()=>{if(m){const i=/\\/g;return()=>{const a=r.cwd().replace(i,"/");return a.slice(a.indexOf("/"))}}return()=>r.cwd()})();t.posix={resolve(...i){let a="",g=!1;for(let b=i.length-1;b>=-1&&!g;b--){const f=b>=0?i[b]:_();u(f,"path"),f.length!==0&&(a=`${f}/${a}`,g=f.charCodeAt(0)===h)}return a=E(a,!g,"/",y),g?`/${a}`:a.length>0?a:"."},normalize(i){if(u(i,"path"),i.length===0)return".";const a=i.charCodeAt(0)===h,g=i.charCodeAt(i.length-1)===h;return i=E(i,!a,"/",y),i.length===0?a?"/":g?"./":".":(g&&(i+="/"),a?`/${i}`:i)},isAbsolute(i){return u(i,"path"),i.length>0&&i.charCodeAt(0)===h},join(...i){if(i.length===0)return".";let a;for(let g=0;g<i.length;++g){const b=i[g];u(b,"path"),b.length>0&&(a===void 0?a=b:a+=`/${b}`)}return a===void 0?".":t.posix.normalize(a)},relative(i,a){if(u(i,"from"),u(a,"to"),i===a||(i=t.posix.resolve(i),a=t.posix.resolve(a),i===a))return"";const g=1,b=i.length,f=b-g,p=1,N=a.length-p,A=f<N?f:N;let D=-1,P=0;for(;P<A;P++){const I=i.charCodeAt(g+P);if(I!==a.charCodeAt(p+P))break;I===h&&(D=P)}if(P===A)if(N>A){if(a.charCodeAt(p+P)===h)return a.slice(p+P+1);if(P===0)return a.slice(p+P)}else f>A&&(i.charCodeAt(g+P)===h?D=P:P===0&&(D=0));let T="";for(P=g+D+1;P<=b;++P)(P===b||i.charCodeAt(P)===h)&&(T+=T.length===0?"..":"/..");return`${T}${a.slice(p+D)}`},toNamespacedPath(i){return i},dirname(i){if(u(i,"path"),i.length===0)return".";const a=i.charCodeAt(0)===h;let g=-1,b=!0;for(let f=i.length-1;f>=1;--f)if(i.charCodeAt(f)===h){if(!b){g=f;break}}else b=!1;return g===-1?a?"/":".":a&&g===1?"//":i.slice(0,g)},basename(i,a){a!==void 0&&u(a,"ext"),u(i,"path");let g=0,b=-1,f=!0,p;if(a!==void 0&&a.length>0&&a.length<=i.length){if(a===i)return"";let N=a.length-1,A=-1;for(p=i.length-1;p>=0;--p){const D=i.charCodeAt(p);if(D===h){if(!f){g=p+1;break}}else A===-1&&(f=!1,A=p+1),N>=0&&(D===a.charCodeAt(N)?--N===-1&&(b=p):(N=-1,b=A))}return g===b?b=A:b===-1&&(b=i.length),i.slice(g,b)}for(p=i.length-1;p>=0;--p)if(i.charCodeAt(p)===h){if(!f){g=p+1;break}}else b===-1&&(f=!1,b=p+1);return b===-1?"":i.slice(g,b)},extname(i){u(i,"path");let a=-1,g=0,b=-1,f=!0,p=0;for(let N=i.length-1;N>=0;--N){const A=i.charCodeAt(N);if(A===h){if(!f){g=N+1;break}continue}b===-1&&(f=!1,b=N+1),A===L?a===-1?a=N:p!==1&&(p=1):a!==-1&&(p=-1)}return a===-1||b===-1||p===0||p===1&&a===b-1&&a===g+1?"":i.slice(a,b)},format:S.bind(null,"/"),parse(i){u(i,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return a;const g=i.charCodeAt(0)===h;let b;g?(a.root="/",b=1):b=0;let f=-1,p=0,N=-1,A=!0,D=i.length-1,P=0;for(;D>=b;--D){const T=i.charCodeAt(D);if(T===h){if(!A){p=D+1;break}continue}N===-1&&(A=!1,N=D+1),T===L?f===-1?f=D:P!==1&&(P=1):f!==-1&&(P=-1)}if(N!==-1){const T=p===0&&g?1:p;f===-1||P===0||P===1&&f===N-1&&f===p+1?a.base=a.name=i.slice(T,N):(a.name=i.slice(T,f),a.base=i.slice(T,N),a.ext=i.slice(f,N))}return p>0?a.dir=i.slice(0,p-1):g&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=m?t.win32.normalize:t.posix.normalize,t.resolve=m?t.win32.resolve:t.posix.resolve,t.relative=m?t.win32.relative:t.posix.relative,t.dirname=m?t.win32.dirname:t.posix.dirname,t.basename=m?t.win32.basename:t.posix.basename,t.extname=m?t.win32.extname:t.posix.extname,t.sep=m?t.win32.sep:t.posix.sep}),X(Z[18],K([0,1,65,17]),function(q,t,r,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.URI=void 0;const R=/^\w[\w\d+.-]*$/,d=/^\//,v=/^\/\//;function L(g,b){if(!g.scheme&&b)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${g.authority}", path: "${g.path}", query: "${g.query}", fragment: "${g.fragment}"}`);if(g.scheme&&!R.test(g.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(g.path){if(g.authority){if(!d.test(g.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(v.test(g.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(g,b){return!g&&!b?"file":g}function l(g,b){switch(g){case"https":case"http":case"file":b?b[0]!==e&&(b=e+b):b=e;break}return b}const w="",e="/",s=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class o{static isUri(b){return b instanceof o?!0:b?typeof b.authority=="string"&&typeof b.fragment=="string"&&typeof b.path=="string"&&typeof b.query=="string"&&typeof b.scheme=="string"&&typeof b.fsPath=="string"&&typeof b.with=="function"&&typeof b.toString=="function":!1}constructor(b,f,p,N,A,D=!1){typeof b=="object"?(this.scheme=b.scheme||w,this.authority=b.authority||w,this.path=b.path||w,this.query=b.query||w,this.fragment=b.fragment||w):(this.scheme=h(b,D),this.authority=f||w,this.path=l(this.scheme,p||w),this.query=N||w,this.fragment=A||w,L(this,D))}get fsPath(){return E(this,!1)}with(b){if(!b)return this;let{scheme:f,authority:p,path:N,query:A,fragment:D}=b;return f===void 0?f=this.scheme:f===null&&(f=w),p===void 0?p=this.authority:p===null&&(p=w),N===void 0?N=this.path:N===null&&(N=w),A===void 0?A=this.query:A===null&&(A=w),D===void 0?D=this.fragment:D===null&&(D=w),f===this.scheme&&p===this.authority&&N===this.path&&A===this.query&&D===this.fragment?this:new m(f,p,N,A,D)}static parse(b,f=!1){const p=s.exec(b);return p?new m(p[2]||w,a(p[4]||w),a(p[5]||w),a(p[7]||w),a(p[9]||w),f):new m(w,w,w,w,w)}static file(b){let f=w;if(M.isWindows&&(b=b.replace(/\\/g,e)),b[0]===e&&b[1]===e){const p=b.indexOf(e,2);p===-1?(f=b.substring(2),b=e):(f=b.substring(2,p),b=b.substring(p)||e)}return new m("file",f,b,w,w)}static from(b,f){return new m(b.scheme,b.authority,b.path,b.query,b.fragment,f)}static joinPath(b,...f){if(!b.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let p;return M.isWindows&&b.scheme==="file"?p=o.file(r.win32.join(E(b,!0),...f)).path:p=r.posix.join(b.path,...f),b.with({path:p})}toString(b=!1){return S(this,b)}toJSON(){return this}static revive(b){var f,p;if(b){if(b instanceof o)return b;{const N=new m(b);return N._formatted=(f=b.external)!==null&&f!==void 0?f:null,N._fsPath=b._sep===u&&(p=b.fsPath)!==null&&p!==void 0?p:null,N}}else return b}}t.URI=o;const u=M.isWindows?1:void 0;class m extends o{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=E(this,!1)),this._fsPath}toString(b=!1){return b?S(this,!0):(this._formatted||(this._formatted=S(this,!1)),this._formatted)}toJSON(){const b={$mid:1};return this._fsPath&&(b.fsPath=this._fsPath,b._sep=u),this._formatted&&(b.external=this._formatted),this.path&&(b.path=this.path),this.scheme&&(b.scheme=this.scheme),this.authority&&(b.authority=this.authority),this.query&&(b.query=this.query),this.fragment&&(b.fragment=this.fragment),b}}const c={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function y(g,b,f){let p,N=-1;for(let A=0;A<g.length;A++){const D=g.charCodeAt(A);if(D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57||D===45||D===46||D===95||D===126||b&&D===47||f&&D===91||f&&D===93||f&&D===58)N!==-1&&(p+=encodeURIComponent(g.substring(N,A)),N=-1),p!==void 0&&(p+=g.charAt(A));else{p===void 0&&(p=g.substr(0,A));const P=c[D];P!==void 0?(N!==-1&&(p+=encodeURIComponent(g.substring(N,A)),N=-1),p+=P):N===-1&&(N=A)}}return N!==-1&&(p+=encodeURIComponent(g.substring(N))),p!==void 0?p:g}function C(g){let b;for(let f=0;f<g.length;f++){const p=g.charCodeAt(f);p===35||p===63?(b===void 0&&(b=g.substr(0,f)),b+=c[p]):b!==void 0&&(b+=g[f])}return b!==void 0?b:g}function E(g,b){let f;return g.authority&&g.path.length>1&&g.scheme==="file"?f=`//${g.authority}${g.path}`:g.path.charCodeAt(0)===47&&(g.path.charCodeAt(1)>=65&&g.path.charCodeAt(1)<=90||g.path.charCodeAt(1)>=97&&g.path.charCodeAt(1)<=122)&&g.path.charCodeAt(2)===58?b?f=g.path.substr(1):f=g.path[1].toLowerCase()+g.path.substr(2):f=g.path,M.isWindows&&(f=f.replace(/\//g,"\\")),f}t.uriToFsPath=E;function S(g,b){const f=b?C:y;let p="",{scheme:N,authority:A,path:D,query:P,fragment:T}=g;if(N&&(p+=N,p+=":"),(A||N==="file")&&(p+=e,p+=e),A){let I=A.indexOf("@");if(I!==-1){const W=A.substr(0,I);A=A.substr(I+1),I=W.lastIndexOf(":"),I===-1?p+=f(W,!1,!1):(p+=f(W.substr(0,I),!1,!1),p+=":",p+=f(W.substr(I+1),!1,!0)),p+="@"}A=A.toLowerCase(),I=A.lastIndexOf(":"),I===-1?p+=f(A,!1,!0):(p+=f(A.substr(0,I),!1,!0),p+=A.substr(I))}if(D){if(D.length>=3&&D.charCodeAt(0)===47&&D.charCodeAt(2)===58){const I=D.charCodeAt(1);I>=65&&I<=90&&(D=`/${String.fromCharCode(I+32)}:${D.substr(3)}`)}else if(D.length>=2&&D.charCodeAt(1)===58){const I=D.charCodeAt(0);I>=65&&I<=90&&(D=`${String.fromCharCode(I+32)}:${D.substr(2)}`)}p+=f(D,!0,!1)}return P&&(p+="?",p+=f(P,!1,!1)),T&&(p+="#",p+=b?T:y(T,!1,!1)),p}function _(g){try{return decodeURIComponent(g)}catch{return g.length>3?g.substr(0,3)+_(g.substr(3)):g}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(g){return g.match(i)?g.replace(i,b=>_(b)):g}}),X(Z[69],K([0,1,5,9,13,14,17,6]),function(q,t,r,M,R,d,v,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.SimpleWorkerServer=t.SimpleWorkerClient=t.logOnceWebWorkerWarning=void 0;const h="$initialize";let l=!1;function w(a){v.isWeb&&(l||(l=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(a.message))}t.logOnceWebWorkerWarning=w;class e{constructor(g,b,f,p){this.vsWorker=g,this.req=b,this.method=f,this.args=p,this.type=0}}class s{constructor(g,b,f,p){this.vsWorker=g,this.seq=b,this.res=f,this.err=p,this.type=1}}class o{constructor(g,b,f,p){this.vsWorker=g,this.req=b,this.eventName=f,this.arg=p,this.type=2}}class u{constructor(g,b,f){this.vsWorker=g,this.req=b,this.event=f,this.type=3}}class m{constructor(g,b){this.vsWorker=g,this.req=b,this.type=4}}class c{constructor(g){this._workerId=-1,this._handler=g,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(g){this._workerId=g}sendMessage(g,b){const f=String(++this._lastSentReq);return new Promise((p,N)=>{this._pendingReplies[f]={resolve:p,reject:N},this._send(new e(this._workerId,f,g,b))})}listen(g,b){let f=null;const p=new M.Emitter({onWillAddFirstListener:()=>{f=String(++this._lastSentReq),this._pendingEmitters.set(f,p),this._send(new o(this._workerId,f,g,b))},onDidRemoveLastListener:()=>{this._pendingEmitters.delete(f),this._send(new m(this._workerId,f)),f=null}});return p.event}handleMessage(g){!g||!g.vsWorker||this._workerId!==-1&&g.vsWorker!==this._workerId||this._handleMessage(g)}_handleMessage(g){switch(g.type){case 1:return this._handleReplyMessage(g);case 0:return this._handleRequestMessage(g);case 2:return this._handleSubscribeEventMessage(g);case 3:return this._handleEventMessage(g);case 4:return this._handleUnsubscribeEventMessage(g)}}_handleReplyMessage(g){if(!this._pendingReplies[g.seq]){console.warn("Got reply to unknown seq");return}const b=this._pendingReplies[g.seq];if(delete this._pendingReplies[g.seq],g.err){let f=g.err;g.err.$isError&&(f=new Error,f.name=g.err.name,f.message=g.err.message,f.stack=g.err.stack),b.reject(f);return}b.resolve(g.res)}_handleRequestMessage(g){const b=g.req;this._handler.handleMessage(g.method,g.args).then(p=>{this._send(new s(this._workerId,b,p,void 0))},p=>{p.detail instanceof Error&&(p.detail=(0,r.transformErrorForSerialization)(p.detail)),this._send(new s(this._workerId,b,void 0,(0,r.transformErrorForSerialization)(p)))})}_handleSubscribeEventMessage(g){const b=g.req,f=this._handler.handleEvent(g.eventName,g.arg)(p=>{this._send(new u(this._workerId,b,p))});this._pendingEvents.set(b,f)}_handleEventMessage(g){if(!this._pendingEmitters.has(g.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(g.req).fire(g.event)}_handleUnsubscribeEventMessage(g){if(!this._pendingEvents.has(g.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(g.req).dispose(),this._pendingEvents.delete(g.req)}_send(g){const b=[];if(g.type===0)for(let f=0;f<g.args.length;f++)g.args[f]instanceof ArrayBuffer&&b.push(g.args[f]);else g.type===1&&g.res instanceof ArrayBuffer&&b.push(g.res);this._handler.sendMessage(g,b)}}class y extends R.Disposable{constructor(g,b,f){super();let p=null;this._worker=this._register(g.create("vs/base/common/worker/simpleWorker",I=>{this._protocol.handleMessage(I)},I=>{p?.(I)})),this._protocol=new c({sendMessage:(I,W)=>{this._worker.postMessage(I,W)},handleMessage:(I,W)=>{if(typeof f[I]!="function")return Promise.reject(new Error("Missing method "+I+" on main thread host."));try{return Promise.resolve(f[I].apply(f,W))}catch(H){return Promise.reject(H)}},handleEvent:(I,W)=>{if(E(I)){const H=f[I].call(f,W);if(typeof H!="function")throw new Error(`Missing dynamic event ${I} on main thread host.`);return H}if(C(I)){const H=f[I];if(typeof H!="function")throw new Error(`Missing event ${I} on main thread host.`);return H}throw new Error(`Malformed event name ${I}`)}}),this._protocol.setWorkerId(this._worker.getId());let N=null;const A=globalThis.require;typeof A<"u"&&typeof A.getConfig=="function"?N=A.getConfig():typeof globalThis.requirejs<"u"&&(N=globalThis.requirejs.s.contexts._.config);const D=(0,d.getAllMethodNames)(f);this._onModuleLoaded=this._protocol.sendMessage(h,[this._worker.getId(),JSON.parse(JSON.stringify(N)),b,D]);const P=(I,W)=>this._request(I,W),T=(I,W)=>this._protocol.listen(I,W);this._lazyProxy=new Promise((I,W)=>{p=W,this._onModuleLoaded.then(H=>{I(S(H,P,T))},H=>{W(H),this._onError("Worker failed to load "+b,H)})})}getProxyObject(){return this._lazyProxy}_request(g,b){return new Promise((f,p)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(g,b).then(f,p)},p)})}_onError(g,b){console.error(g),console.info(b)}}t.SimpleWorkerClient=y;function C(a){return a[0]==="o"&&a[1]==="n"&&L.isUpperAsciiLetter(a.charCodeAt(2))}function E(a){return/^onDynamic/.test(a)&&L.isUpperAsciiLetter(a.charCodeAt(9))}function S(a,g,b){const f=A=>function(){const D=Array.prototype.slice.call(arguments,0);return g(A,D)},p=A=>function(D){return b(A,D)},N={};for(const A of a){if(E(A)){N[A]=p(A);continue}if(C(A)){N[A]=b(A,void 0);continue}N[A]=f(A)}return N}class _{constructor(g,b){this._requestHandlerFactory=b,this._requestHandler=null,this._protocol=new c({sendMessage:(f,p)=>{g(f,p)},handleMessage:(f,p)=>this._handleMessage(f,p),handleEvent:(f,p)=>this._handleEvent(f,p)})}onmessage(g){this._protocol.handleMessage(g)}_handleMessage(g,b){if(g===h)return this.initialize(b[0],b[1],b[2],b[3]);if(!this._requestHandler||typeof this._requestHandler[g]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+g));try{return Promise.resolve(this._requestHandler[g].apply(this._requestHandler,b))}catch(f){return Promise.reject(f)}}_handleEvent(g,b){if(!this._requestHandler)throw new Error("Missing requestHandler");if(E(g)){const f=this._requestHandler[g].call(this._requestHandler,b);if(typeof f!="function")throw new Error(`Missing dynamic event ${g} on request handler.`);return f}if(C(g)){const f=this._requestHandler[g];if(typeof f!="function")throw new Error(`Missing event ${g} on request handler.`);return f}throw new Error(`Malformed event name ${g}`)}initialize(g,b,f,p){this._protocol.setWorkerId(g);const D=S(p,(P,T)=>this._protocol.sendMessage(P,T),(P,T)=>this._protocol.listen(P,T));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(D),Promise.resolve((0,d.getAllMethodNames)(this._requestHandler))):(b&&(typeof b.baseUrl<"u"&&delete b.baseUrl,typeof b.paths<"u"&&typeof b.paths.vs<"u"&&delete b.paths.vs,typeof b.trustedTypesPolicy<"u"&&delete b.trustedTypesPolicy,b.catchError=!0,globalThis.require.config(b)),new Promise((P,T)=>{(globalThis.require||q)([f],W=>{if(this._requestHandler=W.create(D),!this._requestHandler){T(new Error("No RequestHandler!"));return}P((0,d.getAllMethodNames)(this._requestHandler))},T)}))}}t.SimpleWorkerServer=_;function i(a){return new _(a,null)}t.create=i}),X(Z[66],K([19,63]),function(q,t){return q.create("vs/editor/common/languages",t)}),X(Z[67],K([0,1,42,18,2,61,66]),function(q,t,r,M,R,d,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InlineEditTriggerKind=t.TokenizationRegistry=t.LazyTokenizationSupport=t.InlayHintKind=t.Command=t.NewSymbolNameTag=t.FoldingRangeKind=t.TextEdit=t.SymbolKinds=t.getAriaLabelForSymbol=t.symbolKindNames=t.isLocationLink=t.DocumentHighlightKind=t.SignatureHelpTriggerKind=t.SelectedSuggestionInfo=t.InlineCompletionTriggerKind=t.CompletionItemKinds=t.EncodedTokenizationResult=t.TokenizationResult=t.Token=void 0;class L{constructor(f,p,N){this.offset=f,this.type=p,this.language=N,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}t.Token=L;class h{constructor(f,p){this.tokens=f,this.endState=p,this._tokenizationResultBrand=void 0}}t.TokenizationResult=h;class l{constructor(f,p){this.tokens=f,this.endState=p,this._encodedTokenizationResultBrand=void 0}}t.EncodedTokenizationResult=l;var w;(function(b){const f=new Map;f.set(0,r.Codicon.symbolMethod),f.set(1,r.Codicon.symbolFunction),f.set(2,r.Codicon.symbolConstructor),f.set(3,r.Codicon.symbolField),f.set(4,r.Codicon.symbolVariable),f.set(5,r.Codicon.symbolClass),f.set(6,r.Codicon.symbolStruct),f.set(7,r.Codicon.symbolInterface),f.set(8,r.Codicon.symbolModule),f.set(9,r.Codicon.symbolProperty),f.set(10,r.Codicon.symbolEvent),f.set(11,r.Codicon.symbolOperator),f.set(12,r.Codicon.symbolUnit),f.set(13,r.Codicon.symbolValue),f.set(15,r.Codicon.symbolEnum),f.set(14,r.Codicon.symbolConstant),f.set(15,r.Codicon.symbolEnum),f.set(16,r.Codicon.symbolEnumMember),f.set(17,r.Codicon.symbolKeyword),f.set(27,r.Codicon.symbolSnippet),f.set(18,r.Codicon.symbolText),f.set(19,r.Codicon.symbolColor),f.set(20,r.Codicon.symbolFile),f.set(21,r.Codicon.symbolReference),f.set(22,r.Codicon.symbolCustomColor),f.set(23,r.Codicon.symbolFolder),f.set(24,r.Codicon.symbolTypeParameter),f.set(25,r.Codicon.account),f.set(26,r.Codicon.issues);function p(D){let P=f.get(D);return P||(console.info("No codicon found for CompletionItemKind "+D),P=r.Codicon.symbolProperty),P}b.toIcon=p;const N=new Map;N.set("method",0),N.set("function",1),N.set("constructor",2),N.set("field",3),N.set("variable",4),N.set("class",5),N.set("struct",6),N.set("interface",7),N.set("module",8),N.set("property",9),N.set("event",10),N.set("operator",11),N.set("unit",12),N.set("value",13),N.set("constant",14),N.set("enum",15),N.set("enum-member",16),N.set("enumMember",16),N.set("keyword",17),N.set("snippet",27),N.set("text",18),N.set("color",19),N.set("file",20),N.set("reference",21),N.set("customcolor",22),N.set("folder",23),N.set("type-parameter",24),N.set("typeParameter",24),N.set("account",25),N.set("issue",26);function A(D,P){let T=N.get(D);return typeof T>"u"&&!P&&(T=9),T}b.fromString=A})(w||(t.CompletionItemKinds=w={}));var e;(function(b){b[b.Automatic=0]="Automatic",b[b.Explicit=1]="Explicit"})(e||(t.InlineCompletionTriggerKind=e={}));class s{constructor(f,p,N,A){this.range=f,this.text=p,this.completionKind=N,this.isSnippetText=A}equals(f){return R.Range.lift(this.range).equalsRange(f.range)&&this.text===f.text&&this.completionKind===f.completionKind&&this.isSnippetText===f.isSnippetText}}t.SelectedSuggestionInfo=s;var o;(function(b){b[b.Invoke=1]="Invoke",b[b.TriggerCharacter=2]="TriggerCharacter",b[b.ContentChange=3]="ContentChange"})(o||(t.SignatureHelpTriggerKind=o={}));var u;(function(b){b[b.Text=0]="Text",b[b.Read=1]="Read",b[b.Write=2]="Write"})(u||(t.DocumentHighlightKind=u={}));function m(b){return b&&M.URI.isUri(b.uri)&&R.Range.isIRange(b.range)&&(R.Range.isIRange(b.originSelectionRange)||R.Range.isIRange(b.targetSelectionRange))}t.isLocationLink=m,t.symbolKindNames={17:(0,v.localize)(0,null),16:(0,v.localize)(1,null),4:(0,v.localize)(2,null),13:(0,v.localize)(3,null),8:(0,v.localize)(4,null),9:(0,v.localize)(5,null),21:(0,v.localize)(6,null),23:(0,v.localize)(7,null),7:(0,v.localize)(8,null),0:(0,v.localize)(9,null),11:(0,v.localize)(10,null),10:(0,v.localize)(11,null),19:(0,v.localize)(12,null),5:(0,v.localize)(13,null),1:(0,v.localize)(14,null),2:(0,v.localize)(15,null),20:(0,v.localize)(16,null),15:(0,v.localize)(17,null),18:(0,v.localize)(18,null),24:(0,v.localize)(19,null),3:(0,v.localize)(20,null),6:(0,v.localize)(21,null),14:(0,v.localize)(22,null),22:(0,v.localize)(23,null),25:(0,v.localize)(24,null),12:(0,v.localize)(25,null)};function c(b,f){return(0,v.localize)(26,null,b,t.symbolKindNames[f])}t.getAriaLabelForSymbol=c;var y;(function(b){const f=new Map;f.set(0,r.Codicon.symbolFile),f.set(1,r.Codicon.symbolModule),f.set(2,r.Codicon.symbolNamespace),f.set(3,r.Codicon.symbolPackage),f.set(4,r.Codicon.symbolClass),f.set(5,r.Codicon.symbolMethod),f.set(6,r.Codicon.symbolProperty),f.set(7,r.Codicon.symbolField),f.set(8,r.Codicon.symbolConstructor),f.set(9,r.Codicon.symbolEnum),f.set(10,r.Codicon.symbolInterface),f.set(11,r.Codicon.symbolFunction),f.set(12,r.Codicon.symbolVariable),f.set(13,r.Codicon.symbolConstant),f.set(14,r.Codicon.symbolString),f.set(15,r.Codicon.symbolNumber),f.set(16,r.Codicon.symbolBoolean),f.set(17,r.Codicon.symbolArray),f.set(18,r.Codicon.symbolObject),f.set(19,r.Codicon.symbolKey),f.set(20,r.Codicon.symbolNull),f.set(21,r.Codicon.symbolEnumMember),f.set(22,r.Codicon.symbolStruct),f.set(23,r.Codicon.symbolEvent),f.set(24,r.Codicon.symbolOperator),f.set(25,r.Codicon.symbolTypeParameter);function p(N){let A=f.get(N);return A||(console.info("No codicon found for SymbolKind "+N),A=r.Codicon.symbolProperty),A}b.toIcon=p})(y||(t.SymbolKinds=y={}));class C{}t.TextEdit=C;class E{static fromValue(f){switch(f){case"comment":return E.Comment;case"imports":return E.Imports;case"region":return E.Region}return new E(f)}constructor(f){this.value=f}}t.FoldingRangeKind=E,E.Comment=new E("comment"),E.Imports=new E("imports"),E.Region=new E("region");var S;(function(b){b[b.AIGenerated=1]="AIGenerated"})(S||(t.NewSymbolNameTag=S={}));var _;(function(b){function f(p){return!p||typeof p!="object"?!1:typeof p.id=="string"&&typeof p.title=="string"}b.is=f})(_||(t.Command=_={}));var i;(function(b){b[b.Type=1]="Type",b[b.Parameter=2]="Parameter"})(i||(t.InlayHintKind=i={}));class a{constructor(f){this.createSupport=f,this._tokenizationSupport=null}dispose(){this._tokenizationSupport&&this._tokenizationSupport.then(f=>{f&&f.dispose()})}get tokenizationSupport(){return this._tokenizationSupport||(this._tokenizationSupport=this.createSupport()),this._tokenizationSupport}}t.LazyTokenizationSupport=a,t.TokenizationRegistry=new d.TokenizationRegistry;var g;(function(b){b[b.Invoke=0]="Invoke",b[b.Automatic=1]="Automatic"})(g||(t.InlineEditTriggerKind=g={}))}),X(Z[68],K([0,1,39,9,36,18,4,2,43,67,60]),function(q,t,r,M,R,d,v,L,h,l,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createMonacoBaseAPI=t.KeyMod=void 0;class e{static chord(u,m){return(0,R.KeyChord)(u,m)}}t.KeyMod=e,e.CtrlCmd=2048,e.Shift=1024,e.Alt=512,e.WinCtrl=256;function s(){return{editor:void 0,languages:void 0,CancellationTokenSource:r.CancellationTokenSource,Emitter:M.Emitter,KeyCode:w.KeyCode,KeyMod:e,Position:v.Position,Range:L.Range,Selection:h.Selection,SelectionDirection:w.SelectionDirection,MarkerSeverity:w.MarkerSeverity,MarkerTag:w.MarkerTag,Uri:d.URI,Token:l.Token}}t.createMonacoBaseAPI=s}),X(Z[70],K([0,1,24,18,4,2,57,29,53,54,68,23,59,51,14,52]),function(q,t,r,M,R,d,v,L,h,l,w,e,s,o,u,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.EditorSimpleWorker=void 0;class c extends v.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}findMatches(S){const _=[];for(let i=0;i<this._lines.length;i++){const a=this._lines[i],g=this.offsetAt(new R.Position(i+1,1)),b=a.matchAll(S);for(const f of b)(f.index||f.index===0)&&(f.index=f.index+g),_.push(f)}return _}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(S){return this._lines[S-1]}getWordAtPosition(S,_){const i=(0,L.getWordAtText)(S.column,(0,L.ensureValidWordDefinition)(_),this._lines[S.lineNumber-1],0);return i?new d.Range(S.lineNumber,i.startColumn,S.lineNumber,i.endColumn):null}words(S){const _=this._lines,i=this._wordenize.bind(this);let a=0,g="",b=0,f=[];return{*[Symbol.iterator](){for(;;)if(b<f.length){const p=g.substring(f[b].start,f[b].end);b+=1,yield p}else if(a<_.length)g=_[a],f=i(g,S),b=0,a+=1;else break}}}getLineWords(S,_){const i=this._lines[S-1],a=this._wordenize(i,_),g=[];for(const b of a)g.push({word:i.substring(b.start,b.end),startColumn:b.start+1,endColumn:b.end+1});return g}_wordenize(S,_){const i=[];let a;for(_.lastIndex=0;(a=_.exec(S))&&a[0].length!==0;)i.push({start:a.index,end:a.index+a[0].length});return i}getValueInRange(S){if(S=this._validateRange(S),S.startLineNumber===S.endLineNumber)return this._lines[S.startLineNumber-1].substring(S.startColumn-1,S.endColumn-1);const _=this._eol,i=S.startLineNumber-1,a=S.endLineNumber-1,g=[];g.push(this._lines[i].substring(S.startColumn-1));for(let b=i+1;b<a;b++)g.push(this._lines[b]);return g.push(this._lines[a].substring(0,S.endColumn-1)),g.join(_)}offsetAt(S){return S=this._validatePosition(S),this._ensureLineStarts(),this._lineStarts.getPrefixSum(S.lineNumber-2)+(S.column-1)}positionAt(S){S=Math.floor(S),S=Math.max(0,S),this._ensureLineStarts();const _=this._lineStarts.getIndexOf(S),i=this._lines[_.index].length;return{lineNumber:1+_.index,column:1+Math.min(_.remainder,i)}}_validateRange(S){const _=this._validatePosition({lineNumber:S.startLineNumber,column:S.startColumn}),i=this._validatePosition({lineNumber:S.endLineNumber,column:S.endColumn});return _.lineNumber!==S.startLineNumber||_.column!==S.startColumn||i.lineNumber!==S.endLineNumber||i.column!==S.endColumn?{startLineNumber:_.lineNumber,startColumn:_.column,endLineNumber:i.lineNumber,endColumn:i.column}:S}_validatePosition(S){if(!R.Position.isIPosition(S))throw new Error("bad position");let{lineNumber:_,column:i}=S,a=!1;if(_<1)_=1,i=1,a=!0;else if(_>this._lines.length)_=this._lines.length,i=this._lines[_-1].length+1,a=!0;else{const g=this._lines[_-1].length+1;i<1?(i=1,a=!0):i>g&&(i=g,a=!0)}return a?{lineNumber:_,column:i}:S}}class y{constructor(S,_){this._host=S,this._models=Object.create(null),this._foreignModuleFactory=_,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(S){return this._models[S]}_getModels(){const S=[];return Object.keys(this._models).forEach(_=>S.push(this._models[_])),S}acceptNewModel(S){this._models[S.url]=new c(M.URI.parse(S.url),S.lines,S.EOL,S.versionId)}acceptModelChanged(S,_){if(!this._models[S])return;this._models[S].onEvents(_)}acceptRemovedModel(S){this._models[S]&&delete this._models[S]}async computeUnicodeHighlights(S,_,i){const a=this._getModel(S);return a?s.UnicodeTextModelHighlighter.computeUnicodeHighlights(a,_,i):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async computeDiff(S,_,i,a){const g=this._getModel(S),b=this._getModel(_);return!g||!b?null:y.computeDiff(g,b,i,a)}static computeDiff(S,_,i,a){const g=a==="advanced"?o.linesDiffComputers.getDefault():o.linesDiffComputers.getLegacy(),b=S.getLinesContent(),f=_.getLinesContent(),p=g.computeDiff(b,f,i),N=p.changes.length>0?!1:this._modelsAreIdentical(S,_);function A(D){return D.map(P=>{var T;return[P.original.startLineNumber,P.original.endLineNumberExclusive,P.modified.startLineNumber,P.modified.endLineNumberExclusive,(T=P.innerChanges)===null||T===void 0?void 0:T.map(I=>[I.originalRange.startLineNumber,I.originalRange.startColumn,I.originalRange.endLineNumber,I.originalRange.endColumn,I.modifiedRange.startLineNumber,I.modifiedRange.startColumn,I.modifiedRange.endLineNumber,I.modifiedRange.endColumn])]})}return{identical:N,quitEarly:p.hitTimeout,changes:A(p.changes),moves:p.moves.map(D=>[D.lineRangeMapping.original.startLineNumber,D.lineRangeMapping.original.endLineNumberExclusive,D.lineRangeMapping.modified.startLineNumber,D.lineRangeMapping.modified.endLineNumberExclusive,A(D.changes)])}}static _modelsAreIdentical(S,_){const i=S.getLineCount(),a=_.getLineCount();if(i!==a)return!1;for(let g=1;g<=i;g++){const b=S.getLineContent(g),f=_.getLineContent(g);if(b!==f)return!1}return!0}async computeMoreMinimalEdits(S,_,i){const a=this._getModel(S);if(!a)return _;const g=[];let b;_=_.slice(0).sort((p,N)=>{if(p.range&&N.range)return d.Range.compareRangesUsingStarts(p.range,N.range);const A=p.range?0:1,D=N.range?0:1;return A-D});let f=0;for(let p=1;p<_.length;p++)d.Range.getEndPosition(_[f].range).equals(d.Range.getStartPosition(_[p].range))?(_[f].range=d.Range.fromPositions(d.Range.getStartPosition(_[f].range),d.Range.getEndPosition(_[p].range)),_[f].text+=_[p].text):(f++,_[f]=_[p]);_.length=f+1;for(let{range:p,text:N,eol:A}of _){if(typeof A=="number"&&(b=A),d.Range.isEmpty(p)&&!N)continue;const D=a.getValueInRange(p);if(N=N.replace(/\r\n|\n|\r/g,a.eol),D===N)continue;if(Math.max(N.length,D.length)>y._diffLimit){g.push({range:p,text:N});continue}const P=(0,r.stringDiff)(D,N,i),T=a.offsetAt(d.Range.lift(p).getStartPosition());for(const I of P){const W=a.positionAt(T+I.originalStart),H=a.positionAt(T+I.originalStart+I.originalLength),x={text:N.substr(I.modifiedStart,I.modifiedLength),range:{startLineNumber:W.lineNumber,startColumn:W.column,endLineNumber:H.lineNumber,endColumn:H.column}};a.getValueInRange(x.range)!==x.text&&g.push(x)}}return typeof b=="number"&&g.push({eol:b,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),g}async computeLinks(S){const _=this._getModel(S);return _?(0,h.computeLinks)(_):null}async computeDefaultDocumentColors(S){const _=this._getModel(S);return _?(0,m.computeDefaultDocumentColors)(_):null}async textualSuggest(S,_,i,a){const g=new e.StopWatch,b=new RegExp(i,a),f=new Set;e:for(const p of S){const N=this._getModel(p);if(N){for(const A of N.words(b))if(!(A===_||!isNaN(Number(A)))&&(f.add(A),f.size>y._suggestionsLimit))break e}}return{words:Array.from(f),duration:g.elapsed()}}async computeWordRanges(S,_,i,a){const g=this._getModel(S);if(!g)return Object.create(null);const b=new RegExp(i,a),f=Object.create(null);for(let p=_.startLineNumber;p<_.endLineNumber;p++){const N=g.getLineWords(p,b);for(const A of N){if(!isNaN(Number(A.word)))continue;let D=f[A.word];D||(D=[],f[A.word]=D),D.push({startLineNumber:p,startColumn:A.startColumn,endLineNumber:p,endColumn:A.endColumn})}}return f}async navigateValueSet(S,_,i,a,g){const b=this._getModel(S);if(!b)return null;const f=new RegExp(a,g);_.startColumn===_.endColumn&&(_={startLineNumber:_.startLineNumber,startColumn:_.startColumn,endLineNumber:_.endLineNumber,endColumn:_.endColumn+1});const p=b.getValueInRange(_),N=b.getWordAtPosition({lineNumber:_.startLineNumber,column:_.startColumn},f);if(!N)return null;const A=b.getValueInRange(N);return l.BasicInplaceReplace.INSTANCE.navigateValueSet(_,p,N,A,i)}loadForeignModule(S,_,i){const a=(f,p)=>this._host.fhr(f,p),b={host:(0,u.createProxyObject)(i,a),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(b,_),Promise.resolve((0,u.getAllMethodNames)(this._foreignModule))):new Promise((f,p)=>{q([S],N=>{this._foreignModule=N.create(b,_),f((0,u.getAllMethodNames)(this._foreignModule))},p)})}fmr(S,_){if(!this._foreignModule||typeof this._foreignModule[S]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+S));try{return Promise.resolve(this._foreignModule[S].apply(this._foreignModule,_))}catch(i){return Promise.reject(i)}}}t.EditorSimpleWorker=y,y._diffLimit=1e5,y._suggestionsLimit=1e4;function C(E){return new y(E,null)}t.create=C,typeof importScripts=="function"&&(globalThis.monaco=(0,w.createMonacoBaseAPI)())})}).call(this);

//# sourceMappingURL=../../../../min-maps/vs/base/worker/workerMain.js.map